      SUBROUTINE UNPK_GRIB2(KFILDO,A,IA,ND2X3,IDAT,NIDAT,RDAT,NRDAT,
     1                      IS0,NS0,IS1,NS1,IS2,NS2,IS3,NS3,IS4,NS4,
     2                      IS5,NS5,IS6,NS6,IS7,NS7,IB,IBITMAP,IPACK,
     3                      ND5,XMISSP,XMISSS,NEW,ICLEAN,L3264B,
     4                      IENDPK,JER,NDJER,KJER)
C
C        
C        MARCH    1999   PEACHEY  ORIGINAL CODING
C        JANUARY  2001   GLAHN    COMMENTS; ELIMINATED  "EXISTS"
C                                 IN MOST CALLING ARGUMENTS;
C                                 ELIMINATED UNUSED ARRAY
C                                 AS2( ) AND VARIABLE "GRIB".
C        FEBRUARY 2001   LAWRENCE GSC/MDL   UPDATED THE PROLOGUE TO
C                                 MAKE IT MORE ACCURATE
C                                 AND INFORMATIVE.
C        NOVEMBER 2001   GLAHN    ADDED TRACE WHEN SECTION FORMAT
C                                 CAN NOT BE RECOGNIZED
C        JANUARY  2002   GLAHN    CHANGED IA(K)=INT(A(K)) TO NINT(A(K))
C        FEBRUARY 2002   GLAHN    MODIFIED RETURN FROM UNPK_SECT2
C
C        PURPOSE
C           THIS UTILITY DECODES A MESSAGE THAT WAS ORIGINALLY ENCODED
C           ACCORDING THE RULES AND STRUCTURE PUT FORTH IN THE GRIB
C           VERSION 2 (GRIB2) DOCUMENTATION.  GRIB2 IS A DATA
C           REPRESENTATION FORM FOR GENERAL REGULARLY DISTRIBUTED
C           INFORMATION IN BINARY.  IT PROVIDES A MEANS OF COMPRESSING
C           DATA SO AS TO MAKE ITS TRANSMISSION MORE EFFICIENT. IT IS 
C           RECOMMENDED THAT THE USER OF THIS ROUTINE REVIEW THE 
C           EXTERNAL DOCUMENTATION THAT EXPLAINS WHAT GRIB2 IS AND
C           HOW TO USE IT.  
C
C           THERE ARE EIGHT MANDATORY AND ONE OPTIONAL SECTIONS
C           CONTAINED WITHIN A GRIB2 MESSAGE.  THESE SECTIONS ARE
C
C              SECTION 0 - THE INDICATOR SECTION
C              SECTION 1 - THE IDENTIFICATION SECTION
C              SECTION 2 - THE LOCAL USE SECTION (OPTIONAL)
C              SECTION 3 - THE GRID DEFINITION SECTION
C              SECTION 4 - THE PRODUCT DEFINITION SECTION
C              SECTION 5 - THE DATA REPRESENTATION SECTION
C              SECTION 6 - THE BIT-MAP SECTION
C              SECTION 7 - THE DATA SECTION
C              SECTION 8 - THE END SECTION
C
C           SECTION 0, THE INDICATOR SECTION, CONTAINS GRIB2
C           DISCIPLINE, EDITION, AND MESSAGE LENGTH INFORMATION. 
C
C           SECTION 1, THE IDENTIFICATION SECTION, CONTAINS DATA 
C           THAT DESCRIBES CHARACTERISTICS THAT APPLY TO ALL OF THE
C           PROCESSED DATA IN THE GRIB2 MESSAGE.
C
C           SECTION 2, THE LOCAL USE SECTION, CONTAINS SUPPLEMENTAL 
C           INFORMATION FOR LOCAL USE BY THE ORIGINATING CENTERS.
C           THIS SECTION IS OPTIONAL; IT DOES NOT NEED TO BE INCLUDED
C           IN THE GRIB2 MESSAGE.
C
C           SECTION 3, THE GRID DEFINITION SECTION, DESCRIBES THE 
C           GEOMETRY OF THE VALUES WITHIN A PLANE DESCRIBED BY 
C           TWO FIXED COORDINATES.
C
C           SECTION 4, THE PRODUCT DEFINITION SECTION, PROVIDES A
C           DESCRIPTION OF THE DATA PACKED WITHIN SECTION 7. 
C
C           SECTION 5, THE DATA REPRESENTATION SECTION, DESCRIBES
C           WHAT METHOD IS USED TO COMPRESS THE DATA IN SECTION 7. 
C     
C           SECTION 6, THE BIT-MAP SECTION, CONTAINS A BIT-MAP WHICH
C           INDICATES THE PRESENCE OR ABSENCE OF DATA AT EACH GRID
C           POINT.  A BIT-MAP IS ONLY APPLICABLE TO THE SIMPLE 
C           AND COMPLEX PACKING METHODS.  A BIT-MAP DOES NOT
C           APPLY TO COMPLEX PACKING WITH SPATIAL DIFFERENCES.
C
C           SECTION 7, THE DATA SECTION, CONTAINS THE PACKED DATA
C           VALUES.
C
C           SECTION 8, THE END SECTION, CONTAINS THE STRING "7777"
C           INDICATING THE END OF THE GRIB2 MESSAGE.
C     
C           SECTIONS 3, 4, 5, AND 7 PROVIDE A VARIETY OF TEMPLATES 
C           THAT DESCRIBE AND DEFINE THE GRIDDED PRODUCT 
C           CONTAINED WITHIN THE GRIB2 MESSAGE.  THIS GRIB2 UNPACKER 
C           DOES NOT SUPPORT ALL OF THE TEMPLATES PROVIDED IN GRIB2.
C           THE MORE COMMONLY USED TEMPLATES ARE SUPPORTED, AND 
C           THIS SOFTWARE CAN BE EASILY EXTENDED IN THE FUTURE TO 
C           ACCOMMODATE ADDITIONAL TEMPLATES AS THE NEED ARISES. 
C
C           THE SECTION 3 GRID DEFINITION TEMPLATES CURRENTLY 
C           RECOGNIZED BY THIS UNPACKER ARE:
C              TEMPLATE 3.0   EQUIDISTANT CYLINDRICAL LATITUDE/
C                             LONGITUDE
C              TEMPLATE 3.10  MERCATOR
C              TEMPLATE 3.20  POLAR STEREOGRAPHIC
C              TEMPLATE 3.30  LAMBERT
C              TEMPLATE 3.90  ORTHOGRAPHIC SPACE VIEW
C              TEMPLATE 3.110 EQUATORIAL AZIMUTHAL EQUIDISTANT
C              TEMPLATE 3.120 AZIMUTH-RANGE (RADAR)
C
C           THE SECTION 4 PRODUCT DEFINITION TEMPLATES CURRENTLY
C           RECOGNIZED BY THIS UNPACKER ARE:
C              TEMPLATE 4.0  ANALYSIS OR FORECAST AT A LEVEL AND POINT
C              TEMPLATE 4.1  INDIVIDUAL ENSEMBLE
C              TEMPLATE 4.2  DERIVED FORECAST BASED ON ENSEMBLES
C              TEMPLATE 4.8  AVERAGE, ACCUMULATION, EXTREMES
C              TEMPLATE 4.20 RADAR
C              TEMPLATE 4.30 SATELLITE
C
C           THE SECTION 5 DATA REPRESENTATION TEMPLATES CURRENTLY 
C           RECOGNIZED BY THIS UNPACKER ARE:
C              TEMPLATE 5.0  SIMPLE PACKING
C              TEMPLATE 5.2  COMPLEX PACKING
C              TEMPLATE 5.3  COMPLEX PACKING AND SPATIAL DIFFERENCING 
C
C           THE SECTION 7 DATA TEMPLATES CURRENTLY RECOGNIZED BY THIS
C           UNPACKER ARE:
C              TEMPLATE 7.0  SIMPLE PACKING
C              TEMPLATE 7.2  COMPLEX PACKING
C              TEMPLATE 7.3  COMPLEX PACKING AND SPATIAL DIFFERENCING
C
C           THE REPRESENTATION OF MISSING VALUES IN THE DATA FIELD
C           PLAYS AN INTEGRAL ROLE IN HOW THE DATA ARE RETURNED TO
C           THE CALLER OF THIS ROUTINE.  THE PROCESSING OF PRIMARY
C           VALUES IS SUPPORTED WHEN DECODING A GRIB2 MESSAGE 
C           CREATED USING THE SIMPLE PACKING METHOD.  THE USER OF
C           THIS ROUTINE IS GIVEN THE OPTION TO HAVE THE DATA
C           FIELD RETURNED TO HIM WITH THE MISSING VALUES EMBEDDED
C           WITHIN IT OR TO HAVE THE DATA FIELD RETURNED TO HIM
C           WITHOUT THE MISSING VALUES IN IT.  IN THE LATTER CASE,
C           THIS ROUTINE WILL GENERATE A BIT-MAP INDICATING THE 
C           LOCATIONS OF THE MISSING VALUES IN THE DATA FIELD WITH
C           RESPECT TO THE VALID DATA POINTS.
C
C           THE EXISTENCE OF PRIMARY AND SECONDARY MISSING VALUES IS
C           PROVIDED FOR WHEN DECODING A GRIB2 MESSAGE CREATED USING
C           THE COMPLEX PACKING METHOD.  AS WITH THE SIMPLE PACKING
C           METHOD, INSTEAD OF RETURNING THE PRIMARY MISSING VALUES
C           EMBEDDED WITHIN THE DATA FIELD, A BIT-MAP MAY BE USED TO
C           INDICATE THE POSITIONS OF THE PRIMARY MISSING VALUES IN
C           RELATION TO THE VALID DATA POINTS.  HOWEVER, THE SECONDARY
C           MISSING VALUES, IF THEY EXIST, ARE ALWAYS RETURNED TO THE 
C           CALLER OF THIS ROUTINE EMBEDDED WITHIN THE DATA FIELD.
C
C           A GRIB2 MESSAGE MAY CONTAIN ONE OR MORE GRIDDED DATA
C           FIELDS.  WHEN UNPACKING MULTIPLE GRIDS FROM A GRIB2 MESSAGE
C           THE FIRST GRID MUST PROVIDE INFORMATION FOR SECTIONS 0 
C           THROUGH 7 (WITH, OF COURSE, SECTION 2 BEING OPTIONAL).
C           SUBSEQUENT GRIDS SHOULD NOT PROVIDE DATA FOR SECTIONS
C           0 AND 1.  THEY NEED ONLY PROVIDE DATA FOR SECTIONS 
C           2, 3, 4, 5, 6, 7, OR 3, 4, 5, 6, 7, OR 4, 5, 6, 7.
C           THE FINAL DATA GRID PACKED INTO THE GRIB2 MESSAGE 
C           MUST BE FOLLOWED BY A SECTION 8 INDICATING THE END
C           OF THE GRIB2 MESSAGE.  THIS ROUTINE MUST BE CALLED
C           ONCE FOR EACH GRID PACKED IN THE GRIB2 MESSAGE. THE
C           NEW AND IENDPK CALLING ARGUMENTS (SEE BELOW) ARE USED
C           WHEN UNPACKING GRIB2 MESSAGES CONTAINING MULTIPLE 
C           DATA GRIDS.
C
C           THE UNPACKED DATA GRID IS RETURNED IN ARRAY A( )
C           IF THE ORIGINAL PACKED FIELD CONSISTED OF FLOATING
C           POINT VALUES OR IN ARRAY IA( ) IF THE ORIGINAL PACKED
C           DATA FIELD CONTAINED INTEGER VALUES.  THE UNPACKED DATA
C           CORRESPONDING TO SECTIONS 0, 1 ,2 , 3, 4, 5, 6, AND 7 OF
C           THE GRIB2 MESSAGE IS RETURNED IN ARRAYS IS0( ), IS1( ),
C           IS2( ), IS3( ), IS4( ), IS5( ), IS6( ), AND IS7( ), 
C           RESPECTIVELY.  IF A BIT-MAP WAS PACKED INTO THE GRIB2
C           MESSAGE, THEN THE BIT-MAP WILL BE UNPACKED RETURNED IN
C           ARRAY IB( ).  EACH ELEMENT OF IB( ) WILL CORRESPOND TO
C           ONE DATA POINT IN THE DATA FIELD.  A VALUE OF "0" IN THE
C           BIT-MAP INDICATES A MISSING VALUE AT THE CORRESPONDING
C           POINT IN THE DATA GRID.  A VALUE OF "1" IN THE BIT-MAP 
C           INDICATES A VALID VALUE AT THE CORRESPONDING POINT IN 
C           THE DATA GRID.  AN IMPORTANT POINT TO REMEMBER IS THAT
C           WHEN A BIT-MAP IS RETURNED FROM THIS ROUTINE THE PRIMARY
C           MISSING VALUES WILL NOT BE INCLUDED IN THE DATA FIELD 
C           (UNLESS THE CALLER HAS SPECIFIED THAT THEY SHOULD BE BY
C           SETTING THE ICLEAN FLAG (SEE BELOW) TO "0".  THE CALLER 
C           OF THIS ROUTINE MUST USE THE BIT-MAP TO DETERMINE THE 
C           LOCATIONS OF MISSING DATA VALUES IN THE DATA FIELD. 
C
C           THIS GRIB2 DECODER CANNOT BE USED TO DECODE A MESSAGE
C           THAT WAS PACKED FOLLOWING THE ORIGINAL GRIB (GRIB 1)
C           FORMAT.  GRIB2 IS NOT BACKWARD COMPATIBLE WITH THE
C           ORIGINAL VERSION OF GRIB.
C
C           THERE ARE A NUMBER OF DIFFERENT ERROR CONDITIONS THAT
C           THAT CAN BE GENERATED WHILE UNPACKING A GRIB2 MESSAGE.
C           ERROR TRACKING IS HANDLED BY THE JER( , ) ARRAY (SEE BELOW).
C           EACH ROW OF THIS ARRAY CAN CONTAIN AN ERROR CODE FOLLOWED
C           BY ITS SEVERITY LEVEL.  THE SEVERITY LEVELS ARE
C           "0" FOR "OK", "1" FOR "WARNING", AND "2" FOR "FATAL". 
C           THE UNPACKER WILL IMMEDIATELY ABORT EXECUTION WHEN 
C           IT ENCOUNTERS A FATAL ERROR.  HOWEVER, EXECUTION IS NOT
C           IMPEDED BY A STATUS CODE OF "OK" OR "WARNING".  SEE THE
C           ARGUMENT LIST BELOW FOR A COMPLETE LIST OF THE ERROR 
C           CODES THAT CAN BE RETURNED BY THIS ROUTINE.
C
C        DATA SET USE
C           KFILDO - UNIT NUMBER FOR OUTPUT (PRINT) FILE.  (OUTPUT)
C
C        VARIABLES
C              KFILDO = UNIT NUMBER OF THE OUTPUT (PRINT) FILE.
C                       (INPUT)
C              A(IXY) = IF FLOATING POINT GRIDDED DATA ARE PACKED IN 
C                       THE GRIB2 MESSAGE, THEN THE UNPACKED DATA ARE
C                       RETURNED IN THIS ARRAY.  TO DETERMINE WHETHER 
C                       A FLOATING POINT DATA FIELD IS BEING RETURNED
C                       BY THIS UNPACKER, THE USER MUST CHECK THE 
C                       VALUE OF IS5(21).  IF IT IS "0", THEN THE
C                       DATA ARE FLOATING POINT.  IF IT IS "1", THEN
C                       THE DATA ARE INTEGER. (OUTPUT)
C             IA(IXY) = IF INTEGER GRIDDED DATA ARE PACKED IN THE
C                       GRIB2 MESSAGE, THEN THE UNPACKED DATA ARE
C                       RETURNED IN THIS ARRAY.  TO DETERMINE WHETHER
C                       AN INTEGER DATA FIELD IS BEING RETURNED
C                       BY THIS UNPACKER, THE USER MUST TEST THE
C                       VALUE CONTAINED WITHIN IS5(21).  IF IT IS
C                       "1", THEN THE DATA ARE INTEGER.  IF IT IS "0",
C                       THEN THE DATA ARE FLOATING POINT.  (OUTPUT)
C               ND2X3 = THE DIMENSION OF A( ), IA( ), AND IB( ). 
C                       (INPUT)
C             IDAT(J) = THE ARRAY CONTAINING THE LOCAL USE GROUPS
C                       CONSISTING OF INTEGER DATA UNPACKED FROM
C                       SECTION 2 (J=1,NIDAT).  (OUTPUT)
C               NIDAT = THE DIMENSION OF THE IDAT( ) ARRAY.  (INPUT)
C             RDAT(J) = THE ARRAY CONTAINING THE LOCAL USE GROUPS
C                       CONSISTING OF FLOATING POINT DATA UNPACKED
C                       FROM SECTION 2 (J=1,NRDAT).  (OUTPUT)
C               NRDAT = THE DIMENSION OF THE RDAT( ) ARRAY.  (INPUT)
C              IS0(L) = HOLDS THE VALUES FOR GRIB2 INDICATOR
C                       SECTION, SECTION 0 (L=1,NS0).  (OUTPUT)
C                 NS0 = SIZE OF IS0( ).  (INPUT)
C              IS1(L) = HOLDS THE VALUES FOR GRIB2 IDENTIFICATION
C                       SECTION, SECTION 1 (L=1,NS1).  (OUTPUT)
C                 NS1 = SIZE OF IS1( ).  (INPUT)
C              IS2(L) = HOLDS THE VALUES FOR GRIB2 LOCAL USE
C                       SECTION, SECTION 2 (L=1,NS2).  (OUTPUT)
C                 NS2 = SIZE OF IS2( ).  (INPUT)
C              IS3(L) = HOLDS THE VALUES FOR GRIB2 GRID DEFINITION
C                       SECTION, SECTION 3 (L=1,NS3).  (OUTPUT)
C                 NS3 = SIZE OF IS3( ).  (INPUT)
C              IS4(L) = HOLDS THE VALUES FOR GRIB2 PRODUCT DEFINITION
C                       SECTION, SECTION 4 (L=1,NS4).  (OUTPUT)
C                 NS4 = SIZE OF IS4( ).  (INPUT)
C              IS5(L) = HOLDS THE VALUES FOR GRIB2 DATA REPRESENTATION
C                       SECTION, SECTION 5 (L=1,NS5).  (OUTPUT)
C                 NS5 = SIZE OF IS5( ).  (INPUT)
C              IS6(L) = HOLDS THE VALUES FOR GRIB2 BIT MAP
C                       SECTION, SECTION 6 (L=1,NS6).  (OUTPUT)
C                 NS6 = SIZE OF IS5( ).  (INPUT)
C              IS7(L) = HOLDS THE VALUES FOR GRIB2 DATA
C                       SECTION, SECTION 7 (L=1,NS7).  (OUTPUT)
C                 NS7 = SIZE OF IS7( ).  (INPUT)
C             IB(IXY) = CAN CONTAIN A BIT-MAP REPRESENTING THE 
C                       LOCATIONS OF MISSING VALUES IN THE 
C                       DATA FIELD AS UNPACKED FROM SECTION
C                       6 OF THE GRIB2 MESSAGE.  A BIT-MAP CAN
C                       ONLY EXIST IN A MESSAGE WHOSE DATA FIELD
C                       WAS PACKED USING THE SIMPLE OR COMPLEX
C                       PACKING METHODS.  A BIT-MAP DOES NOT
C                       APPLY TO COMPLEX PACKING WITH SPATIAL
C                       DIFFERENCES. 
C
C                       UPON RETURNING FROM A CALL TO THIS ROUTINE,
C                       THE EXISTENCE OF A BIT-MAP IN SECTION 6
C                       OF THE GRIB2 MESSAGE IS INDICATED BY
C                       THE CALLING ARGUMENT IBITMAP (SEE BELOW).
C                       (OUTPUT)
C             IBITMAP = A FLAG INDICATING WHETHER OR NOT THERE 
C                       WAS A BIT-MAP IN SECTION 6 OF THE GRIB2
C                       MESSAGE.  A VALUE OF "0" INDICATES THAT
C                       THERE WAS NO BIT-MAP.  A VALUE OF "1" 
C                       INDICATES THAT THERE WAS A BIT-MAP PACKED
C                       IN THIS MESSAGE.  (OUTPUT)
C            IPACK(J) = THE ARRAY HOLDING THE PACKED GRIB2 MESSAGE
C                       (J=1,ND5).  (INPUT)
C                 ND5 = THE DIMENSION OF IPACK( ).  (INPUT)
C              XMISSP = PRIMARY MISSING VALUE INDICATOR.  THE 
C                       CALLER MUST SUPPLY THIS VALUE WHEN 
C                       UNPACKING A MESSAGE THAT WAS COMPRESSED
C                       USING THE SIMPLE PACKING METHOD IF HE 
C                       WANTS MISSING VALUES TO BE EMBEDDED
C                       IN THE RETURNED DATA FIELD.
C
C                       WHEN UNPACKING A MESSAGE THAT WAS 
C                       COMPRESSED USING THE COMPLEX PACKING METHOD
C                       (WITH OR WITHOUT SPATIAL DIFFERENCES), THE 
C                       PRIMARY MISSING VALUE WILL BE RETURNED FROM
C                       THIS ROUTINE THROUGH THIS CALLING ARGUMENT.
C                       THE CALLER OF THIS ROUTINE WILL NEED TO TEST
C                       THE VALUE OF IS5(23) TO DETERMINE THE 
C                       MISSING VALUE MANAGEMENT IN THE UNPACKED 
C                       GRIB2 MESSAGE.  IF IS5(23) HAS A VALUE OF
C                       "0", THEN THERE ARE NO MISSING VALUES
C                       IN THE DATA GRID, AND XMISSP DOES NOT 
C                       REPRESENT A PRIMARY MISSING VALUE.  IF
C                       IS5(23) HAS A VALUE OF "1" OR "2", THEN
C                       THE VALUE IN XMISSP REPRESENTS THE 
C                       PRIMARY MISSING VALUE IN THE DATA FIELD. 
C                       (INPUT/OUTPUT)
C              XMISSS = SECONDARY MISSING VALUE INDICATOR.  THIS
C                       CALLING ARGUMENT DOES NOT APPLY TO DATA 
C                       GRIDS THAT WERE PACKED USING THE SIMPLE 
C                       PACKING METHOD.  WHEN UNPACKING A GRID THAT
C                       WAS PACKED USING THE COMPLEX PACKING METHOD OR
C                       THE COMPLEX WITH SECOND ORDER SPATIAL
C                       DIFFERENCES METHOD, THE CALLER OF THIS ROUTINE
C                       WILL NEED TO TEST IS5(23) TO DETERMINE THE 
C                       MISSING VALUE MANAGEMENT IN THE UNPACKED GRIB2 
C                       DATA GRID.  IF IS5(23) HAS A VALUE OF "0" OR 
C                       "1", THEN THERE ARE NO SECONDARY MISSING 
C                       VALUES IN THE GRIDDED DATA AND XMISSS DOES NOT
C                       REPRESENT A SECONDARY MISSING VALUE.  IF 
C                       IS5(23) HAS A VALUE OF "2", THEN THE VALUE 
C                       CONTAINED WITHIN XMISSS REPRESENTS THE 
C                       SECONDARY MISSING VALUE OF THE DATA FIELD.
C                       (OUTPUT)
C                 NEW = A FLAG THAT INDICATES WHETHER OR NOT TO START
C                       UNPACKING AT THE BEGINNING OF THE GRIB2
C                       MESSAGE.  A VALUE OF "1" INDICATES THAT 
C                       UNPACKING SHOULD START AT THE BEGINNING OF THE
C                       GRIB2 MESSAGE.  A VALUE OF "0" INDICATES THAT
C                       UNPACKING SHOULD RESUME AFTER THE LAST GRID
C                       TO BE UNPACKED FROM THE GRIB2 MESSAGE.
C
C                       THIS FLAG IS USED WHEN UNPACKING GRIB2 MESSAGES
C                       CONTAINING MULTIPLE DATA GRIDS.  WHEN UNPACKING
C                       THE FIRST DATA GRID FROM THE MESSAGE, NEW
C                       SHOULD ALWAYS HAVE A VALUE OF "1".  WHEN
C                       UNPACKING SUBSEQUENT DATA FIELDS FROM THE
C                       MESSAGE, IT SHOULD HAVE A VALUE OF "0".  THIS
C                       ROUTINE MUST BE CALLED ONCE FOR EVERY DATA GRID 
C                       CONTAINED WITHIN THE MESSAGE.  AFTER A DATA
C                       GRID HAD BEEN UNPACKED FROM THE GRIB2 MESSAGE,
C                       THE IENDPK FLAG (SEE BELOW) INDICATES IF THERE
C                       ANY MORE GRIDS TO BE UNPACKED FROM THE
C                       DATA FIELD.  (INPUT)
C              ICLEAN = A FLAG THAT DETERMINES WHETHER OR NOT A DATA
C                       FIELD IS RETURNED WITH PRIMARY MISSING VALUES
C                       IN IT.  THIS FLAG ONLY APPLIES TO THE SIMPLE
C                       AND COMPLEX PACKING METHODS WHEN A BIT-MAP HAS
C                       BEEN PACKED INTO SECTION 6 OF THE GRIB2 
C                       MESSAGE.
C                       1 = THE DATA FIELD IS RETURNED WITHOUT ANY
C                           PRIMARY MISSING VALUES IN IT.  IT IS THE 
C                           RESPONSIBILITY OF THE USER TO USE THE
C                           BIT-MAP TO LOCATE PRIMARY MISSING VALUES.
C                       0 = THE DATA FIELD IS RETURNED WITH THE
C                           PRIMARY MISSING VALUES INSERTED IN IT. 
C                       THIS FLAG DOES NOT APPLY TO COMPLEX PACKING
C                       WITH SPATIAL DIFFERENCING.  ALSO, THIS FLAG
C                       DOES NOT AFFECT SECONDARY MISSING VALUES. 
C                       IF THEY EXIST, THEY ARE ALWAYS RETURNED IN THE
C                       DATA FIELD.  (INPUT)
C              L3264B = INTEGER WORD LENGTH OF MACHINE BEING USED.
C                       VALUES OF 32 AND 64 ARE ACCOMMODATED.  (INPUT)
C              IENDPK = INDICATES TO THE CALLING ROUTINE WHETHER OR NOT
C                       THERE ARE ADDITIONAL GRIDS TO BE PROCESSED
C                       IN THIS GRIB2 MESSAGE.
C                       0 = THIS IS NOT THE END OF THE GRIB2
C                           MESSAGE.  THERE ARE ADDITIONAL
C                           GRIDS TO PROCESS
C                       1 = THERE ARE NO MORE GRIDS TO PROCESS; THIS
C                           IS THE END OF THE GRIB2 MESSAGE.  OR,
C                           THERE HAS BEEN AN ERROR UNPACKING AND
C                           CONTINUING TO UNPACK WOULD BE FRUITLESS.
C                           (OUTPUT)
C            JER(J,K) = RETURN STATUS CODES AND SEVERITY LEVELS
C                       (J=1,NDJER)(K=1,2). VALUES CAN COME FROM
C                       SUBROUTINES; OTHERWISE: 0 = GOOD RETURN.
C                       (OUTPUT)
C               NDJER = THE MAXIMUM NUMBER OF ERROR CODES JER( , )
C                       MAY CONTAIN.  (INPUT)
C                KJER = THE ACTUAL NUMBER OF ERROR MESSAGES CONTAINED
C                       IN JER( , ).  (OUTPUT)
C
C        LOCAL VARIABLES
C               BOUST = .TRUE. IF THE DATA FIELD WAS SCANNED
C                       BOUSTROPHEDONICALLY. .FALSE. OTHERWISE.
C                       (LOGICAL)
C               C7777 = EQUIVALENCED TO I7777 FOR END OF MESSAGE
C                       TESTING.  (CHARACTER*4)
C              EXISTS = A FLAG USED TO INDICATE THE EXISTENCE OF 
C                       OF SECTION 2 AND SECTION 3 IN THE GRIB2
C                       MESSAGE.  (LOGICAL)  
C               I7777 = EQUIVALENCED TO C7777 FOR TESTING END OF
C                       MESSAGE.
C                 IER = ERROR RETURN.
C                        0 -- GOOD RETURN
C                      6-8 -- ERROR CODES RETURNED BY UNPKBG.
C              100,102,199 -- ERROR CODES RETURNED BY UNPK_SECT1.
C                9,202,299 -- ERROR CODES RETURNED BY UNPK_SECT2.
C      300,302,303,307,399 -- ERROR CODES RETURNED BY UNPK_SECT3. 
C                      300 -- THIS IS THE FIRST GRID IN THE MESSAGE
C                             AND THERE IS NO SECTION 3.
C              401,402,499 -- ERROR CODES RETURNED BY UNPK_SECT4.
C      501,502,508,509,599 -- ERROR CODES RETURNED BY UNPK_SECT5.
C      601,602,605,608,699 -- ERROR CODES RETURNED BY UNPK_SECT6. 
C          701,702,708,799 -- ERROR CODES RETURNED BY UNPK_SECT7.
C                      999 -- ERROR CODE RETURNED BY UNPK_TRACE.
C           1002,1010,1011 -- ERROR CODES RETURNED BY UNPK_SECT0.
C                LOCN = THE WORD POSITION FROM WHICH TO UNPACK THE
C                       NEXT VALUE. (INPUT/OUTPUT)
C                IPOS = THE BIT POSITION IN LOCN FROM WHICH TO START
C                       UNPACKING THE NEXT VALUE.  (INPUT/OUTPUT)
C              LBYPWD = BYTES PER WORD FOR EITHER A 32- OR 64-BIT
C                       MACHINE.
C               LOCNS = SAVES THE WORD WHERE A PACKED GRIB2 MESSAGE
C                       SECTION STARTS.
C               IPOSS = SAVES THE BIT POSITION WERE A PACKED GRIB2
C                       MESSAGE STARTS.
C               LSECT = CONTAINS THE LENGTH OF THE SECTION OF THE
C                       GRIB2 MESSAGE LAST UNPACKED.
C                   N = WORKING COPY OF L3264B.
C                  NX = THE NUMBER OF COLUMNS IN THE PRODUCT.
C                  NY = THE NUMBER OF ROWS IN THE PRODUCT.
C                 REF = THE FIELD REFERENCE VALUE AS UNPACKED IN 
C                       SECTION 5.  THIS VALUE IS USED TO UNPACK
C                       THE DATA FIELD IN SECTION 7.
C
C        NON SYSTEM SUBROUTINES CALLED
C           LOCPOS, UNPKBG, UNPK_REFER, UNPK_SECT0, UNPK_SECT1,
C           UNPK_SECT2, UNPK_SECT3, UNPK_SECT4, UNPK_SECT5,
C           UNPK_SECT6, UNPK_SECT7, UNPK_TRACE
C
      CHARACTER*4 C7777
C
      LOGICAL BOUST,EXISTS
C
      DIMENSION A(ND2X3),IA(ND2X3),IB(ND2X3)
      DIMENSION IDAT(NIDAT),RDAT(NRDAT)
C
      DIMENSION IPACK(ND5)
      DIMENSION IS0(NS0),IS1(NS1),IS2(NS2),IS3(NS3),IS4(NS4),IS5(NS5),
     1          IS6(NS6),IS7(NS7)
      DIMENSION JER(NDJER,2)
C
      EQUIVALENCE (C7777,I7777)
C
      DATA C7777/'7777'/
C
      SAVE LOCN,IPOS,NX,NY
C
C        SET ERROR RETURN AND INITIALIZE VARIABLES.
      IER=0
C
C        LBYPWD IS THE NUMBER OF BYTES PER WORD.
      LBYPWD=L3264B/8
C
C        THIS ASSIGNMENT IS MADE MAINLY TO KEEP MOST CALLS TO UNPKBG
C        TO ONE LINE.
      N=L3264B
C
C        ZERO OUT THE ERROR-HANDLING ARRAY.
C
      DO K=1,NDJER
         JER(K,1)=0
         JER(K,2)=0
      ENDDO
C
      KJER=0
C
C        ****************************************
C
C        UNPACK SECTION 0, THE INDICATOR SECTION
C
C        ****************************************
C
C        ATTEMPT TO UNPACK SECTIONS 0 AND 1 ONLY IF THIS IS THE FIRST 
C        GRID IN THE GRIB2 MESSAGE.
      IF(NEW.EQ.1)THEN
         LOCN=1
         IPOS=1
C
C           CALL UNPK_TRACE TO ADD THE SECTION NUMBER AS THE "ERROR"
C           VALUE WITH A SEVERITY OF 0 TO AID IN DIAGNOSING WHERE
C           A FATAL ERROR OCCURRED WITH PROGRAM TERMINATION.
         CALL UNPK_TRACE(KFILDO,JER,NDJER,KJER,0,0)
         CALL UNPK_SECT0(KFILDO,IPACK,ND5,IS0,NS0,N,LOCN,IPOS,IER,
     1                   ISEVERE,*900)
C
         LSECT=NS0
C
C        *************************************
C
C        UNPACK SECTION 1, IDENTIFICATION.
C
C        *************************************
C
C           SAVE LOCN AND IPOS.
C
         LOCNS=LOCN
         IPOSS=IPOS
C
C           CALL UNPK_TRACE TO ADD THE SECTION NUMBER AS THE "ERROR"
C           VALUE WITH A SEVERITY OF 0 TO AID IN DIAGNOSING WHERE
C           A FATAL ERROR OCCURRED WITH PROGRAM TERMINATION.
         CALL UNPK_TRACE(KFILDO,JER,NDJER,KJER,100,0)
         CALL UNPK_SECT1(KFILDO,IPACK,ND5,IS1,NS1,N,LOCN,IPOS,
     1                   IER,ISEVERE,*900)
         LSECT=IS1(1)
C
C           CALCULATE START OF SECTION 2 AND SAVE LOCN AND IPOS.
C           THIS IS DONE IN CASE THERE WAS ACTUALLY MORE DATA
C           IN THE PREVIOUS SECTION THAN WE UNPACKED.
C
         CALL LOCPOS(KFILDO,LOCNS,IPOSS,LSECT,LBYPWD,LOCN,IPOS)
      ENDIF
C
      LOCNS=LOCN
      IPOSS=IPOS
C
C        *************************************
C
C        UNPACK SECTION 2, THE LOCAL USE
C        SECTION, IF IT IS PRESENT.
C
C        *************************************
C
C        CALL UNPK_TRACE TO ADD THE SECTION NUMBER AS THE "ERROR"
C        VALUE WITH A SEVERITY OF 0 TO AID IN DIAGNOSING WHERE
C        A FATAL ERROR OCCURRED WITH PROGRAM TERMINATION.
      CALL UNPK_TRACE(KFILDO,JER,NDJER,KJER,200,0)
      CALL UNPK_SECT2(KFILDO,IPACK,ND5,IS2,NS2,RDAT,NRDAT,IDAT,NIDAT,
     1                N,LOCN,IPOS,EXISTS,IER,ISEVERE,*900)
C
      IF(EXISTS)THEN
         LSECT=IS2(1)
C
C           CALCULATE THE START OF THE NEXT SECTION AND SAVE LOCN
C           AND IPOS. THIS IS DONE IN CASE THERE WAS ACTUALLY MORE
C           DATA IN THE PREVIOUS SECTION THAN WE UNPACKED.
         CALL LOCPOS(KFILDO,LOCNS,IPOSS,LSECT,LBYPWD,LOCN,IPOS)
         LOCNS=LOCN
         IPOSS=IPOS
C
         IF(IER.NE.0)THEN
C              SECTION 2 NOT OF RECOGNIZABLE FILE FORMAT.  THIS IS
C              NOT TREATED AS A FATAL ERROR; SECTION 2 IS SKIPPED.
            CALL UNPK_TRACE(KFILDO,JER,NDJER,KJER,IER,1)
         ENDIF
C
      ENDIF
C
C        *************************************
C
C        UNPACK SECTION 3, GRID DEFINITION.
C
C        *************************************
C
C        CALL UNPK_TRACE TO ADD THE SECTION NUMBER AS THE "ERROR"
C        VALUE WITH A SEVERITY OF 0 TO AID IN DIAGNOSING WHERE
C        A FATAL ERROR OCCURRED WITH PROGRAM TERMINATION.
      CALL UNPK_TRACE(KFILDO,JER,NDJER,KJER,300,0)
      CALL UNPK_SECT3(KFILDO,IPACK,ND5,IS3,NS3,N,LOCN,IPOS,
     1               NX,NY,EXISTS,BOUST,IER,ISEVERE,*900)
C
      IF(.NOT.EXISTS)THEN
         IF(NEW.EQ.1)THEN
C
C              THERE MUST BE A SECTION 3 FOR A NEW PRODUCT.
C              ISEVERE = 2 IS RETURNED FROM UNPK_SECT3 EVEN WITH A
C              NORMAL RETURN.
            IER=300
            GO TO 900
         ENDIF
      ELSE
         LSECT=IS3(1)
C
C           CALCULATE THE START OF THE NEXT SECTION AND SAVE LOCN
C           AND IPOS. THIS IS DONE IN CASE THERE WAS ACTUALLY MORE
C           DATA IN THE PREVIOUS SECTION THAN WE UNPACKED.
         CALL LOCPOS(KFILDO,LOCNS,IPOSS,LSECT,LBYPWD,LOCN,IPOS)
         LOCNS=LOCN
         IPOSS=IPOS
      ENDIF
C
C        *************************************
C
C        UNPACK SECTION 4, PRODUCT DEFINITION.
C
C        *************************************
C
C        CALL UNPK_TRACE TO ADD THE SECTION NUMBER AS THE "ERROR"
C        VALUE WITH A SEVERITY OF 0 TO AID IN DIAGNOSING WHERE
C        A FATAL ERROR OCCURRED WITH PROGRAM TERMINATION.
      CALL UNPK_TRACE(KFILDO,JER,NDJER,KJER,400,0)
      CALL UNPK_SECT4(KFILDO,IPACK,ND5,IS4,NS4,N,
     1                LOCN,IPOS,IER,ISEVERE,*900)
      LSECT=IS4(1)
C
C        *************************************
C
C        UNPACK SECTION 5, DATA DEFINITION.
C
C        *************************************
C
C        CALCULATE START OF SECTION 5 AND SAVE LOCN AND IPOS.
C        THIS IS DONE IN CASE THERE WAS ACTUALLY MORE DATA
C        IN THE PREVIOUS SECTION THAN WE UNPACKED.
C
      CALL LOCPOS(KFILDO,LOCNS,IPOSS,LSECT,LBYPWD,LOCN,IPOS)
      LOCNS=LOCN
      IPOSS=IPOS
C
C        CALL UNPK_TRACE TO ADD THE SECTION NUMBER AS THE "ERROR"
C        VALUE WITH A SEVERITY OF 0 TO AID IN DIAGNOSING WHERE
C        A FATAL ERROR OCCURRED WITH PROGRAM TERMINATION.
      CALL UNPK_TRACE(KFILDO,JER,NDJER,KJER,500,0)
      CALL UNPK_SECT5(KFILDO,IPACK,ND5,IS5,NS5,N,LOCN,IPOS,
     1                REF,XMISSP,XMISSS,IER,ISEVERE,*900)
      LSECT=IS5(1)
C
C        *************************************************
C
C        UNPACK SECTION 6, BIT MAP.
C
C        ************************************************
C
C        CALCULATE START OF SECTION 6 AND SAVE LOCN AND IPOS.
C        THIS IS DONE IN CASE THERE WAS ACTUALLY MORE DATA
C        IN THE PREVIOUS SECTION THAN WE UNPACKED.
C
      CALL LOCPOS(KFILDO,LOCNS,IPOSS,LSECT,LBYPWD,LOCN,IPOS)
      LOCNS=LOCN
      IPOSS=IPOS
C
C
C        CALL UNPK_TRACE TO ADD THE SECTION NUMBER AS THE "ERROR"
C        VALUE WITH A SEVERITY OF 0 TO AID IN DIAGNOSING WHERE
C        A FATAL ERROR OCCURRED WITH PROGRAM TERMINATION.
      CALL UNPK_TRACE(KFILDO,JER,NDJER,KJER,600,0)
      CALL UNPK_SECT6(KFILDO,IPACK,ND5,IS6,NS6,IB,ND2X3,NX,NY,N,
     1                LOCN,IPOS,IBITMAP,IER,ISEVERE,*900)
      LSECT=IS6(1)
C
C        *************************************
C
C        CALL UNPK_REFER TO DETERMINE HOW THE
C        DATA WAS ORIGINALLY PACKED. THIS ROUTINE
C        ALSO DETERMINES WHETHER THE USER WANTS
C        MISSING VALUES IN THE UNPACKED DATA FIELD TO
C        BE REPRESENTED BY A BIT-MAP OR BY ACTUALLY
C        HAVING THE MISSING VALUES EMBEDDED IN THE 
C        DATA FIELD.
C
C        *************************************
C
      CALL UNPK_REFER(IS5,NS5,ICLEAN,IUNPKOPT,IER,ISEVERE,*900)
C
C        *************************************
C
C        UNPACK SECTION 7, BINARY DATA.
C
C        *************************************
C
C        CALCULATE START OF SECTION AND SAVE LOCN AND IPOS.
C        THIS IS DONE IN CASE THERE WAS ACTUALLY MORE DATA
C        IN THE PREVIOUS SECTION THAN WE UNPACKED.
C
      CALL LOCPOS(KFILDO,LOCNS,IPOSS,LSECT,LBYPWD,LOCN,IPOS)
      LOCNS=LOCN
      IPOSS=IPOS
C
C        CALL UNPK_TRACE TO ADD THE SECTION NUMBER AS THE "ERROR"
C        VALUE WITH A SEVERITY OF 0 TO AID IN DIAGNOSING WHERE
C        A FATAL ERROR OCCURRED WITH PROGRAM TERMINATION.
      CALL UNPK_TRACE(KFILDO,JER,NDJER,KJER,700,0)
      CALL UNPK_SECT7(KFILDO,A,ND2X3,NX,NY,IUNPKOPT,IPACK,REF,ND5,
     1                IS5,NS5,IS7,NS7,IBITMAP,IB,XMISSP,XMISSS,BOUST,
     2                N,LOCN,IPOS,IER,ISEVERE,*900)
      LSECT=IS7(1)
C
C        *************************************
C
C        UNPACK SECTION 8, END OF RECORD.
C        IT STARTS ON A BYTE.
C
C        *************************************
C
C        CALCULATE START OF SECTION.
C
      CALL LOCPOS(KFILDO,LOCNS,IPOSS,LSECT,LBYPWD,LOCN,IPOS)
      LOCNS=LOCN
      IPOSS=IPOS
      CALL UNPKBG(KFILDO,IPACK,ND5,LOCN,IPOS,NVALUE,32,N,IER,*900)
      IF(L3264B.EQ.64)NVALUE=ISHFT(NVALUE,32)
C        THE ABOVE STATEMENT IS TO ACCOMMODATE THE 64-BIT WORD, BY
C        MOVING THE 4 CHARACTERS TO THE LEFT HALF OF THE WORD FOR 
C        TESTING WITH I7777.
C
      IF(NVALUE.EQ.I7777)THEN
         IENDPK=1
      ELSE
         IENDPK=0
      ENDIF
C
C        THIS RETAINS INTERNALLY FOR THE NEXT ENTRY THE LOCATION
C        OF THE END OF MESSAGE OR THE START OF THE NEXT MESSAGE.
C        IF THE USER WERE TO MISTAKENLY ENTER AGAIN, THE END
C        OF MESSAGE WOULD BE UNEXPECTEDLY FOUND.
      LOCN=LOCN-1
C
C        IS THE USER EXPECTING AN INTEGER DATA FIELD?
      IF(IS5(21).EQ.1)THEN
         DO K=1,NX*NY
            IA(K)=NINT(A(K))
         ENDDO
      ENDIF
C 
      RETURN
C
C        ERROR RETURN SECTION.
C
 900  IENDPK=1
C
      CALL UNPK_TRACE(KFILDO,JER,NDJER,KJER,IER,ISEVERE)
      RETURN
      END

      SUBROUTINE TIMPR(KFILDS,KFILDO,ITITLE) 
C 
C        JANUARY   1994   CHAMBERS, GLAHN   TDL  MOS-2000
C        SEPTEMBER 2002   GLAHN   ADDED COMMAS IN FORMAT 110
C 
C        PURPOSE 
C            A DATE/TIME STAMPING FUNCTION WHICH WILL WRITE THE DATE AND
C            TIME AND A USER MESSAGE OF UP TO 20 CHARACTERS ON UNIT 
C            NO. KFILDO.  UNDER THE D COMPILER OPTION, MESSAGE WILL 
C            ALSO BE WRITTEN TO THE CURRENT CONSOLE, UNIT NO. KFILDS
C            (ONLY) WHEN KFILDS NE KFILDO. 
C 
C        DATA SET USE 
C            KFILDS - UNIT NUMBER FOR OUTPUT TO CURRENT CONSOLE.  (OUTPUT) 
C            KFILDO - OUTPUT (PRINT) FILE UNIT NUMBER.  (OUTPUT) 
C 
C        VARIABLES 
C 
C            INPUT 
C              KFILDS = UNIT NUMBER FOR OUTPUT TO CURRENT CONSOLE. 
C              KFILDO = OUTPUT (PRINT) FILE UNIT NUMBER. 
C              ITITLE = USER MESSAGE.  (CHARACTER*20) 
C 
C            INTERNAL 
C              DTATME = DATE AND TIME FOR PRINTING.  (CHARACTER*24)
C 
C        NONSYSTEM SUBROUTINES CALLED 
C            NONE. 
C 
      CHARACTER*24 DTATME
      CHARACTER*20 ITITLE
C 
      CALL FDATE(DTATME) 
D     IF(KFILDS.NE.KFILDO)WRITE(KFILDS,110)ITITLE,DTATME
      WRITE(KFILDO,110)ITITLE,DTATME
 110  FORMAT(' ',A20,'   DATE/TIME:  ',A24) 
      RETURN 
      END 

      SUBROUTINE UNPK_TEMP48(KFILDO,IPACK,ND5,IS4,NS4,L3264B,
     1                       LOCN,IPOS,IER,*)
C
C        MARCH    2000   LAWRENCE  GSC/TDL    ORIGINAL CODING
C        JANUARY  2001   GLAHN     COMMENTS; CHANGED TO STANDARD 
C                                  RETURN SEQUENCE; CHANGED IER = 14
C                                  TO 402; CHECKED FOR SIZE OF IS4( )
C                                  FOR ALL TIME IS4(42) TIME RANGES
C        FEBRUARY 2001   GLAHN     CHECKED TEMPLATE NUMBER; COMMENTS
C        MAY      2002   GLAHN     CORRECTED ERROR IN CALL TO 
C                                  UNPK_TEMP40
C
C        PURPOSE
C            UNPACKS TEMPLATE 8, AN AVERAGE, ACCUMULATION, OR EXTREME
C            VALUE TEMPLATE, FROM THE PRODUCT DEFINITION SECTION OF A 
C            GRIB2 MESSAGE.  IT IS THE RESPONSIBILITY OF THE CALLING 
C            ROUTINE TO UNPACK THE FIRST 9 OCTETS IN SECTION 4.
C
C        DATA SET USE
C           KFILDO - UNIT NUMBER FOR OUTPUT (PRINT) FILE. (OUTPUT)
C
C        VARIABLES
C              KFILDO = UNIT NUMBER FOR OUTPUT (PRINT) FILE. (INPUT)
C            IPACK(J) = THE ARRAY THAT HOLDS THE ACTUAL PACKED MESSAGE
C                       (J=1,ND5). (INPUT/OUTPUT)
C                 ND5 = THE SIZE OF THE ARRAY IPACK( ). (INPUT)
C              IS4(J) = THE PRODUCT DEFINITION INFORMATION FOR
C                       TEMPLATE 4.8 IS WRITTEN TO ELEMENTS 10 THROUGH
C                       55+12*(IS4(42)-1) AS IT IS UNPACKED FROM 
C                       IPACK( ) (J=1,NS4).  (INPUT/OUTPUT)
C                 NS4 = SIZE OF IS4( ). (INPUT)
C              L3264B = THE INTEGER WORD LENGTH IN BITS OF THE MACHINE
C                       BEING USED. VALUES OF 32 AND 64 ARE
C                       ACCOMMODATED. (INPUT)
C                LOCN = THE WORD POSITION FROM WHICH TO UNPACK THE
C                       NEXT VALUE. (INPUT/OUTPUT)
C                IPOS = THE BIT POSITION IN LOCN FROM WHICH TO START
C                       UNPACKING THE NEXT VALUE.  (INPUT/OUTPUT)
C                 IER = RETURN STATUS CODE. (OUTPUT)
C                         0 = GOOD RETURN.
C                       6-8 = ERROR CODES GENERATED BY UNPKBG. SEE THE 
C                             DOCUMENTATION IN THE UNPKBG ROUTINE.
C                       402 = IS4( ) HAS NOT BEEN DIMENSIONED LARGE
C                             ENOUGH TO CONTAIN THE ENTIRE TEMPLATE. 
C                       403 = NOT THE CORRECT TEMPLATE. 
C                   * = ALTERNATE RETURN WHEN IER NE 0. 
C
C             LOCAL VARIABLES
C             MINSIZE = THE SMALLEST ALLOWABLE DIMENSION FOR IS4( ).
C                   N = L3264B = THE INTEGER WORD LENGTH IN BITS OF
C                       THE MACHINE BEING USED. VALUES OF 32 AND
C                       64 ARE ACCOMMODATED.
C
C        NON SYSTEM SUBROUTINES CALLED
C           UNPKBG, UNPK_TEMP40
C
      PARAMETER(MINSIZE=43)
C
      DIMENSION IPACK(ND5),IS4(NS4)
C
      N=L3264B
      IER=0
C
C        CHECK TO MAKE SURE THAT THIS IS TEMPLATE 4.8. 
C
      IF(IS4(8).NE.8)THEN
D        WRITE(KFILDO,10)IS4(8)
D10      FORMAT(/' TEMPLATE ',I4,' INDICATED BY IS4(8)'/
D    1           ' IS NOT CORRECT IN UNPK_TEMP48.'/)
         IER=403
         GO TO 900
      ENDIF
C
C        CHECK THE DIMENSIONS OF IS4( ).
C
      IF(NS4.LT.MINSIZE)THEN
D        WRITE(KFILDO,20)NS4,MINSIZE
D20      FORMAT(/' IS4( ) IS CURRENTLY DIMENSIONED TO CONTAIN'/
D    1           ' NS4=',I4,' ELEMENTS. THIS ARRAY MUST BE'/
D    2           ' DIMENSIONED TO AT LEAST ',I4,' ELEMENTS'/
D    3           ' TO CONTAIN ALL OF THE DATA IN PRODUCT'/
D    4           ' DEFINITION TEMPLATE 4.8.'/)
         IER=402
         GO TO 900
      ENDIF
C
C        SINCE THIS TEMPLATE SHARES THE SAME INFORMATION
C        AS TEMPLATE 4.0, CALL THE UNPK_TEMP40 ROUTINE
C        TO RETRIEVE OCTETS 10 THROUGH 42.
      CALL UNPK_TEMP40(KFILDO,IPACK,ND5,IS4,NS4,L3264B,
     1                 LOCN,IPOS,IER,*900)
C
C        UNPACK THE YEAR 
      CALL UNPKBG(KFILDO,IPACK,ND5,LOCN,IPOS,IS4(35),16,N,IER,*900)
C
C        UNPACK THE MONTH 
      CALL UNPKBG(KFILDO,IPACK,ND5,LOCN,IPOS,IS4(37),8,N,IER,*900)
C
C        UNPACK THE DAY 
      CALL UNPKBG(KFILDO,IPACK,ND5,LOCN,IPOS,IS4(38),8,N,IER,*900)
C
C        UNPACK THE HOUR 
      CALL UNPKBG(KFILDO,IPACK,ND5,LOCN,IPOS,IS4(39),8,N,IER,*900)
C
C        UNPACK THE MINUTE 
      CALL UNPKBG(KFILDO,IPACK,ND5,LOCN,IPOS,IS4(40),8,N,IER,*900)
C
C        UNPACK THE SECOND 
      CALL UNPKBG(KFILDO,IPACK,ND5,LOCN,IPOS,IS4(41),8,N,IER,*900)
C
C        UNPACK THE NUMBER OF TIME RANGE SPECIFICATIONS DESCRIBING
C        THE TIME INTERVALS USED TO CALCULATE THE STATISTICALLY
C        PROCESSED FIELD.
      CALL UNPKBG(KFILDO,IPACK,ND5,LOCN,IPOS,IS4(42),8,N,IER,*900)
C
C        PACK THE TOTAL NUMBER OF DATA VALUES MISSING IN
C        STATISTICAL PROCESS.
      CALL UNPKBG(KFILDO,IPACK,ND5,LOCN,IPOS,IS4(43),32,N,IER,*900)
C
C        CHECK TO MAKE SURE THAT IS4( ) WAS DIMENSIONED LARGE ENOUGH
C        TO CONTAIN THE DATA FOR ALL OF THE IS4(42) TIME RANGES.
C
      ISIZE=55+12*(IS4(42)-1)
      IF(NS4.LT.ISIZE)THEN
D        WRITE(KFILDO,19)NS4,ISIZE
D19      FORMAT(/' IS4( ) IS CURRENTLY DIMENSIONED TO CONTAIN'/
D    1           ' NS4=',I4,' ELEMENTS.  THIS ARRAY MUST BE'/
D    2           ' DIMENSIONED TO AT LEAST ',I4,' ELEMENTS'/
D    3           ' TO CONTAIN ALL OF THE TIME RANGES'/
D    4           ' IN PRODUCT DEFINITION TEMPLATE 4.8.'/)
         IER=402
         GO TO 900
      ENDIF
C
      DO 30 I=1,IS4(42)
         IC=12*(I-1)
C
C           UNPACK THE STATISTICAL PROCESS USED TO CALCULATE THE
C           PROCESSED FIELD FROM THE FIELD AT EACH TIME INCREMENT
C           DURING THE TIME RANGE.
         CALL UNPKBG(KFILDO,IPACK,ND5,LOCN,IPOS,IS4(47+IC),8,N,
     1             IER,*900)
C
C           UNPACK THE TYPE OF TIME INCREMENT BETWEEN SUCCESSIVE
C           FIELDS USED IN THE STATISTICAL PROCESS.
         CALL UNPKBG(KFILDO,IPACK,ND5,LOCN,IPOS,IS4(48+IC),8,N,
     1             IER,*900)
C
C           UNPACK THE INDICATOR OF UNIT OF TIME FOR TIME RANGE OVER
C           WHICH STATISTICAL PROCESSING IS DONE.
         CALL UNPKBG(KFILDO,IPACK,ND5,LOCN,IPOS,IS4(49+IC),8,N,
     1             IER,*900)
C
C           UNPACK THE LENGTH OF THE TIME RANGE OVER WHICH STATISTICAL
C           PROCESSING IS DONE, IN UNITS DEFINED BY THE PREVIOUS
C           OCTET.
         CALL UNPKBG(KFILDO,IPACK,ND5,LOCN,IPOS,IS4(50+IC),32,N,
     1             IER,*900)
C
C           UNPACK THE INDICATOR OF UNIT OF TIME FOR THE INCREMENT
C           BETWEEN THE SUCCESSIVE FIELDS USED.
         CALL UNPKBG(KFILDO,IPACK,ND5,LOCN,IPOS,IS4(54+IC),8,N,
     1             IER,*900)
C
C           UNPACK THE TIME INCREMENT BETWEEN SUCCESSIVE FIELDS,
C           IN UNITS DEFINED BY THE PREVIOUS OCTET.
         CALL UNPKBG(KFILDO,IPACK,ND5,LOCN,IPOS,IS4(55+IC),32,N,
     1             IER,*900)
C
 30   ENDDO
C
C       ERROR RETURN SECTION
C
 900  IF(IER.NE.0)RETURN 1
C
      RETURN
      END

      SUBROUTINE UNEARTH(KFILDO,IPACK,ND5,IS3,NS3,L3264B,
     1                   LOCN,IPOS,IER,*)
C
C        MARCH    2000   LAWRENCE  GSC/TDL   ORIGINAL CODING
C        JANUARY  2001   GLAHN     COMMENTS; CHANGED IER = 24 TO 307;
C                                  ADDED * RETURN
C        FEBRUARY 2001   GLAHN     COMMENTS; REMOVED GO TO 900
C
C        PURPOSE
C            UNPACKS INFORMATION PERTAINING TO THE SHAPE OF 
C            THE EARTH FROM SECTION 3 OF A GRIB2 MESSAGE.
C            THE INFORMATION THAT THIS ROUTINE PROCESSES IS BASED
C            ON TABLE 3.2 OF THE WMO GRIB2 DOCUMENTATION AND IS
C            REQUIRED BY MANY OF THE MAP TEMPLATES IN SECTION 3.
C
C        DATA SET USE
C           KFILDO - UNIT NUMBER FOR OUTPUT (PRINT) FILE. (OUTPUT)
C
C        VARIABLES
C              KFILDO = UNIT NUMBER FOR OUTPUT (PRINT) FILE. (INPUT)
C            IPACK(J) = THE ARRAY THAT HOLDS THE ACTUAL PACKED MESSAGE
C                       (J=1,ND5). (INPUT)
C                 ND5 = THE SIZE OF THE ARRAY IPACK( ). (INPUT)
C              IS3(J) = THE EARTH-SHAPE INFORMATION IS UNPACKED
C                       INTO ELEMENTS 15 THROUGH 27 OF THIS ARRAY
C                       FROM THE GRIB2 MESSAGE IN IPACK( ) (J=1,NS3).
C                       (OUTPUT)
C                 NS3 = SIZE OF IS3( ). (INPUT)
C              L3264B = THE INTEGER WORD LENGTH IN BITS OF THE MACHINE
C                       BEING USED. VALUES OF 32 AND 64 ARE
C                       ACCOMMODATED. (INPUT)
C                LOCN = THE WORD POSITION FROM WHICH TO UNPACK THE
C                       NEXT VALUE. (INPUT/OUTPUT)
C                IPOS = THE BIT POSITION IN LOCN FROM WHICH TO START
C                       UNPACKING THE NEXT VALUE.  (INPUT/OUTPUT)
C                 IER = RETURN STATUS CODE. (OUTPUT)
C                         0 = GOOD RETURN.
C                       6-8 = ERROR CODES GENERATED BY UNPKBG. SEE THE
C                             DOCUMENTATION IN THE UNPKBG ROUTINE.
C                       307 = UNRECOGNIZED OR UNSUPPORTED SHAPE OF
C                             EARTH CODE IN IS3(15).
C                   * = ALTERNATE RETURN WHEN IER NE 0. 
C
C             LOCAL VARIABLES
C              ITRASH = CONTAINS UNNEEDED UNPACKED DATA FROM THE
C                       GRIB2 MESSAGE.
C                   N = L3264B = THE INTEGER WORD LENGTH IN BITS OF
C                       THE MACHINE BEING USED. VALUES OF 32 AND
C                       64 ARE ACCOMMODATED.
C
C        NON-SYSTEM SUBROUTINES CALLED
C           UNPKBG
C
      DIMENSION IPACK(ND5),IS3(NS3)
C
      N=L3264B
      IER=0
C
C        UNPACK THE SHAPE OF THE EARTH.
      CALL UNPKBG(KFILDO,IPACK,ND5,LOCN,IPOS,IS3(15),8,N,IER,*900)
C
C        DEPENDING ON THE SHAPE OF THE EARTH THAT THE
C        USER HAS CHOSEN, UNPACK THE APPROPRIATE SCALE
C        FACTOR AND VALUE FOR THE RADIUS OF THE EARTH.
      IF((IS3(15).EQ.0).OR.(IS3(15).EQ.1))THEN
C
C           UNPACK THE SCALE FACTOR OF THE RADIUS OF THE
C           SPHERICAL EARTH AND THE SCALED RADIUS OF THE
C           SPHERICAL EARTH.
         CALL UNPKBG(KFILDO,IPACK,ND5,LOCN,IPOS,IS3(16),8,N,
     1               IER,*900)
         CALL UNPKBG(KFILDO,IPACK,ND5,LOCN,IPOS,IS3(17),
     1               32,N,IER,*900)
C
C           UNPACK THE ZEROED-OUT OCTETS THAT WOULD HAVE CONTAINED
C           THE OBLATE SPHEROID EARTH DATA. 
         CALL UNPKBG(KFILDO,IPACK,ND5,LOCN,IPOS,ITRASH,32,N,IER,*900)
         CALL UNPKBG(KFILDO,IPACK,ND5,LOCN,IPOS,ITRASH,32,N,IER,*900)
         CALL UNPKBG(KFILDO,IPACK,ND5,LOCN,IPOS,ITRASH,16,N,IER,*900)
C
      ELSE IF((IS3(15).EQ.2).OR.(IS3(15).EQ.3))THEN
C
C           UNPACK THE ZEROED-OUT OCTETS THAT WOULD HAVE
C           BEEN USED TO STORE THE SPHERICAL EARTH INFORMATION.
         CALL UNPKBG(KFILDO,IPACK,ND5,LOCN,IPOS,ITRASH,32,N,IER,*900)
         CALL UNPKBG(KFILDO,IPACK,ND5,LOCN,IPOS,ITRASH,8,N,IER,*900)
C
C           UNPACK THE SCALE FACTOR OF THE MAJOR AND MINOR
C           AXES OF AN OBLATE SPHEROID EARTH ALONG WITH
C           WITH THEIR SCALED VALUES.
         CALL UNPKBG(KFILDO,IPACK,ND5,LOCN,IPOS,IS3(21),8,N,
     1               IER,*900)
         CALL UNPKBG(KFILDO,IPACK,ND5,LOCN,IPOS,IS3(22),
     1               32,N,IER,*900)
         CALL UNPKBG(KFILDO,IPACK,ND5,LOCN,IPOS,IS3(26),8,N,
     1               IER,*900)
         CALL UNPKBG(KFILDO,IPACK,ND5,LOCN,IPOS,IS3(27),
     1               32,N,IER,*900)
C
      ELSE
C           AN INVALID OR UNSUPPORTED CODE FOR THE SHAPE OF
C           THE EARTH HAS BEEN PACKED INTO THE GRIB2 MESSAGE.
         IER=307
      ENDIF
C
C       ERROR RETURN SECTION.
C
 900  IF(IER.NE.0)RETURN1
C
      RETURN
      END

      SUBROUTINE UNPK_AZIMUTH(KFILDO,IPACK,ND5,IS3,NS3,L3264B,
     1                        LOCN,IPOS,BOUST,IER,*)
C
C        MARCH    2000   LAWRENCE  GSC/TDL    ORIGINAL CODING
C        JANUARY  2001   GLAHN     COMMENTS; CHANGED COMPUTATION OF
C                                  NEGATIVE VALUE; CHANGED TO
C                                  STANDARD RETURN SEQUENCE 
C        FEBRUARY 2001   GLAHN/LAWRENCE CHANGED J=39+4*(K-1)
C                                  TO J=40+4*(K-1); CHECKED SIZE OF
C                                  NS3; COMMENTS
C        NOVEMBER 2001   GLAHN     COMMENT ON IS3( ) SIZE
C
C        PURPOSE
C            UNPACKS TEMPLATE 3.120, AN AZIMUTH-RANGE PROJECTION,
C            FROM SECTION 3 OF A GRIB2 MESSAGE.
C            DATA ARE PLACED INTO THE IS3( ) ARRAY.
C            IT IS THE RESPONSIBILITY OF THE CALLING ROUTINE
C            TO UNPACK THE FIRST 14 OCTETS IN SECTION 3.
C
C        DATA SET USE
C           KFILDO - UNIT NUMBER FOR OUTPUT (PRINT) FILE. (OUTPUT)
C
C        VARIABLES
C              KFILDO = UNIT NUMBER FOR OUTPUT (PRINT) FILE. (INPUT)
C            IPACK(J) = THE ARRAY THAT HOLDS THE ACTUAL PACKED MESSAGE
C                       (J=1,ND5). (INPUT/OUTPUT)
C                 ND5 = THE SIZE OF THE ARRAY IPACK( ). (INPUT)
C              IS3(J) = THE AZIMUTH-RANGE PROJECTION INFORMATION
C                       IS WRITTEN TO ELEMENTS 15 THROUGH 39+4(Nr-1)
C                       (WHERE Nr IS THE NUMBER OF RADIALS IN THE
C                       PROJECTION) AS IT IS UNPACKED FROM IPACK( )
C                       (J=1,NS3). (INPUT/OUTPUT)
C                 NS3 = SIZE OF IS3( ). (INPUT) 
C              L3264B = THE INTEGER WORD LENGTH IN BITS OF THE MACHINE
C                       BEING USED. VALUES OF 32 AND 64 ARE
C                       ACCOMMODATED. (INPUT)
C                LOCN = THE WORD POSITION FROM WHICH TO UNPACK THE
C                       NEXT VALUE. (INPUT/OUTPUT)
C                IPOS = THE BIT POSITION IN LOCN FROM WHICH TO START
C                       UNPACKING THE NEXT VALUE.  (INPUT/OUTPUT)
C               BOUST = .TRUE. IF THE DATA FIELD WAS SCANNED
C                       BOUSTROPHEDONICALLY. .FALSE. OTHERWISE. 
C                       (LOGICAL) (OUTPUT)
C                 IER = RETURN STATUS CODE. (OUTPUT)
C                         0 = GOOD RETURN.
C                       6-8 = ERROR CODES GENERATED BY UNPKBG. SEE THE 
C                             DOCUMENTATION IN THE UNPKBG ROUTINE.
C                       302 = IS3( ) NOT DIMENSIONED LARGE ENOUGH.
C                       303 = UNSUPPORTED GRID TEMPLATE INDICATED 
C                             BY IS3(13).
C                   * = ALTERNATE RETURN WHEN IER .NE. 0.
C
C             LOCAL VARIABLES
C               ISIGN = A FLAG INDICATING WHETHER AN UNPACKED VALUE
C                       IS POSITIVE OR NEGATIVE.
C                   J = ARRAY INDEXING VARIABLE.
C                   K = LOOPING VARIABLE.
C                   N = L3264B = THE INTEGER WORD LENGTH IN BITS OF
C                       THE MACHINE BEING USED. VALUES OF 32 AND
C                       64 ARE ACCOMMODATED.
C
C        NON SYSTEM SUBROUTINES CALLED
C           UNPKBG
C
      LOGICAL BOUST
C
      DIMENSION IPACK(ND5),IS3(NS3)
C
      N=L3264B
      IER=0
C
C        CHECK TO MAKE SURE THAT AN AZIMUTH-RANGE PROJECTION
C        IS PACKED IN THIS GRIB2 MESSAGE.
      IF (IS3(13).NE.120)THEN
D        WRITE(KFILDO,10)IS3(13)
D10      FORMAT(/' MAP PROJECTION CODE ',I4,' INDICATED BY IS3(13)'/
D    1           ' IS NOT AZIMUTH-RANGE. PLEASE REFER TO'/
D    2           ' THE GRIB2 DOCUMENTATION TO DETERMINE THE'/
D    3           ' CORRECT MAP PROJECTION PACKER TO CALL.'/)
         IER=303
         GO TO 900
      ENDIF
C
C        CHECK SIZE OF IS3( ).
C
      IF(NS3.LT.39)THEN
         IER=302
         GO TO 900
      ENDIF
C
C        UNPACK THE NUMBER OF DATA BINS ALONG THE RADIALS (Nb).
      CALL UNPKBG(KFILDO,IPACK,ND5,LOCN,IPOS,IS3(15),32,N,IER,*900)
C
C        UNPACK THE NUMBER OF RADIALS IN THE PRODUCT (Nr).
      CALL UNPKBG(KFILDO,IPACK,ND5,LOCN,IPOS,IS3(19),32,N,IER,*900)
C
C        UNPACK THE LATITUDE & LONGITUDE OF THE CENTER POINT
      CALL UNPKBG(KFILDO,IPACK,ND5,LOCN,IPOS,ISIGN,1,N,IER,*900)
      CALL UNPKBG(KFILDO,IPACK,ND5,LOCN,IPOS,IS3(23),
     1          31,N,IER,*900)
      IF(ISIGN.EQ.1)IS3(23)=-IS3(23)
      CALL UNPKBG(KFILDO,IPACK,ND5,LOCN,IPOS,ISIGN,1,N,IER,*900)
      CALL UNPKBG(KFILDO,IPACK,ND5,LOCN,IPOS,IS3(27),
     1          31,N,IER,*900)
      IF(ISIGN.EQ.1)IS3(27)=-IS3(27)
C
C        UNPACK THE SPACING OF BINS ALONG THE RADIALS
      CALL UNPKBG(KFILDO,IPACK,ND5,LOCN,IPOS,IS3(31),32,N,IER,*900)
C
C        UNPACK THE OFFSET FROM THE ORIGIN TO THE INNER BOUND.
      CALL UNPKBG(KFILDO,IPACK,ND5,LOCN,IPOS,IS3(35),32,N,IER,*900)
C
C        UNPACK THE SCANNING MODE.
      CALL UNPKBG(KFILDO,IPACK,ND5,LOCN,IPOS,IS3(39),8,N,IER,*900)
C
      IF(IAND(IS3(39),16).EQ.16)THEN
C           THE MASK GETS BIT 4 (FROM THE LEFT); WHEN IT IS 1,
C           BOUST IS TRUE.; OTHERWISE BOUST IS FALSE.
         BOUST=.TRUE.
         IS3(39)=IAND(IS3(39),239)
C           BIT 4 IS SET = 0, BECAUSE THE DATA ARE RETURNED
C           NON-BOUSTROPHEDONICALLY ORDERED EVEN THOUGH THEY WERE
C           PACKED THAT WAY.  239 DECIMAL = 357 OCTAL PRESERVES
C           ALL OTHER BITS IN THE OCTET.
      ELSE
         BOUST=.FALSE.
      ENDIF
C
C        UNPACK THE STARTING AZIMUTH AND AZIMUTHAL WIDTH
C        FOR EACH OF THE RADIALS (THE IS3(19) VALUE)
C
C        CHECK SIZE OF IS3( ).
C
      IF(NS3.LT.42+4*(IS3(19)-1))THEN
         IER=302
         GO TO 900
      ENDIF
C
      DO K=1,IS3(19)
         J = 40 + 4*(K-1)
         CALL UNPKBG(KFILDO,IPACK,ND5,LOCN,IPOS,IS3(J),16,N,IER,*900)
         CALL UNPKBG(KFILDO,IPACK,ND5,LOCN,IPOS,ISIGN,1,N,IER,*900)
         CALL UNPKBG(KFILDO,IPACK,ND5,LOCN,IPOS,IS3(J+2),15,
     1             N,IER,*900)
         IF(ISIGN.EQ.1)IS3(J+2)=-IS3(J+2)
      ENDDO 
C
C       ERROR RETURN SECTION
C
 900  IF(IER.NE.0)RETURN 1
C
      RETURN
      END

      SUBROUTINE UNPK_SECT4(KFILDO,IPACK,ND5,IS4,NS4,L3264B,
     1                      LOCN,IPOS,IER,ISEVERE,*)
C
C        MARCH    2000   LAWRENCE  GSC/TDL    ORIGINAL CODING
C        JANUARY  2001   GLAHN     COMMENTS; CHANGED TO STANDARD 
C                                  RETURN SEQUENCE; ADDED IER = 402;
C                                  OMITTED EXISTS FROM CALL SEQUENCE
C        FEBRUARY 2001   GLAHN     CHECKED SIZE OF NS4; COMMENTS
C        NOVEMBER 2001   GLAHN     IER=1 CHANGED TO IER=3; REMOVED
C                                  DUPLICATE CHECK ON NS4; MOVED
C                                  IER AND ISEVERE TO TOP
C        JULY     2002   RUDACK    ADDED ADDTIONAL CASE STATEMENT TO
C                                  ACCOMMODATE TEMPLATE 4.9.
C
C        PURPOSE
C            UNPACKS SECTION 4, THE PRODUCT DEFINITION SECTION,
C            OF A GRIB2 MESSAGE.
C
C            THIS ROUTINE IS CAPABLE OF UNPACKING THE FOLLOWING
C            PRODUCT DEFINITION TEMPLATES:
C               TEMPLATE 4.0  ANALYSIS OR FORECAST AT A LEVEL AND POINT
C               TEMPLATE 4.1  INDIVIDUAL ENSEMBLE
C               TEMPLATE 4.2  DERIVED FORECAST BASED ON ENSEMBLES
C               TEMPLATE 4.8  AVERAGE, ACCUMULATION, EXTREMES
C               TEMPLATE 4.9  PROBABILITY FORECASTS AT A HORIZONTAL LEVEL
C               TEMPLATE 4.20 RADAR
C               TEMPLATE 4.30 SATELLITE
C
C        DATA SET USE
C           KFILDO - UNIT NUMBER FOR OUTPUT (PRINT) FILE. (OUTPUT
C                    FILE)
C
C        VARIABLES
C              KFILDO = UNIT NUMBER FOR OUTPUT (PRINT) FILE. (INPUT)
C            IPACK(J) = THE ARRAY THAT HOLDS THE ACTUAL PACKED MESSAGE
C                       (J=1,ND5). (INPUT/OUTPUT)
C                 ND5 = THE SIZE OF THE ARRAY IPACK( ). (INPUT)
C              IS4(J) = THE GRID DEFINITION DATA THAT IS UNPACKED FROM
C                       IPACK( ) IS PLACED INTO THIS ARRAY (J=1,NS4).
C                       (OUTPUT)
C                 NS4 = SIZE OF IS4( ). (INPUT)
C              L3264B = THE INTEGER WORD LENGTH IN BITS OF THE MACHINE
C                       BEING USED. VALUES OF 32 AND 64 ARE
C                       ACCOMMODATED. (INPUT)
C                LOCN = THE WORD POSITION FROM WHICH TO UNPACK THE
C                       NEXT VALUE. (INPUT/OUTPUT)
C                IPOS = THE BIT POSITION IN LOCN FROM WHICH TO START
C                       UNPACKING THE NEXT VALUE.  (INPUT/OUTPUT)
C                 IER = RETURN STATUS CODE. (OUTPUT)
C                         0 = GOOD RETURN.
C                       6-8 = ERROR CODES GENERATED BY UNPKBG. SEE THE
C                             DOCUMENTATION IN THE PKBG ROUTINE.
C                       401 = IS4(5) DOES NOT INDICATE SECTION 4.
C                       402 = IS4( ) HAS NOT BEEN DIMENSIONED LARGE
C                             ENOUGH TO CONTAIN THE TEMPLATE. 
C                       403 = IS4(8) DOES NOT CONTAIN A SUPPORTED 
C                             TEMPLATE NUMBER.
C                       499 = UNEXPECTED END OF MESSAGE.
C             ISEVERE = THE SEVERITY LEVEL OF THE ERROR.  THE ONLY
C                       VALUE RETUNED IS:
C                       2 = A FATAL ERROR  (OUTPUT)
C                   * = ALTERNATE RETURN WHEN IER NE 0.
C
C             LOCAL VARIABLES
C             LOCN4_1 = SAVES THE WORD POSITION LOCN IN IPACK
C                       UPON ENTRY TO STORE BACK TO LOCN IN CASE
C                       THERE IS A FATAL ERROR.
C             IPOS4_1 = SAVES THE BIT POSITION IPOS IN LOCN
C                       UPON ENTRY TO STORE BACK TO IPOS IN CASE
C                       THERE IS A FATAL ERROR.
C               LSECT = CONTAINS THE LENGTH OF SECTION 4
C                       AS UNPACKED FROM THE FIRST FOUR
C                       BYTES IN THE SECTION.
C               NSECT = SECTION NUMBER.
C                   K = A LOOPING INDEX VARIABLE.
C                   N = L3264B = THE INTEGER WORD LENGTH IN BITS OF
C                       THE MACHINE BEING USED. VALUES OF 32 AND
C                       64 ARE ACCOMMODATED.
C
C        NON SYSTEM SUBROUTINES CALLED
C           ENDOMESS, UNPKBG, UNPK_TEMP40, UNPK_TEMP41, UNPK_TEMP42,
C           UNPK_TEMP48, UNPK_TEMP420, UNPK_TEMP430, UNPK_TEMP49
C
      LOGICAL ENDOMESS
C
      DIMENSION IPACK(ND5),IS4(NS4)
C
      IER=0
      N=L3264B
C
C        ALL ERRORS GENERATED BY THIS ROUTINE ARE FATAL.
      ISEVERE=2
C
C        CHECK SIZE OF IS4( ).
C
      IF(NS4.LT.8)THEN
         IER=402
         GO TO 900
      ENDIF
C
C        UNPACK THE LENGTH OF THE SECTION, LSECT.
      LOCN4_1=LOCN
      IPOS4_1=IPOS
      CALL UNPKBG(KFILDO,IPACK,ND5,LOCN,IPOS,LSECT,32,N,IER,*900)
C
C        CHECK FOR AN UNEXPECTED END OF MESSAGE,
C        ACCOMMODATING FOR A 64-BIT WORD.
      IF(ENDOMESS(LSECT,N))THEN
         IER=499
         GO TO 900
      ENDIF
C
C        UNPACK THE NUMBER OF THE SECTION, NSECT. CHECK
C        TO MAKE SURE THAT THIS IS SECTION 4.
      CALL UNPKBG(KFILDO,IPACK,ND5,LOCN,IPOS,NSECT,8,N,IER,*900)
C
      IF(NSECT.NE.4)THEN
         IER=401
         LOCN=LOCN4_1
         IPOS=IPOS4_1
         GO TO 900
      ENDIF
C
      DO K=1,NS4
         IS4(K)=0
      ENDDO
C
      IS4(1)=LSECT
      IS4(5)=NSECT
C
C        UNPACK THE NUMBER OF COORDINATES VALUES AFTER
C        THE TEMPLATE.  THIS VALUE IS NOT USED IN THIS SOFTWARE.
      CALL UNPKBG(KFILDO,IPACK,ND5,LOCN,IPOS,IS4(6),16,N,IER,*900)
C
C        UNPACK PRODUCT DEFINITION TEMPLATE NUMBER
      CALL UNPKBG(KFILDO,IPACK,ND5,LOCN,IPOS,IS4(8),16,N,IER,*900)
C
c      SELECT CASE(IS4(8))
C
c      CASE(0)
       IF (IS4(8).EQ.0) THEN
C
C            AN ANALYSIS OR FORECAST AT A HORIZONTAL
C            LEVEL OR IN A HORIZONTAL LAYER AT A POINT
C            IN TIME (TEMPLATE 4.0).
         CALL UNPK_TEMP40(KFILDO,IPACK,ND5,IS4,NS4,L3264B,
     1                    LOCN,IPOS,IER,*900)
C
c      CASE(1)
       ELSEIF (IS4(8).EQ.1) THEN
C
C            AN INDIVIDUAL ENSEMBLE FORECAST, CONTROL AND
C            PERTURBED, AT A HORIZONTAL LEVEL OR IN A
C            HORIZONTAL LEVEL OR IN A HORIZONTAL LAYER AT
C            A POINT IN TIME (TEMPLATE 4.1).
         CALL UNPK_TEMP41(KFILDO,IPACK,ND5,IS4,NS4,L3264B,
     1                    LOCN,IPOS,IER,*900)
C
c      CASE(2)
       ELSEIF (IS4(8).EQ.2) THEN
C
C            A DERIVED FORECAST BASED ON ALL ENSEMBLE MEMBERS
C            AT A HORIZONTAL LEVEL OR IN A HORIZONTAL LAYER
C            AT A POINT IN TIME (TEMPLATE 4.2).
         CALL UNPK_TEMP42(KFILDO,IPACK,ND5,IS4,NS4,L3264B,
     1                    LOCN,IPOS,IER,*900)
C
c      CASE(8)
       ELSEIF (IS4(8).EQ.8) THEN
C
C           AVERAGE, ACCUMULATION, AND/OR EXTREME VALUES AT A
C           HORIZONTAL LEVEL OR IN A HORIZONTAL LAYER IN A
C           CONTINUOUS OR NON-CONTINUOUS TIME INTERVAL. 
         CALL UNPK_TEMP48(KFILDO,IPACK,ND5,IS4,NS4,L3264B,
     1                    LOCN,IPOS,IER,*900)
C
c      CASE(9)
       ELSEIF (IS4(8).EQ.9) THEN
C
C            A PROBABILITY FORECAST AT A HORIZONTAL LEVEL
C            OR IN A HORIZONTAL LAYER IN A CONTINUOUS OR
C            NON-CONTINUOUS TIME INTERVAL. (TEMPLATE 4.9)
C            (POP12)
         CALL UNPK_TEMP49(KFILDO,IPACK,ND5,IS4,NS4,L3264B,
     1                    LOCN,IPOS,IER,*900)
C
c      CASE(20)
       ELSEIF (IS4(8).EQ.20) THEN
C
C            A RADAR PRODUCT (TEMPLATE 4.20).
         CALL UNPK_TEMP420(KFILDO,IPACK,ND5,IS4,NS4,L3264B,
     1                     LOCN,IPOS,IER,*900)
C
c      CASE(30)
       ELSEIF (IS4(8).EQ.30) THEN
C
C            A SATELLITE PRODUCT (TEMPLATE 4.30).
         CALL UNPK_TEMP430(KFILDO,IPACK,ND5,IS4,NS4,L3264B,
     1                     LOCN,IPOS,IER,*900)
C
c      CASE DEFAULT 
       ELSE
C
C            THE PRODUCT TEMPLATE IS NOT SUPPORTED.
         IER = 403
C
c      END SELECT
       ENDIF
C
C       ERROR RETURN SECTION
C
 900  IF(IER.NE.0)RETURN 1
C
      RETURN
      END

      SUBROUTINE UNPKSECDIF(KFILDO,A,ND2X3,JMIN,LBIT,NOV,LX,NX,NY,
     1                      IPACK,ND5,IFIRST,ISECOND,ISECMIN,REF,
     2                      LOCN,IPOS,MAXGPREF,IMISSING,XMISSP,XMISSS,
     3                      ISCAL,SCAL10,SCAL2,L3264B,IER)
C
C        MAY      1999   GLAHN   TDL   GRIB2
C        JANUARY  2001   GLAHN   COMMENTS; CHANGED IER = 17 TO 502
C        FEBRUARY 2001   GLAHN   REMOVED XMISSX FROM CALL
C        FEBRUARY 2001   GLAHN   INSERTED SELECT CASE (ISCAL) IN 
C                                3 PLACES
C        NOVEMBER 2001   GLAHN   MODIFIED TO HANDLE PRIMARY MISSINGS
C                                PROPERLY WHEN A GROUP IS ALL OF ONE
C                                VALUE AND MISSING.  ADDED MAXGPREF TO
C                                CALL AND TO CALLS TO UNPKPO AND UNPKPS
C        NOVEMBER 2001   GLAHN   CHANGED IER=17 TO IER=705; COMMENTS
C                                ABOUT IWORK( )
C        OCTOBER  2002   GLAHN   CHANGED DIMENSION OF IWORK FROM ND5
C                                TO ND2X3, AND TEST ABOVE D339
C        OCTOBER  2002   GLAHN   CORRECTED ERROR RELATED TO ABOVE
C
C        PURPOSE
C            UNPACKS DATA IN THE SO-CALLED WMO "SECOND ORDER SPATIAL
C            DIFFERENCING" CORRESPONDING TO CODE TABLE 5.0 VALUE 
C            OF 3.  IT HANDLES (1) 2ND ORDER DIFFERENCE REMOVAL
C            CALLED COMPLEX PACKING BY GRIB, (2) 2ND ORDER SPATIAL
C            DIFFERENCES AND ALTERNATE ROW REVERSAL, AND (3)
C            PRIMARY AND SECONDARY MISSING VALUES.
C
C        DATA SET USE
C           KFILDO - UNIT NUMBER FOR OUTPUT (PRINT) FILE. (OUTPUT) 
C
C        VARIABLES 
C              KFILDO = UNIT NUMBER FOR OUTPUT (PRINT) FILE.  (INPUT) 
C              A(IXY) = GRID OF UNPACKED VALUES  (IXY=1,ND2X3).  THE
C                       VALUES WILL BE IN FORTRAN ARRAY FORMAT
C                       A(IX,JY), (IX=1,NX) (JY=1,NY).  (OUTPUT)
C               ND2X3 = SIZE OF A( ).  (OUTPUT)
C             JMIN(L) = THE MINIMUM VALUE SUBTRACTED FOR EACH GROUP
C                       L BEFORE PACKING (L=1,LX).  (INTERNAL)
C             LBIT(L) = THE NUMBER OF BITS NECESSARY TO HOLD THE
C                       PACKED VALUES FOR EACH GROUP L (L=1,LX). 
C                       (INTERNAL)
C              NOV(L) = THE NUMBER OF VALUES IN GROUP L (L=1,LX).
C                       (INTERNAL)
C                  LX = THE NUMBER OF VALUES IN LBIT( ), JMIN( ), AND
C                       NOV( ).  ALSO THEIR DIMENSIONS BY ALLOCATION.
C                       (INTERNAL)
C              NX, NY = SIZE OF DATA ARRAY FOR A( ).  (INPUT)
C            IPACK(J) = THE ARRAY HOLDING THE ACTUAL PACKED MESSAGE
C                       (J=1,MAX OF ND5).  (INPUT/OUTPUT)
C                 ND5 = DIMENSION OF IPACK( ).  (INPUT)
C              IFIRST = THE FIRST VALUE IN THE FIELD.  USED ONLY WHEN
C                       PACKING SECOND ORDER DIFFERENCES.  (INPUT)
C             ISECOND = THE SECOND ORIGINAL VALUE IN THE FIELD. USED
C                       ONLY WHEN PACKING SECOND ORDER DIFFERENCES.
C                       (INPUT)
C             ISECMIN =
C                 REF = THE MINIMUM VALUE THAT WAS SUBTRACTED BEFORE
C                       PACKING.  THIS IS ADDED BACK IN BEFORE RETURNING
C                       THE DATA IN A( ).  (INPUT)
C                LOCN = THE WORD POSITION FROM WHICH TO UNPACK THE
C                       NEXT VALUE. (INPUT/OUTPUT)
C                IPOS = THE BIT POSITION IN LOCN FROM WHICH TO START
C                       UNPACKING THE NEXT VALUE.  (INPUT/OUTPUT)
C            MAXGPREF = THE MAXIMUM VALUE THAT CAN BE STORED IN THE
C                       GROUP REFERENCES.  (INPUT)
C            IMISSING = REPRESENTS OCTET 23 OF SECTION 5. DETERMINES
C                       IF THERE ARE NO MISSING VALUES, PRIMARY MISSING
C                       VALUES, OR PRIMARY AND SECONDARY MISSING VALUES.
C                       (INPUT)
C              XMISSP = PRIMARY MISSING VALUE INDICATOR THAT IS 
C                       TO BE TREATED AS MISSING.  (INPUT)
C              XMISSS = SECONDARY MISSING VALUE INDICATOR.  (OUTPUT)
C               ISCAL = INDICATES COMBINATIONS OF SCALING.
C                       0 = NONE
C                       1 = DECIMAL ONLY
C                       2 = BINARY ONLY
C                       3 = BOTH DECIMAL AND BINARY
C              SCAL10 = DECIMAL SCALING PARAMETER.  (OUTPUT)
C               SCAL2 = BINARY SCALING PARAMETER.  (OUTPUT)
C              L3264B = INTEGER WORD LENGTH OF MACHINE BEING USED.
C                       (INPUT)
C                 IER = ERROR RETURNS:
C                         0 = GOOD RETURN.
C                         6 = NOT ENOUGH ROOM IN IPACK( ) OR IWORK( ) TO
C                             ACCOMMODATE THE DATA INDICATED BY LBIT( )
C                             AND NOV( ).
C                         7 = IPOS NOT IN RANGE 1 TO 32.
C                         8 = LBIT(L) NOT IN RANGE 0 TO 30.
C                       705 = ND5 NOT LARGE ENOUGH.
C              NVALUE = AN UNPACKED VALUE RETURNED FROM SUBROUTINE
C                       UNPKBG.  (INTERNAL)
C                KBIT = THE NUMBER OF BITS REQUIRED TO HOLD THE NUMBER
C                       OF VALUES IN EACH GROUP.  (INTERNAL)  
C                JBIT = THE NUMBER OF BITS REQUIRED TO HOLD THE NUMBER
C                       OF BITS REQUIRED FOR EACH GROUP'S VALUES.
C                       (INTERNAL)
C                MBIT = THE NUMBER OF BITS REQUIRED TO PACK THE
C                       ABSOLUTE VALUE OF THE FIRST FIRST ORDER  
C                       DIFFERENCE.  USED ONLY WHEN PACKING SECOND ORDER
C                       DIFFERENCES.  (INTERNAL)
C                NBIT = THE NUMBER OF BITS REQUIRED TO HOLD THE ABSOLUTE
C                       VALUE OF THE OVERALL MINIMUM, REF.  (INTERNAL)
C                IFOD = THE FIRST FIRST ORDER DIFFERENCE.  USED ONLY
C                       WHEN PACKING SECOND ORDER DIFFERENCES.
C                       (INTERNAL)
C                   N = WORKING COPY OF L3264B.  (INTERNAL)
C              LBYPWD = BYTES PER WORD FOR EITHER A 32- OR 64-BIT
C                       MACHINE.  (INTERNAL)
C            IWORK(J) = WORK ARRAY J(=1,ND2X3).  (INTERNAL)
C
C        NON-SYSTEM SUBROUTINES CALLED
C           UNPKOO, UNPKPO, UNPKPS
C
      DIMENSION A(ND2X3)
      DIMENSION IWORK(800000)
C        IWORK( ) IS AN AUTOMATIC ARRAY.
      DIMENSION IPACK(ND5)
      DIMENSION JMIN(LX),LBIT(LX),NOV(LX)
C
C        SET ERROR RETURN AND INITIALIZE VARIABLES.
      IER=0
      MISSP=INT(XMISSP)
      MISSS=INT(XMISSS)
      LBYPWD=L3264B/8
      NXY=NX*NY
C
C        LBYPWD IS THE BYTES PER WORD FOR EITHER A 32- OR 64-BIT
C        MACHINE.
      N=L3264B
C        THIS ASSIGNMENT IS MADE MAINLY TO KEEP MOST CALLS TO UNPKBG
C        TO ONE LINE.  IT MAY HELP THE COMPILER TO BE MORE EFFICIENT.
C
      IF(NXY.GT.ND2X3)THEN
D        WRITE(KFILDO,339)ND2X3,NXY
D339     FORMAT(/' ****DIMENSION ND2X3 ='I6,' NOT LARGE ENOUGH',
D    1           ' IN UNPKSECDIF.  INCREASE TO'I6)
          IER=705
          GOTO 910
       ENDIF
C
C       SET OSCAL10, THE RECIPROCAL OF SCAL10.
C
      OSCAL10=1./SCAL10
C
C        UNPACK THE DATA VALUES THEMSELVES.  THE ROUTINES
C        UNPKOO, UNPKPO, AND UNPKPS HANDLE THE CASE WHEN
C        THERE ARE NO MISSING VALUES, THERE CAN BE
C        PRIMARY MISSING VALUES, AND THERE CAN BE BOTH
C        PRIMARY AND SECONDARY MISSING VALUES, RESPECTIVELY.
C
 340  IF(IMISSING.EQ.0)THEN
         CALL UNPKOO(KFILDO,IPACK,ND5,LOCN,IPOS,JMIN,LBIT,
     1               NOV,LX,IWORK,ND2X3,L3264B,IER)
      ELSEIF(IMISSING.EQ.1)THEN
         CALL UNPKPO(KFILDO,IPACK,ND5,LOCN,IPOS,MISSP,JMIN,
     1               LBIT,NOV,LX,MAXGPREF,IWORK,ND2X3,L3264B,IER)
      ELSE
         CALL UNPKPS(KFILDO,IPACK,ND5,LOCN,IPOS,MISSP,MISSS,
     1               JMIN,LBIT,NOV,LX,IWORK,ND2X3,L3264B,IER)
      ENDIF
C
      IF(IER.NE.0)GO TO 910
C
C        ADD THE MINIMUM VALUE BACK INTO THE SECOND ORDER DIFFERENCE
C        FIELD
      IF(IMISSING.EQ.0)THEN
         DO 370 K=3,NXY 
            IWORK(K)=IWORK(K)+ISECMIN
 370     CONTINUE
      ELSE
         DO 380 K=3,NXY
            IF(IWORK(K).NE.MISSP)IWORK(K)=IWORK(K)+ISECMIN
 380     CONTINUE
      ENDIF
C
C        RECOVER FIELD FROM 2ND ORDER DIFFERENCES.
C
C        THIS LOOP IS FOR NO MISSING VALUES AND 2ND ORDER DIFFERENCES.
C
      IFOD=ISECOND-IFIRST
C
      IF(IMISSING.EQ.0)THEN
         IWORK(1)=IFIRST
         IWORK(2)=ISECOND
         ISUM=IFOD
C
         DO 385 K=3,NXY
            ISUM=IWORK(K)+ISUM
            IWORK(K)=IWORK(K-1)+ISUM
 385     CONTINUE
C
C        THIS LOOP FOR MISSING VALUES AND 2ND ORDER DIFFERENCES.
C
      ELSE
C
         KOUNT=0
         KSTART=1
C           THE ABOVE STATEMENT SHOULD NOT BE NEEDED.
C
         DO 387 K=1,NXY
         IF(IWORK(K).EQ.MISSP)GO TO 387
         KOUNT=KOUNT+1
C
         IF(KOUNT.EQ.1)THEN
            IWORK(K)=IFIRST
         ELSEIF(KOUNT.EQ.2)THEN
            IWORK(K)=IFIRST+IFOD
            ISUM=IFOD
            IWKEEP=IWORK(K)
            KSTART=K+1
            GO TO 388
         ENDIF
C 
 387     CONTINUE        
C   
         GO TO 391
C           THIS EXIT SHOULD NOT OCCUR, BECAUSE THIS WOULD 
C           INDICATE ALL VALUES WERE MISSING, AND ALL MISSING
C           VALUES SHOULD NOT HAVE BEEN PACKED WITH SECOND
C           ORDER DIFFERENCES.
 388     IF(KSTART.GT.NXY)GO TO 391
C           THE ABOVE TEST WOULD BE MET ONLY WHEN EXACTLY
C           TWO NON-MISSING VALUES WERE PACKED.
C
         DO 390 K=KSTART,NXY
         IF(IWORK(K).EQ.MISSP)GO TO 3880
         ISUM=IWORK(K)+ISUM
         IWORK(K)=IWKEEP+ISUM
         IWKEEP=IWORK(K)
C
 3880    CONTINUE
 390     CONTINUE
C
      ENDIF
C
C        DECODE THE ORIGINAL VALUES BASED UPON
C        WHETHER THERE ARE NO MISSING VALUES,
C        PRIMARY MISSING VALUES, OR PRIMARY AND
C        SECONDARY MISSING VALUES.
 391  IF(IMISSING.EQ.0)THEN
C
         DO 395 K=1,NXY
C
c
c            SELECT CASE (ISCAL)
c
c               CASE(0)
               IF (ISCAL.EQ.0) THEN
                  A(K)=IWORK(K)+REF
c               CASE(1)
               ELSEIF (ISCAL.EQ.1) THEN
                  A(K)=(IWORK(K)+REF)*OSCAL10
c               CASE(2)
               ELSEIF (ISCAL.EQ.2) THEN
                  A(K)=IWORK(K)*SCAL2+REF
c               CASE(3)
               ELSEIF (ISCAL.EQ.3) THEN
                  A(K)=(IWORK(K)*SCAL2+REF)*OSCAL10
c            END SELECT
               ENDIF
C
 395     CONTINUE
C
      ELSEIF(IMISSING.EQ.1)THEN
C
         DO 398 K=1,NXY
            IF(IWORK(K).EQ.MISSP)THEN
               A(K)=MISSP
            ELSE
C
c               SELECT CASE (ISCAL)
c                  CASE(0)
               IF (ISCAL.EQ.0) THEN
                     A(K)=IWORK(K)+REF
c                  CASE(1)
               ELSEIF (ISCAL.EQ.1) THEN
                     A(K)=(IWORK(K)+REF)*OSCAL10
c                  CASE(2)
               ELSEIF (ISCAL.EQ.2) THEN
                     A(K)=IWORK(K)*SCAL2+REF
c                  CASE(3)
               ELSEIF (ISCAL.EQ.3) THEN
                     A(K)=(IWORK(K)*SCAL2+REF)*OSCAL10
c                END SELECT
               ENDIF       
C
            ENDIF       
 398     CONTINUE
C
      ELSE
C
         DO 399 K=1,NXY
            IF(IWORK(K).EQ.MISSP)THEN
               A(K)=MISSP
            ELSEIF(IWORK(K).EQ.MISSS)THEN
               A(K)=MISSS
            ELSE
C
c               SELECT CASE (ISCAL)
c                  CASE(0)
               IF (ISCAL.EQ.0) THEN
                     A(K)=IWORK(K)+REF
c                  CASE(1)
               ELSEIF (ISCAL.EQ.1) THEN
                     A(K)=(IWORK(K)+REF)*OSCAL10
c                  CASE(2)
               ELSEIF (ISCAL.EQ.2) THEN
                     A(K)=IWORK(K)*SCAL2+REF
c                  CASE(3)
               ELSEIF (ISCAL.EQ.3) THEN
                     A(K)=(IWORK(K)*SCAL2+REF)*OSCAL10
c               END SELECT
               ENDIF       
C
            ENDIF       
 399     CONTINUE
      ENDIF
C
      RETURN
C
C        ERROR RETURN SECTION.
C
 910  DO 920 K=1,ND2X3
         A(K)=9999.
 920  CONTINUE
C
      RETURN
      END

      SUBROUTINE BOUNDARY(IPOS,LOCN)
C
C        AUGUST 2000   LAWRENCE    GSC/TDL    ORIGINAL CODING
C
C        PURPOSE
C           THIS ROUTINE DETERMINES IF IPOS AND LOCN POINT TO 
C           A BYTE BOUNDARY. IF THEY DO NOT, THEN THEIR VALUES
C           ARE INCREMENTED SO THAT THEY DO POINT TO A BYTE
C           BOUNDARY.
C
C        DATA SET USE
C           NONE
C
C        VARIABLES
C                IPOS = INDICATES THE BIT POSITION IN A 32-BIT
C                       WORD. (INPUT/OUTPUT)
C                LOCN = INDICATES THE BYTE POSITION IN A 32-BIT
C                       WORD.  (INPUT/OUTPUT)
C
C             LOCAL VARIABLES
C               IFILL = THE NUMBER OF BITS THAT MUST BE ADDED TO
C                       IPOS SO THAT IT POINTS TO A NEW BYTE
C                       BOUNDARY. 
C
C        NON SYSTEM SUBROUTINES CALLED
C           NONE
C
C        MAKE SURE THAT WE ARE POINTING TO A BYTE BOUNDARY.
      IFILL=MOD(33-IPOS,8)
C
C        IF IPOS IS NOT AT THE BEGINNING OF A BYTE (THAT IS
C        IF IT DOES NOT HAVE A VALUE OF 1, 9, 17, OR 25),
C        THEN ADD THE NUMBER OF BITS NECESSARY TO MAKE IT POINT
C        TO A BYTE BOUNDARY.
      IF (IFILL.NE.0) THEN
         IPOS=IPOS+IFILL
C
C           IF THE NEW VALUE FOR IPOS EXCEEDS A WORD BOUNDARY,
C           THEN SET IPOS TO 1 AND INCREMENT THE WORD POINTER
C           LOCN.
         IF(IPOS.GT.32) THEN
           IPOS=1
           LOCN=LOCN+1
         END IF
C
      END IF
C
      RETURN
      END

      LOGICAL FUNCTION ENDOMESS(LNUM,L3264B)
C
C        MARCH   2000   LAWRENCE    GSC/TDL    ORIGINAL CODING
C        JANUARY 2001   GLAHN       COMMENTS
C
C        PURPOSE
C            TESTS FOR THE END OF MESSAGE CONDITION IN A GRIB2
C            MESSAGE INDICATED BY THE CHARACTERS "7777" STORED IN THE 
C            FOUR BYTES OF SECTION 8.  WHEN AN END OF MESSAGE IS FOUND,
C            ENDOMESS RETURNS .TRUE.; OTHERWISE IT RETURNS .FALSE.
C
C            IF THE INTEGER VALUE IN LNUM IS EQUIVALENT TO
C            THE CHARACTER STRING "7777" THEN THIS FUNCTION
C            WILL RETURN A VALUE OF .TRUE.  OTHERWISE, IT
C            WILL RETURN A VALUE OF .FALSE.
C
C        DATA SET USE
C           NONE 
C
C        VARIABLES
C                LNUM = THE INTEGER VALUE WE ARE GOING TO TEST
C                       TO SEE IF IT IS EQUIVALENT TO THE
C                       CHARACTER STRING "7777".  (INPUT)
C              L3264B = THE INTEGER WORD LENGTH IN BITS OF THE MACHINE
C                       BEING USED. VALUES OF 32 AND 64 ARE
C                       ACCOMMODATED. (INPUT)
C
C             LOCAL VARIABLES
C               C7777 = CONTAINS THE CHARACTER STRING "7777".
C               I7777 = THIS VARIABLE IS EQUIVALENCED TO C7777.
C                       IT CONTAINS THE INTEGER VALUE REPRESENTED
C                       BY THE FOUR BYTES THAT COMPRISE C7777.
C               LNUM1 = TEMPORARILY CONTAINS THE VALUE OF LNUM.
C                       THIS ENSURES THAT THE VALUE OF LNUM
C                       IS NOT ALTERED BY THIS FUNCTION. 
C               
C
C        NON SYSTEM SUBROUTINES CALLED
C           NONE
C
      CHARACTER*4 C7777
C
      EQUIVALENCE (C7777,I7777)
C
      DATA C7777/'7777'/
C
C        IF THIS IS A MACHINE WITH A 64-BIT WORD,
C        WE NEED TO SHIFT THE CONTENTS OF LNUM
C        4 BYTES TO THE LEFT. HOWEVER, WE DON'T WANT TO 
C        AFFECT THE CONTENTS OF LNUM, SO DO ALL
C        PROCESSING ON LNUM1.
      LNUM1=LNUM
      IF(L3264B.EQ.64)LNUM1=ISHFT(LNUM,32)
C
      IF(LNUM1.EQ.I7777)THEN
         ENDOMESS=.TRUE.
      ELSE
         ENDOMESS=.FALSE.
      ENDIF
C
      RETURN
      END

      SUBROUTINE UNPKBG(KFILDO,IPACK,ND5,LOC,IPOS,NVALUE,NBIT,L3264B,
     1                  IER,*)
C
C        DECEMBER 1994   GLAHN   TDL   MOS-2000
C        APRIL    1997   GLAHN   CORRECTED COMMENT FOR NBIT.
C        MAY      1997   GLAHN   MODIFIED TO USE MVBITS RATHER THAN
C                                SHIFTING AND ORING
C 
C        PURPOSE 
C            UNPACKS NBIT BITS INTO THE WORD NVALUE FROM ARRAY
C            IPACK(ND5) STARTING IN WORD LOC, BIT IPOS.  THE WORD
C            POINTER LOC AND BIT POSITION POINTER IPOS ARE UPDATED
C            AS NECESSARY.  IF NBIT EQ 0, NVALUE IS RETURNED EQ 0,
C            AND THE POINTERS ARE NOT MOVED.  THE INTEGER WORD
C            LENGTH OF THE MACHINE BEING USED IS L32B4B.  THIS PACKING
C            ROUTINE WILL WORK ON EITHER A 32- OR 64-BIT MACHINE.
C            A MAXIMUM OF 32 BITS CAN BE UNPACKED ON A SINGLE CALL.
C
C        DATA SET USE 
C           KFILDO - UNIT NUMBER FOR OUTPUT (PRINT) FILE. (OUTPUT) 
C
C        VARIABLES 
C              KFILDO = UNIT NUMBER FOR OUTPUT (PRINT) FILE.  (INPUT)
C            IPACK(J) = ARRAY TO UNPACK FROM (J=1,ND5).  (INPUT)
C                 ND5 = DIMENSION OF IPACK( ).  (INPUT)
C                 LOC = WORD IN IPACK( ) TO START UNPACKING.  UPDATED
C                       AS NECESSARY AFTER UNPACKING IS COMPLETED.
C                       (INPUT-OUTPUT)
C                IPOS = BIT POSITION (COUNTING LEFTMOST BIT IN WORD
C                       AS 1) TO START UNPACKING.  MUST BE GE 1 AND
C                       LE L3264B.  UPDATED AS NECESSARY
C                       AFTER PACKING IS COMPLETED.  (INPUT-OUTPUT)
C              NVALUE = THE RIGHTMOST NBIT BITS IN NVALUE WILL
C                       BE FILLED FROM IPACK(LOC).  IPACK(LOC+1) IS
C                       USED IF NECESSARY.  RETURNED AS ZERO IF 
C                       IER NE 0.  (OUTPUT)
C                NBIT = SEE NVALUE.  MUST BE GE 0 AND LE 32.  (INPUT)   
C              L3264B = INTEGER WORD LENGTH OF MACHINE BEING USED.
C                       (INPUT)
C                 IER = STATUS RETURN:
C                       0 = GOOD RETURN.
C                       6 = LOC NOT IN RANGE 1 TO ND5.
C                       7 = IPOS NOT IN RANGE 1 TO L3264B.
C                       8 = NBIT NOT IN RANGE 0 TO 32.
C                   * = ALTERNATE RETURN WHEN IER NE 0.
C        NON SYSTEM SUBROUTINES CALLED
C            NONE
C
      DIMENSION IPACK(ND5)
C
C        CHECK CORRECTNESS OF INPUT AND SET STATUS RETURN.
C
      IER=0
      NVALUE=0
C        IF IER NE 0 OR NBIT EQ 0, NVALUE IS RETURNED EQ 0.
      IF(NBIT.EQ.0)GO TO 150
      IF(LOC.LT.1.OR.LOC.GT.ND5)IER=6
      IF(IPOS.LE.0.OR.IPOS.GT.L3264B)IER=7
      IF(NBIT.LT.0.OR.NBIT.GT.32)IER=8
      IF(IER.NE.0)RETURN 1      
C 
C        IT APPEARS MVBITS WON'T TRANSFER A FULL 32-BIT WORD,
C        WITH THE FORTRAN COMPILER ON HP 755'S, CONTRARY
C        TO THE HP DOCUMENTATION.  MUST BE A BUG.  TEST FOR THAT
C        HERE.  NBIT WILL RARELY BE 32, AND WITH A 64-BIT WORD,
C        THIS PROBLEM SHOULD NOT EXIST.  THIS BUG IS FIXED IN
C        UNIX 10.20, AND THE TEST CAN BE REMOVED WHEN ALL MACHINES
C        ARE UPGRADED.
C
      IF(NBIT.EQ.L3264B.AND.IPOS.EQ.1)THEN
         NVALUE=IPACK(LOC)
         LOC=LOC+1
         GO TO 150
      ENDIF
C
C        NORMAL PROCESSING BELOW.
C
      NEWIPOS=IPOS+NBIT
C
C        WHEN NEWIPOS LE L3264B+1, THEN ONLY ONE WORD IS UNPACKED FROM.
C        ELSE TWO WORDS ARE INVOLVED.
C
      IF(NEWIPOS.LE.L3264B+1)THEN
         CALL MVBITS(IPACK(LOC),L3264B+1-NEWIPOS,NBIT,NVALUE,0)
C
         IF(NEWIPOS.LE.L3264B)THEN
            IPOS=NEWIPOS
         ELSE
            IPOS=1
            LOC=LOC+1
         ENDIF
C
      ELSE
         NBIT1=L3264B+1-IPOS
         NBIT2=NBIT-NBIT1
         CALL MVBITS(IPACK(LOC),0,NBIT1,NVALUE,NBIT2)
         LOC=LOC+1
C
         IF(LOC.LE.ND5)GO TO 130
         IER=6
         NVALUE=0
         RETURN 1
C
 130     CALL MVBITS(IPACK(LOC),L3264B-NBIT2,NBIT2,NVALUE,0)
         IPOS=NBIT2+1
      ENDIF
C
 150  CONTINUE
      RETURN
      END

      SUBROUTINE UNPK_SECT7(KFILDO,A,ND2X3,NX,NY,IUNPKOPT,IPACK,
     1                      REF,ND5,IS5,NS5,IS7,NS7,IBITMAP,IB,XMISSP,
     2                      XMISSS,BOUST,L3264B,LOCN,IPOS,
     3                      IER,ISEVERE,*)
C
C        MARCH   2000   LAWRENCE   GSC/TDL    ORIGINAL CODING
C        JANUARY 2001   GLAHN      COMMENTS; CHANGED IER = 16 TO 708;
C                                  OMITTED EXISTS FROM CALL SEQUENCE;
C                                  ADDED IER = 701; ADDED TEST FOR
C                                  SECTION LENGTH WITH IER = 708;
C                                  ELIMINATED IS7( ) AND NS7 IN CALL
C                                  TO UNPK_CMPLX
C        FEBRUARY 2001   GLAHN     CHECKED SIZE OF NS7; COMMENTS
C        NOVEMBER 2001   GLAHN     ADDED DIMENSION IB(ND2X3)
C        MARCH    2002   GLAHN     CHANGED IER= 708 TO 709
C
C        PURPOSE
C            UNPACKS SECTION 7, THE DATA SECTION OF A GRIB2 MESSAGE.
C
C        DATA SET USE
C           KFILDO - UNIT NUMBER FOR OUTPUT (PRINT) FILE. (OUTPUT
C                    FILE)
C
C        VARIABLES
C              KFILDO = UNIT NUMBER FOR OUTPUT (PRINT) FILE. (INPUT)
C                A(J) = THE UNPACKED DATA (J=1,ND2X3).  (OUTPUT)
C               ND2X3 = THE SIZE OF A( ).  (INPUT)
C                  NX = THE NUMBER OF COLUMNS IN THE PRODUCT. (INPUT)
C                  NY = THE NUMBER OF ROWS IN THE PRODUCT. (INPUT)
C            IUNPKOPT = 0 DON'T UNPACK THIS DATA GRID. AN ERROR
C                         WAS ENCOUNTERED.
C                       1 UNPACK THIS GRID USING THE SIMPLE METHOD,
C                         LEAVE THE MISSING VALUES IN THE GRID,
C                         DO NOT RETURN A BIT-MAP.
C                       2 UNPACK THIS GRID USING THE SIMPLE METHOD,
C                         REMOVE THE MISSING VALUES FROM THE GRID,
C                         RETURN A BIT-MAP INDICATING MISSING VALUE
C                         LOCATIONS.
C                       3 UNPACK THIS GRID USING THE COMPLEX METHOD,
C                         LEAVE THE MISSING VALUES IN THE GRID,
C                         DO NOT RETURN A BIT-MAP.
C                       4 UNPACK THIS GRID USING THE COMPLEX METHOD,
C                         REMOVE THE MISSING VALUES FROM THE GRID,
C                         RETURN A BIT-MAP INDICATING MISSING VALUE
C                         LOCATIONS.
C                       5 UNPACK THIS GRID USING THE SECOND ORDER
C                         DIFFERENCES METHOD,
C                         LEAVE THE PRIMARY MISSING VALUES IN THE GRID,
C                         DO NOT RETURN A BIT-MAP.
C                       6 UNPACK THIS GRID USING THE SECOND ORDER
C                         DIFFERENCES METHOD,
C                         REMOVE THE PRIMARY MISSING VALUES FROM
C                         THE GRID,
C                         RETURN A BIT-MAP INDICATING THE PRIMARY
C                         MISSING VALUE LOCATIONS.
C                         (INPUT)
C            IPACK(J) = THE ARRAY THAT HOLDS THE ACTUAL PACKED MESSAGE
C                       (J=1,ND5). (INPUT/OUTPUT)
C                 REF = THE REFERENCE VALUE OF THE FIELD. (INPUT)
C                 ND5 = THE SIZE OF THE ARRAY IPACK( ). (INPUT)
C              IS5(J) = THE GRID DEFINITION DATA THAT IS UNPACKED FROM
C                       IPACK( ) IS PLACED INTO THIS ARRAY (J=1,NS5).
C                       (OUTPUT)
C                 NS5 = SIZE OF IS5( ). (INPUT)
C              IS7(J) = THE DATA THAT IS UNPACKED FROM
C                       IPACK( ) IS PLACED INTO THIS ARRAY (J=1,NS7).
C                       (OUTPUT)
C                 NS7 = SIZE OF IS7( ). (INPUT)
C             IBITMAP = 1 IF THERE WAS A BIT-MAP PACKED INTO
C                       THIS GRIB2 MESSAGE.
C                       0 IF THERE WAS NOT A BIT-MAP IN THIS
C                       GRIB2 MESSAGE. (LOGICAL) (INPUT)
C               IB(K) = WORK ARRAY (K=1,ND2X3).  HOLDS BIT-MAP,
C                       IF ONE IS PRESENT. (INPUT)
C              XMISSP = PRIMARY MISSING VALUE INDICATOR.  RETURNED AS
C                       ZERO WHEN THERE ARE NO VALUES IN ARRAY A( , )
C                       THAT WERE TREATED AS MISSING.  (INPUT)
C              XMISSS = SECONDARY MISSING VALUE INDICATOR.  RETURNED AS
C                       ZERO WHEN THERE ARE NO SECONDARY MISSING
C                       VALUES.  THIS VALUE DOES NOT APPLY TO SIMPLE
C                       OR COMPLEX PACKING.  (INPUT)
C               BOUST = .TRUE. IF THE DATA FIELD WAS SCANNED
C                       BOUSTROPHEDONICALLY. .FALSE. OTHERWISE.
C                       (LOGICAL) (INPUT)
C              L3264B = THE INTEGER WORD LENGTH IN BITS OF THE MACHINE
C                       BEING USED. VALUES OF 32 AND 64 ARE
C                       ACCOMMODATED. (INPUT)
C                LOCN = THE WORD POSITION FROM WHICH TO UNPACK THE
C                       NEXT VALUE. (INPUT/OUTPUT)
C                IPOS = THE BIT POSITION IN LOCN FROM WHICH TO START
C                       UNPACKING THE NEXT VALUE.  (INPUT/OUTPUT)
C                 IER = RETURN STATUS CODE. (OUTPUT)
C                         0 = GOOD RETURN.
C                       6-8 = ERROR CODES GENERATED BY UNPKBG. SEE THE
C                             DOCUMENTATION IN THE PKBG ROUTINE.
C                       701 = IS7(5) DOES NOT INDICATE SECTION 7.
C                       702 = IS7( ) HAS NOT BEEN DIMENSIONED LARGE
C                             ENOUGH TO CONTAIN THE ENTIRE TEMPLATE. 
C                       709 = TYPE OF PACKING UNRECOGNIZED.
C                       799 = UNEXPECTED END OF MESSAGE.
C                   * = ALTERNATE RETURN WHEN IER NE 0.
C
C             LOCAL VARIABLES
C             LOCN7_1 = SAVES THE WORD POSITION LOCN IN IPACK
C                       UPON ENTRY TO STORE BACK TO LOCN IN CASE
C                       THERE IS A FATAL ERROR.
C             IPOS7_1 = SAVES THE BIT POSITION IPOS IN LOCN
C                       UPON ENTRY TO STORE BACK TO IPOS IN CASE
C                       THERE IS A FATAL ERROR.
C               LSECT = CONTAINS THE LENGTH OF SECTION 7
C                       AS UNPACKED FROM THE FIRST FOUR
C                       BYTES IN THE SECTION.
C               NSECT = SECTION NUMBER.
C                   K = A LOOPING INDEX VARIABLE.
C                   N = L3264B = THE INTEGER WORD LENGTH IN BITS OF
C                       THE MACHINE BEING USED. VALUES OF 32 AND
C                       64 ARE ACCOMMODATED.
C
C        NON SYSTEM SUBROUTINES CALLED
C           ENDOMESS, UNPK_SMPLE, UNPK_CMPLX, UNPKBG
C
      DIMENSION A(ND2X3),IB(ND2X3)
      DIMENSION IPACK(ND5)
      DIMENSION IS5(NS5),IS7(NS7)
C
      LOGICAL BOUST,ENDOMESS
C
      N=L3264B
      IER=0
C
C        CHECK THE DIMENSIONS OF IS7( ).
C
      IF(NS7.LT.6)THEN
         IER=702
         GO TO 900
      ENDIF
C
C        ALL ERRORS GENERATED BY THIS ROUTINE ARE FATAL.
      ISEVERE=2
C
      LOCN7_1=LOCN
      IPOS7_1=IPOS
C
C        UNPACK THE LENGTH OF THE SECTION, LSECT.
      CALL UNPKBG(KFILDO,IPACK,ND5,LOCN,IPOS,LSECT,32,N,IER,*900)
C
C        CHECK FOR AN UNEXPECTED END OF MESSAGE,
C        ACCOMMODATING FOR A 64-BIT WORD.
      IF(ENDOMESS(LSECT,N))THEN
         IER=799
         GO TO 900
      ENDIF
C
C        UNPACK THE NUMBER OF THE SECTION, NSECT. CHECK
C        TO MAKE SURE THAT THIS IS SECTION 7.
      CALL UNPKBG(KFILDO,IPACK,ND5,LOCN,IPOS,NSECT,8,N,IER,*900)
C
      IF(NSECT.NE.7)THEN
         IER=701
         LOCN=LOCN7_1
         IPOS=IPOS7_1
         GO TO 900
      ENDIF
C
      DO K=1,NS7
         IS7(K)=0
      ENDDO
C
      IS7(1)=LSECT
      IS7(5)=NSECT
C
c      SELECT CASE (IUNPKOPT)
C
c         CASE (0)
        IF (IUNPKOPT.EQ.0) then
          continue
C
c         CASE (1:2)
        ELSEIF (IUNPKOPT.GE.1.AND.IUNPKOPT.LE.2) then
C
C              USE THE SIMPLE METHOD TO UNPACK THIS GRIB2 MESSAGE.
            CALL UNPK_SMPLE(KFILDO,A,ND2X3,NX,NY,IPACK,ND5,LOCN,IPOS,
     1                      IS5,NS5,IS7,NS7,IBITMAP,IB,IUNPKOPT,L3264B,
     2                      REF,XMISSP,IER,*900)
C
c         CASE (3:6)
        ELSEIF (IUNPKOPT.GE.3.AND.IUNPKOPT.LE.6) then
C
C              USE THE COMPLEX METHOD (WITH OR WITHOUT SECOND
C              ORDER SPATIAL DIFFERENCES) TO UNPACK THIS GRIB2 
C              MESSAGE.
            CALL UNPK_CMPLX(KFILDO,A,ND2X3,NX,NY,IPACK,ND5,LOCN,IPOS,
     1                      IS5,NS5,IBITMAP,IB,IUNPKOPT,BOUST,
     2                      L3264B,REF,XMISSP,XMISSS,IER,*900)
C
c         CASE DEFAULT
         ELSE
C
C              THE METHOD OF UNPACKING IS NOT SUPPORTED.
            IER=709
c      END SELECT
         ENDIF
C
C        ERROR RETURN SECTION
 900  IF(IER.NE.0)RETURN 1
C
      RETURN
      END

      SUBROUTINE UNPK_REFER(IS5,NS5,ICLEAN,IUNPKOPT,IER,*)
C
C        APRIL   2000   LAWRENCE   GSC/TDL   ORIGINAL CODING
C        JANUARY 2001   GLAHN      COMMENTS; CHANGED IER = 1040 TO 708;
C                                  INITIALIZED IUNPKOPT TO 0
C
C        PURPOSE
C           DETERMINES WHAT PACKING SCHEME WAS USED TO PACK THE DATA.
C           DETERMINES WHETHER OR NOT THE USER WANTS THE DATA RETURNED
C           WITH OR WITHOUT MISSING VALUES IMBEDDED IN IT. IF THE USER
C           DOESN'T WANT MISSING VALUES IMBEDDED WITHIN THE DATA FIELD,
C           THEN A BIT-MAP IS RETURNED TO THE USER INDICATING THE
C           LOCATIONS OF THE MISSING VALUES. IF THE USER WANTS MISSING
C           VALUES TO BE INCLUDED IN THE DATA FIELD, THEN NO BIT-MAP
C           IS RETURNED FROM THIS ROUTINE. THE ONLY EXCEPTION TO
C           THIS IS WHEN THE USER HAS A PREDEFINED BIT-MAP. IN THIS
C           CASE, A BIT-MAP IS NOT RETURNED TO THE USER, AND THE
C           DATA FIELD IS RETURNED WITHOUT MISSING VALUES IN IT.
C
C           THE ONLY PACKING METHOD IN WHICH A BIT-MAP IS PACKED INTO
C           THE GRIB2 MESSAGE ALONG WITH THE DATA FIELD IS THE SIMPLE
C           PACKING METHOD. FOR THE COMPLEX AND SECOND ORDER
C           DIFFERENCING METHODS OF PACKING DATA, A BIT-MAP IS NOT
C           ACTUALLY PACKED INTO THE GRIB2 MESSAGE. MISSING VALUES
C           ARE INCLUDED IN THE PACKED DATA. IF THE USER DESIRES A
C           BIT-MAP WITH THESE PACKING METHODS THEN THE PROGRAM
C           WILL GENERATE ONE.
C
C           IN ADDITION TO PRIMARY MISSING VALUES, THE COMPLEX
C           PACKING METHOD ALLOWS FOR THE EXISTENCE OF SECONDARY
C           MISSING VALUES. IF THE USER WANTS A BIT-MAP RETURNED
C           FROM THE UNPACKING OF A DATA FIELD THAT HAS BOTH
C           PRIMARY AND SECONDARY MISSING VALUES IN IT, AND THIS
C           DATA WAS PACKED USING THE COMPLEX METHOD, THEN ONLY
C           THE LOCATIONS OF THE PRIMARY MISSING VALUES WILL BE
C           INDICATED BY THE BIT-MAP. IN THIS CASE, ONLY THE
C           PRIMARY MISSING VALUES WILL BE REMOVED FROM THE
C           DATA FIELD.
C
C        DATA SET USE
C           NONE
C        VARIABLES
C              IS5(J) = THE VALUES ASSOCIATED WITH SECTION 5, KEYED
C                       TO THE OCTET NUMBER.  THE ELEMENTS USED
C                       IN THIS ROUTINE ARE:
C                       IS5(10), TEMPLATE NUMBER:
C                       0 = SIMPLE
C                       1 = NOT SUPPORTED
C                       2 = COMPLEX
C                       3 = SPATIAL DIFFERENCING
C                       (J=1,NS5). (INPUT)
C                 NS5 = SIZE OF IS5( ). (INPUT)
C              ICLEAN = 1 WHEN THE USER DOESN'T WANT PRIMARY MISSING
C                         VALUES IN THE UNPACKED DATA FIELD.
C                       0 WHEN THE USER WANTS PRIMARY MISSING VALUES
C                         TO BE LEFT IN THE UNPACKED DATA FIELD. 
C                         (INPUT)
C            IUNPKOPT = 0 DON'T UNPACK THIS DATA GRID. AN ERROR
C                         WAS ENCOUNTERED. 
C                       1 UNPACK THIS GRID USING THE SIMPLE METHOD,
C                         LEAVE THE MISSING VALUES IN THE GRID,
C                         DO NOT RETURN A BIT-MAP. 
C                       2 UNPACK THIS GRID USING THE SIMPLE METHOD,
C                         REMOVE THE MISSING VALUES FROM THE GRID,
C                         RETURN A BIT-MAP INDICATING MISSING VALUE
C                         LOCATIONS. 
C                       3 UNPACK THIS GRID USING THE COMPLEX METHOD,
C                         LEAVE THE MISSING VALUES IN THE GRID,
C                         DO NOT RETURN A BIT-MAP.
C                       4 UNPACK THIS GRID USING THE COMPLEX METHOD,
C                         REMOVE THE MISSING VALUES FROM THE GRID,
C                         RETURN A BIT-MAP INDICATING MISSING VALUE
C                         LOCATIONS.
C                       5 UNPACK THIS GRID USING COMPLEX PACKING
C                         WITH SECOND ORDER SPATIAL DIFFERENCES.
C                         LEAVE THE PRIMARY MISSING VALUES IN THE GRID,
C                         DO NOT RETURN A BIT-MAP.
C                       6 UNPACK THIS GRID USING COMPLEX PACKING
C                         WITH SECOND ORDER SPATIAL DIFFERENCES.
C                         REMOVE THE PRIMARY MISSING VALUES FROM
C                         THE GRID.
C                         RETURN A BIT-MAP INDICATING THE PRIMARY
C                         MISSING VALUE LOCATIONS.
C                         (OUTPUT)
C                 IER = RETURN STATUS CODE. (OUTPUT)
C                         0 = GOOD RETURN.
C                       708 = INVALID UNPACKING OPTION INDICATED IN
C                             IS5(10).
C                   * = ALTERNATE RETURN WHEN IER NE 0 FROM
C                       SUBROUTINES.
C
C             LOCAL VARIABLES
C             IUNPACK = CONTAINS THE CODE OF THE METHOD TO USE
C                       FOR UNPACKING AS GIVEN BY IS5(10).  INITIALIZED
C                       TO ZERO.
C
C        NON SYSTEM SUBROUTINES CALLED
C           NONE 
C
      DIMENSION IS5(NS5)
C
      IER=0
      IUNPKOPT=0
C
C        RETRIEVE THE UNPACKING METHOD FROM IS5(10)
      IUNPACK=IS5(10)
C
c      SELECT CASE (IUNPACK)
C
c         CASE (0)
         IF (IUNPACK.EQ.0) THEN
C
C              SIMPLE UNPACKING
            IF(ICLEAN.EQ.0)THEN
               IUNPKOPT=1
            ELSE
               IUNPKOPT=2
            ENDIF
C
c         CASE (2)
         ELSEIF (IUNPACK.EQ.2) THEN
C
C              COMPLEX UNPACKING
            IF(ICLEAN.EQ.0)THEN
               IUNPKOPT=3
            ELSE
               IUNPKOPT=4
            ENDIF
C
c         CASE (3)
         ELSEIF (IUNPACK.EQ.3) THEN
C
C              SECOND ORDER SPATIAL DIFFERENCES
            IF(ICLEAN.EQ.0)THEN
               IUNPKOPT=5
            ELSE
               IUNPKOPT=6
            ENDIF
C
c         CASE DEFAULT
         ELSE
C
C              INVALID UNPACKING OPTION.
            IER=708
c      END SELECT
         ENDIF
C
      IF(IER.NE.0)RETURN 1
C
      RETURN
      END

      SUBROUTINE UNPK_SECT3(KFILDO,IPACK,ND5,IS3,NS3,L3264B,
     1                      LOCN,IPOS,NX,NY,EXISTS,BOUST,IER,
     2                      ISEVERE,*)
C
C        MARCH    2000   LAWRENCE   GSC/TDL   ORIGINAL CODING
C        JANUARY  2001   GLAHN      COMMENTS; CHANGED IER = 14 TO
C                                   303 AND IER = 99 TO 399
C        FEBRUARY 2001   GLAHN      CHECKED SIZE OF NS3; COMMENTS
C        MARCH    2001   LAWRENCE   CHANGED HOW THE ROUTINE EXITS
C                                   IF IT DETERMINES THAT THERE IS
C                                   NO SECTION 3.  A NON-FATAL RETURN
C                                   IS NEEDED. 
C        NOVEMBER 2001   GLAHN      MOVED ISEVERE=2 UP TO BEGINNING
C
C        PURPOSE
C            UNPACKS SECTION 3, THE GRID DEFINITION SECTION, OF A
C            GRIB2 MESSAGE.
C
C            THIS ROUTINE IS CAPABLE OF UNPACKING THE FOLLOWING
C            GRID DEFINITION TEMPLATES:
C               TEMPLATE 3.0   EQUIDISTANT CYLINDRICAL LATITUDE/LONGITUDE
C               TEMPLATE 3.10  MERCATOR
C               TEMPLATE 3.20  POLAR STEREOGRAPHIC
C               TEMPLATE 3.30  LAMBERT
C               TEMPLATE 3.90  ORTHOGRAPHIC SPACE VIEW
C               TEMPLATE 3.110 EQUATORIAL AZIMUTHAL EQUIDISTANT
C               TEMPLATE 3.120 AZIMUTH-RANGE (RADAR)
C
C        DATA SET USE
C           KFILDO - UNIT NUMBER FOR OUTPUT (PRINT) FILE. (OUTPUT)
C
C        VARIABLES
C              KFILDO = UNIT NUMBER FOR OUTPUT (PRINT) FILE. (INPUT)
C            IPACK(J) = THE ARRAY THAT HOLDS THE ACTUAL PACKED MESSAGE
C                       (J=1,ND5). (INPUT/OUTPUT)
C                 ND5 = THE SIZE OF THE ARRAY IPACK( ). (INPUT)
C              IS3(J) = THE GRID DEFINITION DATA THAT IS UNPACKED
C                       FROM IPACK( ) IS PLACED INTO THIS ARRAY
C                       (J=1,NS3).  (INPUT)
C                 NS3 = SIZE OF IS3( ). (INPUT)
C              L3264B = THE INTEGER WORD LENGTH IN BITS OF THE MACHINE
C                       BEING USED. VALUES OF 32 AND 64 ARE
C                       ACCOMMODATED. (INPUT)
C                LOCN = THE WORD POSITION FROM WHICH TO UNPACK THE
C                       NEXT VALUE. (INPUT/OUTPUT)
C                IPOS = THE BIT POSITION IN LOCN FROM WHICH TO START
C                       UNPACKING THE NEXT VALUE.  (INPUT/OUTPUT)
C                  NX = THE NUMBER OF COLUMNS IN THE PRODUCT.
C                  NY = THE NUMBER OF ROWS IN THE PRODUCT.
C              EXISTS = .TRUE. IF SECTION 3 EXISTS IN THIS GRIB2
C                          MESSAGE.
C                       .FALSE. IF SECTION 3 DOESN'T EXIST IN THIS
C                        GRIB2 MESSAGE. (LOGICAL) (OUTPUT)
C               BOUST = .TRUE. IF THE DATA FIELD WAS SCANNED
C                       BOUSTROPHEDONICALLY. .FALSE. OTHERWISE.
C                       (LOGICAL) (OUTPUT)
C                 IER = RETURN STATUS CODE. (OUTPUT)
C                         0 = GOOD RETURN.
C                       6-8 = ERROR CODES GENERATED BY PKBG. SEE THE
C                             DOCUMENTATION IN THE UNPKBG ROUTINE.
C                       300 = IS3(5) DOES NOT INDICATE SECTION 3.
C                       302 = IS3( ) HAS NOT BEEN DIMENSIONED LARGE
C                             ENOUGH TO CONTAIN THE ENTIRE TEMPLATE. 
C                       303 = UNSUPPORTED GRID TEMPLATE INDICATED 
C                             BY IS3(13).
C                       307 = UNRECOGNIZED OR UNSUPPORTED SHAPE OF
C                             EARTH CODE IN IS3(15) RETURNED FROM
C                             UNEARTH CALLED FROM TEMPLATE UNPACKING
C                             ROUTINES.
C                       399 = UNEXPECTED END OF MESSAGE.
C             ISEVERE = THE SEVERITY LEVEL OF THE ERROR.  THE ONLY
C                       VALUE RETUNED IS:
C                       2 = A FATAL ERROR  (OUTPUT)
C                   * = ALTERNATE RETURN WHEN IER NE 0.
C
C             LOCAL VARIABLES
C             LOCN3_1 = SAVES THE WORD POSITION LOCN IN IPACK
C                       UPON ENTRY TO STORE BACK TO LOCN IN CASE
C                       THERE IS A FATAL ERROR.
C             IPOS3_1 = SAVES THE BIT POSITION IPOS IN LOCN
C                       UPON ENTRY TO STORE BACK TO IPOS IN CASE
C                       THERE IS A FATAL ERROR.
C               LSECT = CONTAINS THE LENGTH OF SECTION 3
C                       AS UNPACKED FROM THE FIRST FOUR
C                       BYTES IN THE SECTION.
C               NSECT = SECTION NUMBER.
C                   K = A LOOPING INDEX VARIABLE.
C                   N = L3264B = THE INTEGER WORD LENGTH IN BITS OF
C                       THE MACHINE BEING USED. VALUES OF 32 AND
C                       64 ARE ACCOMMODATED.
C
C        NON SYSTEM SUBROUTINES CALLED
C           ENDOMESS, UNPKBG, UNPK_AZIMUTH, UNPK_CYLINDER,
C           UNPK_EQUATOR, UNPK_LAMBERT, UNPK_MERCATOR,
C           UNPK_POLSTER, UNPK_ORTHOGRAPHIC
C
      LOGICAL BOUST,EXISTS,ENDOMESS
C
      DIMENSION IPACK(ND5),IS3(NS3)
C
      N=L3264B
      IER=0
C
C        ALL ERRORS GENERATED BY THIS ROUTINE ARE FATAL.
      ISEVERE=2
C
C        CHECK SIZE OF IS3( ).
C
      IF(NS3.LT.13)THEN
         IER=302
         GO TO 900
      ENDIF
C
      EXISTS=.TRUE.
C
C        UNPACK SECTION LENGTH, LSECT.
      LOCN3_1=LOCN
      IPOS3_1=IPOS
      CALL UNPKBG(KFILDO,IPACK,ND5,LOCN,IPOS,LSECT,32,N,IER,*900) 
C
C        CHECK FOR AN UNEXPECTED END OF MESSAGE,
C        ACCOMMODATING FOR A 64-BIT WORD.
C
      IF(ENDOMESS(LSECT,N))THEN
         IER=399
         GO TO 900
      ENDIF
C
C        UNPACK THE SECTION NUMBER. CHECK TO MAKE SURE THAT
C        THIS IS SECTION 3.
      CALL UNPKBG(KFILDO,IPACK,ND5,LOCN,IPOS,NSECT,8,N,IER,*900)
C
      IF(NSECT.NE.3)THEN
         EXISTS=.FALSE.
         LOCN=LOCN3_1
         IPOS=IPOS3_1
         GO TO 900
      ENDIF
C
      DO K=1,NS3
         IS3(K)=0
      ENDDO
C
      IS3(1)=LSECT
      IS3(5)=NSECT
C
C        UNPACK THE SOURCE OF GRID DEFINITION
      CALL UNPKBG(KFILDO,IPACK,ND5,LOCN,IPOS,IS3(6),8,N,IER,*900)
C
C        UNPACK THE NUMBER OF DATA POINTS
      CALL UNPKBG(KFILDO,IPACK,ND5,LOCN,IPOS,IS3(7),32,N,IER,*900)
C
C        UNPACK THE NUMBER OF OCTETS FOR OPTIONAL LIST OF NUMBERS
C        DEFINING NUMBER OF POINTS.
      CALL UNPKBG(KFILDO,IPACK,ND5,LOCN,IPOS,IS3(11),8,N,IER,*900)
C
C        UNPACK THE INTERPRETATION OF LIST OF NUMBERS DEFINING
C        NUMBER OF POINTS. 
      CALL UNPKBG(KFILDO,IPACK,ND5,LOCN,IPOS,IS3(12),8,N,IER,*900)
C
C        UNPACK GRID DEFINITION TEMPLATE NUMBER
      CALL UNPKBG(KFILDO,IPACK,ND5,LOCN,IPOS,IS3(13),16,N,IER,*900)
C
C        UNPACK THE VALUES FOR THE TYPE OF PROJECTION THE
C        GRID IS ON.
C
c      SELECT CASE (IS3(13))
C
c      CASE(0)
       IF (IS3(13).EQ.0) THEN
C
C           THIS IS A LATITUDE/LONGITUDE (OR EQUIDISTANT CYLINDRICAL)
C           PROJECTION.
         CALL UNPK_CYLINDER(KFILDO,IPACK,ND5,IS3,NS3,N,LOCN,IPOS,
     1                      BOUST,IER,*900)
         NX=IS3(31)
         NY=IS3(35)
C
c      CASE(10)
       ELSEIF (IS3(13).EQ.10) THEN
C
C           THIS IS A MERCATOR PROJECTION
         CALL UNPK_MERCATOR(KFILDO,IPACK,ND5,IS3,NS3,N,LOCN,IPOS,
     1                     BOUST,IER,*900)
         NX=IS3(31)
         NY=IS3(35)
C
c      CASE (20)
       ELSEIF (IS3(13).EQ.20) THEN
C
C           POLAR STEREOGRAPHIC MAP PROJECTION.
         CALL UNPK_POLSTER(KFILDO,IPACK,ND5,IS3,NS3,N,LOCN,IPOS,
     1                     BOUST,IER,*900)
         NX=IS3(31)
         NY=IS3(35)
C
c      CASE(30)
       ELSEIF (IS3(13).EQ.30) THEN
C
C           THIS IS A LAMBERT CONFORMAL PROJECTION
         CALL UNPK_LAMBERT(KFILDO,IPACK,ND5,IS3,NS3,N,LOCN,IPOS, 
     1                     BOUST,IER,*900)
         NX=IS3(31)
         NY=IS3(35)
C
c      CASE(90)
       ELSEIF (IS3(13).EQ.90) THEN
C
C           THIS IS A SPACE VIEW PERSPECTIVE OR ORTHOGRAPHIC
C           PROJECTION.
         CALL UNPK_ORTHOGRAPHIC(KFILDO,IPACK,ND5,IS3,NS3,N,LOCN,
     1                          IPOS,BOUST,IER,*900)
         NX=IS3(31)
         NY=IS3(35)
C
c      CASE(110)
       ELSEIF (IS3(13).EQ.110) THEN
C
C           EQUATORIAL AZIMUTHAL EQUIDISTANT PROJECTION
         CALL UNPK_EQUATOR(KFILDO,IPACK,ND5,IS3,NS3,N,LOCN,IPOS,
     1                     BOUST,IER,*900)
         NX=IS3(31)
         NY=IS3(35)
C
c      CASE(120)
       ELSEIF (IS3(13).EQ.120) THEN
C
C           AZIMUTHAL RANGE PROJECTION
         CALL UNPK_AZIMUTH(KFILDO,IPACK,ND5,IS3,NS3,N,LOCN,IPOS,
     1                     BOUST,IER,*900)
         NX=IS3(15)
         NY=IS3(19)
C
c      CASE DEFAULT
       ELSE
C
C           THE MAP PROJECTION IS NOT SUPPORTED.
         IER=303
C
c      END SELECT
       ENDIF
C
C       ERROR RETURN SECTION
 900  IF(IER.NE.0)RETURN 1
C
      RETURN
      END

      SUBROUTINE UNPK_SECT0(KFILDO,IPACK,ND5,IS0,NS0,L3264B,
     1                      LOCN,IPOS,IER,ISEVERE,*)
C
C        MARCH    2000   LAWRENCE  GSC/TDL   ORIGINAL CODING
C        JANUARY  2001   GLAHN     COMMENTS
C        FEBRUARY 2001   GLAHN     CHECKED SIZE OF NS0
C        MARCH    2001   LAWRENCE  CHANGED HOW THIS ROUTINE VALIDATES
C                                  THAT THE GRIB2 MESSAGE STARTS WITH
C                                  THE NUMERIC EQUIVALENT OF THE
C                                  STRING "GRIB".
C        NOVEMBER 2001   GLAHN     MOVED ISEVERE=2 UP TO BEGINNING
C
C        PURPOSE
C            UNPACKS SECTION 0, THE INDICATOR SECTION, OF A GRIB2
C            MESSAGE.
C
C        DATA SET USE
C           KFILDO - UNIT NUMBER FOR OUTPUT (PRINT) FILE. (OUTPUT)
C
C        VARIABLES
C              KFILDO = UNIT NUMBER FOR OUTPUT (PRINT) FILE. (INPUT)
C            IPACK(J) = THE ARRAY THAT HOLDS THE ACTUAL PACKED MESSAGE
C                       (J=1,ND5). (INPUT/OUTPUT)
C                 ND5 = THE SIZE OF THE ARRAY IPACK( ). (INPUT)
C              IS0(J) = CONTAINS THE INDICATOR DATA THAT
C                       WILL BE UNPACKED FROM IPACK( ) (J=1,NS0).
C                       (OUTPUT)
C                 NS0 = SIZE OF IS0( ). (INPUT)
C              L3264B = THE INTEGER WORD LENGTH IN BITS OF THE MACHINE
C                       BEING USED. VALUES OF 32 AND 64 ARE
C                       ACCOMMODATED. (INPUT)
C                LOCN = THE WORD POSITION FROM WHICH TO UNPACK THE
C                       NEXT VALUE. (INPUT/OUTPUT)
C                IPOS = THE BIT POSITION IN LOCN FROM WHICH TO START
C                       UNPACKING THE NEXT VALUE.  (INPUT/OUTPUT)
C                 IER = RETURN STATUS CODE. (OUTPUT)
C                          0 = GOOD RETURN.
C                        6-8 = ERROR CODES GENERATED BY UNPKBG. SEE THE
C                              DOCUMENTATION IN THE UNPKBG ROUTINE.
C                       1002 = IS0( ) HAS NOT BEEN DIMENSIONED LARGE
C                              ENOUGH TO CONTAIN THE ENTIRE TEMPLATE. 
C                       1010 = BEGINNING OF GRIB2 MESSAGE NOT FOUND.
C                       1011 = MESSAGE MUST BE GRIB2 VERSION 2.
C             ISEVERE = THE SEVERITY LEVEL OF THE ERROR.  THE ONLY
C                       VALUE RETUNED IS:
C                       2 = A FATAL ERROR  (OUTPUT)
C                   * = ALTERNATE RETURN WHEN IER NE 0.
C
C             LOCAL VARIABLES
C               IGRIB = CONTAINS THE HEXADECIMAL REPRESENTATION
C                       OF THE STRING "GRIB" AS IT WOULD APPEAR
C                       WHEN THE STRING IS EQUIVALENCED TO 
C                       AN INTEGER*4 VARIABLE ON A "BIG ENDIAN"
C                       PLATFORM.
C                IS01 = CONTAINS THE CONTENTS OF IS0(1) FOR START
C                       OF MESSAGE TESTING.
C                   N = L3264B = THE INTEGER WORD LENGTH IN BITS OF
C                       THE MACHINE BEING USED. VALUES OF 32 AND
C                       64 ARE ACCOMMODATED.
C
C        NON SYSTEM SUBROUTINES CALLED
C           UNPKBG
C
      DIMENSION IPACK(ND5),IS0(NS0)
C
      DATA IGRIB/'47524942'X/
C
      N=L3264B
      IER=0
C
C        ALL ERRORS GENERATED IN THIS ROUTINE ARE FATAL.
      ISEVERE=2 
C
C        CHECK SIZE OF IS0( ).
C
      IF(NS0.LT.9)THEN
         IER=1002
         GO TO 900
      ENDIF
C
C        IPOS = BIT POSITION IN IPACK(LOCN) TO START PUTTING
C        THE VALUE. PKBG UPDATES IT.
      LOCN=1
      IPOS=1
C
C        MAKE SURE THAT THE IS0( ) ARRAY INITIALLY CONTAINS
C        ZERO'S.
C
      DO K=1,NS0
         IS0(K)=0
      ENDDO
C
C        UNPACK THE 'GRIB' IDENTIFICATION.
C        ACCOMMODATE A 64 BIT WORD IF NEED BE.
      CALL UNPKBG(KFILDO,IPACK,ND5,LOCN,IPOS,IS0(1),32,N,IER,*900)
      IS01=IS0(1)
      IF(L3264B.EQ.64)IS01=ISHFT(IS0(1),32)
C
      IF(IGRIB.NE.IS01)THEN
D        WRITE(KFILDO,10)IS0(1)
D10      FORMAT(/' ****BEGINNING OF GRIB MESSAGE NOT FOUND IN',
D    1           ' UNPACK.  FIRST 4 CHARACTERS = 'A4)
         IER=1010
         GO TO 900
      ENDIF
C
C        OCTETS 5 AND 6 ARE RESERVED. THEY CONTAIN NO VALUES.
      CALL UNPKBG(KFILDO,IPACK,ND5,LOCN,IPOS,ITRASH,16,N,IER,*900)
C
C        UNPACK THE DISCIPLINE-GRIB MASTER TABLE NUMBER.
      CALL UNPKBG(KFILDO,IPACK,ND5,LOCN,IPOS,IS0(7),8,N,IER,*900)  
C
C        UNPACK THE GRIB EDITION NUMBER.
      CALL UNPKBG(KFILDO,IPACK,ND5,LOCN,IPOS,IS0(8),8,N,IER,*900)
C
C        THIS MUST BE GRIB EDITION 2.
C
      IF(IS0(8).NE.2)THEN
D        WRITE(KFILDO,113)IS0(8)
D113     FORMAT(/' ****GRIB EDITION NUMBER ='I3,
D    1           ' IN UNPACK NOT EXPECTED.')
         IER=1011
         GO TO 900 
      ENDIF
C
C        A 64-BIT MESSAGE LENGTH IS NOT SUPPORTED AT THIS TIME.
C        UNPACK AND DISCARD THE GARBAGE VALUES IN THE FIRST FOUR
C        OCTETS.
      CALL UNPKBG(KFILDO,IPACK,ND5,LOCN,IPOS,ITRASH,32,N,IER,*900)
C
C        UNPACK THE TOTAL LENGTH OF THE GRIB2 MESSAGE IN OCTETS.
      CALL UNPKBG(KFILDO,IPACK,ND5,LOCN,IPOS,IS0(9),32,N,IER,*900)
C
C       ERROR RETURN SECTION
C
 900  IF(IER.NE.0)RETURN 1 
C
      RETURN
      END

      REAL FUNCTION RDIEEE(RIEEE)
CC$$$ SUBPROGRAM DOCUMENTATION BLOCK
C . . . .
C SUBPROGRAM: rdieee 
C PRGMMR: Gilbert ORG: W/NP11 DATE: 2000-05-09
C
C ABSTRACT: This subroutine reads a list of real values in 
C 32-bit IEEE floating point format.
C
C PROGRAM HISTORY LOG:
C 2000-05-09 Gilbert
C
C USAGE:CALL rdieee(rieee,a,num)
C INPUT ARGUMENT LIST:
C rieee - Inputfloating point value in 32-bit IEEE format.
C
C OUTPUT ARGUMENT LIST: None.
C
C REMARKS: None
C
C ATTRIBUTES:
C LANGUAGE: Fortran 90
C MACHINE: IBM SP
C
C$$$

      PARAMETER (two23=2.**(-23))
      PARAMETER (two126=2.**(-126))
C
      EQUIVALENCE(RTEMP,IEEE)
C
      RTEMP=RIEEE
C
C Extract sign bit, exponent, and mantissa
C
      isign=ibits(ieee,31,1)
      iexp=ibits(ieee,23,8)
      imant=ibits(ieee,0,23)
      sign=1.0
      if (isign.eq.1) sign=-1.0
      
      if ( (iexp.gt.0).and.(iexp.lt.255) ) then
        temp=2.0**(iexp-127)
        rdieee=sign*temp*(1.0+(two23*real(imant)))

      elseif ( iexp.eq.0 ) then
        if ( imant.ne.0 ) then
          rdieee=sign*two126*two23*real(imant)
        else
          rdieee=sign*0.0
        endif

C     elseif ( iexp.eq.255 ) then
C       rdieee=sign*huge(rdieee)

      endif
C
      return
      end

      LOGICAL FUNCTION UNPK_ENDIAN( )
C
C        MARCH  2001    MATTISON/LAWRENCE  GSC/MDL   ORIGINAL CODING
C        OCTOBER 2002   LAWRENCE           WHFS/OHD  
C                       FIXED A BUG THAT WAS PREVENTING THE 
C                       DETERMINATION OF THE CORRECT OPERATING
C                       SYSTEM.
C
C        PURPOSE
C           RETURNS A VALUE OF "TRUE" IF THE MACHINE THAT 
C           THIS ROUTINE IS BEING RUN ON IS USING 
C           BIG ENDIAN MEMORY ARCHITECTURE.  THIS ROUTINE
C           WILL RETURN A VALUE OF "FALSE" IF THE MACHINE
C           THAT THIS ROUTINE IS BEING RUN ON IS USING
C           LITTLE ENDIAN MEMORY ARCHITECTURE.
C
C           ON BIG ENDIAN SYSTEMS (SUCH AS THE HP-9000 WORKSTATIONS),
C           THE LAST BYTE OF AN INTEGER*4 VALUE IS THE LEAST 
C           SIGNIFICANT BYTE.  ON LITTLE ENDIAN SYSTEMS (SUCH AS
C           INTEL PENTIUM SYSTEMS) THE LAST BYTE OF AN INTEGER*4
C           VALUE IS THE MOST SIGNIFICANT BYTE.
C
C           THIS ROUTINE FUNCTIONS AS FOLLOWS:
C
C           THE INTEGER*4 VARIABLE, "I", IS SET TO "0".  THIS
C           ZEROS OUT EACH OF THE FOUR BYTES IN "I".  THIS ALSO
C           SETS EACH OF THE CHARACTERS IN "LETTER" TO "0" SINCE
C           THIS CHARACTER STRING IS EQUIVALENCED TO "I".  THEN,
C           THE FOURTH CHARACTER OF "LETTER" IS SET TO THE CHARACTER
C           WITH AN ASCII VALUE OF "1".  BECAUSE OF THE EQUIVALENCE,
C           THIS SETS THE FOURTH BYTE OF "I" TO CONTAIN A VALUE
C           OF "1".
C
C           ON A BIG ENDIAN SYSTEM, WITH I's LAST (LEAST SIGNIFICANT)
C           BYTE BEING "1", "I" IS SEEN TO HAVE THE VALUE "1".  
C           HOWEVER, ON A LITTLE ENDIAN SYSTEM WITH I's LAST
C           (MOST SIGNIFICANT) BYTE BEING "1", "I" IS SEEN TO HAVE 
C           THE VALUE OF 2**24 (16777216).  THUS, BY TESTING ON THE
C           VALUE OF "I", THIS ROUTINE CAN DETERMINE WHICH TYPE
C           OF HARDWARE THIS ROUTINE IS BEING RUN ON.
C
C        DATA SET USE
C           NONE
C        VARIABLES
C           NONE
C
C             LOCAL VARIABLES
C                   I = CONTAINS THE VALUE OF "1" TO BE USED IN
C                       DETERMINING THE "ENDIANESS" OF THE 
C                       HARDWARE THAT THIS ROUTINE IS BEING
C                       RUN ON.  (INTEGER*4)
C              LETTER = EQUIVALENCED TO "I".  THIS FOUR-BYTE
C                       CHARACTER STRING ALLOWS THIS ROUTINE
C                       TO MANIPULATE THE INDIVIDUAL BYTE
C                       VALUES IN "I".
C
C        NON SYSTEM SUBROUTINES CALLED
C           NONE

      INTEGER*4 I
      CHARACTER*4 LETTER
      EQUIVALENCE (LETTER, I)
C
      I = 0
      LETTER(4:4) = CHAR(1)
C
      IF (I.EQ.1) THEN
         UNPK_ENDIAN=.TRUE.
      ELSE
         UNPK_ENDIAN=.FALSE.
      ENDIF
C
      RETURN
      END

      SUBROUTINE UNPK_TRACE(KFILDO,JER,NDIER,KIER,NERR,ISEVERE)
C
C        JUNE    2000   LAWRENCE   ERROR POSTING AND TRACING FOR GRIB2
C        JANUARY 2001   GLAHN      COMMENTS; INSERTED KIER=KIER-1;
C                                  CHANGED IER( , ) TO JER( , )
C
C        PURPOSE 
C            INSERTS AN ERROR CODE AND ITS SEVERITY INTO JER( , ).
C            INSERTS 999 WHEN JER( , ) IS FULL.  IN THAT CASE,  
C            TWO ERROR CODES ARE LOST.  SINCE THE PROGRAM PROCEEDS,
C            MORE MAY BE LOST BEFORE PROGRAM COMPLETION.
C
C        DATA SET USE 
C           KFILDO - UNIT NUMBER FOR OUTPUT (PRINT) FILE. (OUTPUT) 
C
C        VARIABLES 
C             KFILDO = UNIT NUMBER FOR OUTPUT (PRINT) FILE.  (INPUT)
C           JER(J,K) = ARRAY OF ERRORS (J=1,NDIER) (K=1,2)
C                      (INPUT/OUTPUT)
C              NDIER = THE DIMENSION OF JER( , ). THE MAXIMUM NUMBER
C                      OF ERRORS ALLOWED TO BE REPORTED IN JER( , ).
C                      (INPUT)
C               KIER = NUMBER OF VALUES IN JER( , ) UPON ENTRY AND
C                      EXIT.  (INPUT/OUTPUT)
C               NERR = VALUE TO INSERT INTO JER(KIER,1).  (INPUT)
C            ISEVERE = THE SEVERITY LEVEL OF THE DIAGNOSTIC TO INSERT
C                      INTO JER(KIER,2).  VALID SEVERITY LEVELS ARE:
C                      0 = NOT A PROBLEM
C                      1 = WARNING
C                      2 = FATAL
C                      (INPUT)
C
C        LOCAL VARIABLES
C           NONE
C
C        NON SYSTEM SUBROUTINES CALLED 
C           NONE
C
      DIMENSION JER(NDIER,2)
C
      KIER=KIER+1
C
      IF(KIER.LE.NDIER)THEN
         JER(KIER,1)=NERR
         JER(KIER,2)=ISEVERE
      ELSE
         KIER=KIER-1
         JER(KIER,1)=999
         JER(KIER,2)=2
      ENDIF
C
      RETURN
      END

      SUBROUTINE UNBOUSTRO(A,NX,NY)
C
C        APRIL    2000   LAWRENCE   CALLED BY UNPKSECDIF AND 
C                                   UNPKCMBM.
C
C        PURPOSE
C            TO SCAN AND REORDER AN ARRAY OF DATA BOUSTROPHEDONICALLY.
C            BOUSTROPHEDONIC ORDERING IS A PROCESS IN WHICH
C            AN ARRAY OF DATA IS SCANNED STARTING FROM THE LAST
C            ROW AND WORKING UP TO THE FIRST ROW. THE ROWS ARE
C            ALTERNATIVELY SCANNED FROM LEFT TO RIGHT AND FROM
C            RIGHT TO LEFT. THIS SCANNING METHOD IS ADVANTAGEOUS
C            WHEN USED TO PROCESS A FIELD OF DATA THAT WILL BE
C            PACKED WITH THE GRIB2 COMPLEX PACKING METHOD (WITH
C            OR WITHOUT SPATIAL DIFFERENCES). IT GENERALLY
C            PRODUCES A SMOOTHER DATA FIELD WHICH CAN BE MORE
C            EASILY BROKEN DOWN INTO GROUPS, A PROCESS WHICH
C            IS CORE TO THE COMPLEX PACKING METHOD.
C
C        DATA SET USE
C           NONE
C
C        VARIABLES
C                A(K) = CONTAINS THE DATA FIELD TO BE
C                       BOUSTROPHEDONICALLY REORDERED
C                       (K=1,NX*NY).  (INPUT/OUTPUT)
C                  NX = THE NUMBER OF COLUMNS IN THE PRODUCT.  (INPUT)
C                  NY = THE NUMBER OF ROWS IN THE PRODUCT.  (INPUT)
C
C        LOCAL VARIABLES
C                TEMP = SAVES THE VALUE OF A( ) CURRENTLY BEING SWAPPED
C                       SO THAT IT IS NOT OVERWRITTEN.
C                   K = LOOPING/INDEX VARIABLE.
C              NXDIV2 = THE NUMBER OF COLUMNS IN THE PRODUCT DIVIDED
C                       BY 2 AND TRUNCATED TO A WHOLE NUMBER. 
C              NXJYP1 = THE PRODUCT OF NX AND JY INCREMENTED BY 1.
C
C         NON SYSTEM SUBROUTINES CALLED
C            NONE
C
      DIMENSION A(NX*NY)
C
      K=0
      NXDIV2=NX/2
C
      DO 20 JY=1,NY
C
         IF(MOD(JY,2).EQ.0)THEN
C
            DO 10 IX=1,NXDIV2
               K=K+1
               NXJYP1=NX*JY+1
               TEMP=A(K)
               A(K)=A(NXJYP1-IX)
               A(NXJYP1-IX)=TEMP
 10         CONTINUE
C
            IF(MOD(NX,2).EQ.0)THEN
              K=K+NXDIV2
            ELSE
              K=K+NXDIV2+1
            ENDIF
C
         ELSE
            K=K+NX
         ENDIF
C
 20   CONTINUE
C
      RETURN
      END

      SUBROUTINE UNPK_SECT6(KFILDO,IPACK,ND5,IS6,NS6,IB,ND2X3,
     1                      NX,NY,L3264B,LOCN,IPOS,IBITMAP,IER,
     2                      ISEVERE,*)
C
C        MARCH   2000   LAWRENCE   GSC/TDL    ORIGINAL CODING
C        JANUARY 2001   GLAHN      COMMENTS; CHANGED IER = 15 TO 608;
C                                  OMITTED EXISTS FROM CALL SEQUENCE;
C                                  ADDED IER = 601; ADDED TEST FOR
C                                  SECTION LENGTH WITH IER = 608
C        FEBRUARY 2001   GLAHN     CHECKED SIZE OF NS6; COMMENTS
C        NOVEMBER 2001   GLAHN     MOVED ISEVERE=2 TO TOP, CHANGED
C                                  IER=605 TO IER=608 ON IS6(6) TEST
C
C        PURPOSE
C            UNPACKS SECTION 6, THE BIT MAP SECTION, OF A GRIB2 MESSAGE.
C
C        DATA SET USE
C           KFILDO - UNIT NUMBER FOR OUTPUT (PRINT) FILE. (OUTPUT
C                    FILE)
C
C        VARIABLES
C              KFILDO = UNIT NUMBER FOR OUTPUT (PRINT) FILE. (INPUT)
C            IPACK(J) = THE ARRAY THAT HOLDS THE ACTUAL PACKED MESSAGE
C                       (J=1,ND5). (INPUT/OUTPUT)
C                 ND5 = THE SIZE OF THE ARRAY IPACK( ). (INPUT)
C              IS6(J) = THE BIT-MAP DATA THAT IS UNPACKED FROM
C                       IPACK( ) IS PLACED INTO THIS ARRAY (J=1,NS6).
C                       (OUTPUT)
C                 NS6 = SIZE OF IS6( ). (INPUT)
C               IB(J) = THE UNPACKED BIT-MAP GOES IN HERE.
C                       (J=1,ND2X3). (OUTPUT)
C               ND2X3 = THE DIMENSIONS OF IB( ). (INPUT)
C               NX,NY = THE ACTUAL NUMBER OF ROWS AND COLUMNS IN
C                       THIS PRODUCT. (INPUT)
C              L3264B = THE INTEGER WORD LENGTH IN BITS OF THE MACHINE
C                       BEING USED. VALUES OF 32 AND 64 ARE
C                       ACCOMMODATED. (INPUT)
C                LOCN = THE WORD POSITION FROM WHICH TO UNPACK THE
C                       NEXT VALUE. (INPUT/OUTPUT)
C                IPOS = THE BIT POSITION IN LOCN FROM WHICH TO START
C                       UNPACKING THE NEXT VALUE.  (INPUT/OUTPUT)
C             IBITMAP = 1 IF THERE WAS A BIT-MAP IN THIS SECTION.
C                       0 IF THERE WAS NOT A BIT-MAP IN THIS
C                       SECTION.  (OUTPUT)
C                 IER = RETURN STATUS CODE. (OUTPUT)
C                         0 = GOOD RETURN.
C                       6-8 = ERROR CODES GENERATED BY UNPKBG. SEE THE
C                             DOCUMENTATION IN THE PKBG ROUTINE.
C                       601 = IS5(5) DOES NOT INDICATE SECTION 6.
C                       602 = IS6( ) HAS NOT BEEN DIMENSIONED LARGE
C                             ENOUGH TO CONTAIN THE ENTIRE TEMPLATE. 
C                       605 = DIMENSION ND2X3 NOT LARGE ENOUGH FOR
C                             IB(NX*NY)
C                       608 = BIT MAP INDICATOR IN IS6(6) NOT IN CORRECT
C                             RANGE.
C                       699 = UNEXPECTED END OF MESSAGE.
C             ISEVERE = THE SEVERITY LEVEL OF THE ERROR.  THE ONLY
C                       VALUE RETUNED IS:
C                       2 = A FATAL ERROR  (OUTPUT)
C                   * = ALTERNATE RETURN WHEN IER NE 0.
C
C             LOCAL VARIABLES
C             LOCN6_1 = SAVES THE WORD POSITION LOCN IN IPACK
C                       UPON ENTRY TO STORE BACK TO LOCN IN CASE
C                       THERE IS A FATAL ERROR.
C             IPOS6_1 = SAVES THE BIT POSITION IPOS IN LOCN
C                       UPON ENTRY TO STORE BACK TO IPOS IN CASE
C                       THERE IS A FATAL ERROR.
C               LSECT = CONTAINS THE LENGTH OF SECTION 6
C                       AS UNPACKED FROM THE FIRST FOUR
C                       BYTES IN THE SECTION.
C               NSECT = SECTION NUMBER.
C                   K = A LOOPING INDEX VARIABLE.
C                   N = L3264B = THE INTEGER WORD LENGTH IN BITS OF
C                       THE MACHINE BEING USED. VALUES OF 32 AND
C                       64 ARE ACCOMMODATED.
C
C        NON SYSTEM SUBROUTINES CALLED
C           ENDOMESS, UNPKBG, UNPKBMAP
C
      DIMENSION IPACK(ND5),IS6(NS6),IB(ND2X3)
      LOGICAL ENDOMESS
C
      N=L3264B
      IER=0
C
C        ALL ERRORS GENERATED BY THIS ROUTINE ARE FATAL.
      ISEVERE=2
C
C        CHECK THE DIMENSIONS OF IS6( ).
C
      IF(NS6.LT.6)THEN
         IER=602
         GO TO 900
      ENDIF
C
      LOCN6_1=LOCN
      IPOS6_1=IPOS
C
C        UNPACK THE LENGTH OF THE SECTION, LSECT.
      CALL UNPKBG(KFILDO,IPACK,ND5,LOCN,IPOS,LSECT,32,N,IER,*900)
C
C        CHECK FOR AN UNEXPECTED END OF MESSAGE,
C        ACCOMMODATING FOR A 64-BIT WORD.
C
      IF(ENDOMESS(LSECT,N))THEN
         IER=699
         GO TO 900
      ENDIF
C
C        UNPACK THE NUMBER OF THE SECTION, NSECT. CHECK
C        TO MAKE SURE THAT THIS IS SECTION 6.
      CALL UNPKBG(KFILDO,IPACK,ND5,LOCN,IPOS,NSECT,8,N,IER,*900)
C
      IF(NSECT.NE.6)THEN
         IER=601
         LOCN=LOCN6_1
         IPOS=IPOS6_1
         GO TO 900
      ENDIF
C
      DO K=1,NS6
         IS6(K)=0
      ENDDO
C
      IS6(1)=LSECT
      IS6(5)=NSECT
C
C        UNPACK THE BIT-MAP INDICATOR.
      CALL UNPKBG(KFILDO,IPACK,ND5,LOCN,IPOS,IS6(6),8,N,IER,*900)
C
C        DO A BOUNDS CHECK ON THE BIT-MAP INDICATOR.
C
      IF((IS6(6).LT.0).OR.(IS6(6).GT.255))THEN
         IER=608
      ELSE
C
C           IS THERE A BIT-MAP TO UNPACK?
C
         IF(IS6(6).EQ.0)THEN
C
            IF(ND2X3.LT.NX*NY)THEN
               IER=605
               GO TO 900
            ENDIF
C
            CALL UNPKBMAP(KFILDO,IPACK,ND5,IB,NX*NY,N,LOCN,IPOS,
     1                    IER,*900)
            IBITMAP=1
         ELSE
            IBITMAP=0
         ENDIF
C
      ENDIF
C
C        ERROR RETURN SECTION
 900  IF(IER.NE.0)RETURN 1
C
      RETURN
      END

      SUBROUTINE UNPKLX(KFILDO,IPACK,NDX,LOC,IPOS,IC,NXY,NBIT,
     1                  L3264B,IER,*)
C
C        APRIL 1997   GLAHN   TDL   HP
C        MAY   1997   GLAHN   MODIFIED UNPACKING ALGORITHM TO USE
C                             MVBITS RATHER THAN SHIFTING AND ORING.
C
C        PURPOSE 
C            TO UNPACK NXY VALUES FROM IPACK( ).  THE PACKED VALUES
C            ARE RETURNED IN IC( ) WITH NO REFERENCE VALUE OR 
C            SCALING CONSIDERED.  UNPKLX ELIMINATES THE CALLING OF
C            UNPKBG, AND RATHER INCORPORATES IT INTO THE LOOP.
C            SINCE THIS IS A HIGHLY USED ROUTINE, ALL REASONABLE
C            ATTEMPTS AT EFFICIENCY MUST BE PURSUED.
C
C        DATA SET USE 
C           KFILDO - UNIT NUMBER FOR OUTPUT (PRINT) FILE. (OUTPUT) 
C
C        VARIABLES 
C              KFILDO = UNIT NUMBER FOR OUTPUT (PRINT) FILE.  (INPUT) 
C            IPACK(J) = THE ARRAY HOLDING THE ACTUAL PACKED MESSAGE
C                       (J=1,MAX OF NDX).  (INPUT)
C                 NDX = DIMENSION OF IPACK( ).  (INPUT)
C                 LOC = HOLDS WORD POSITION IN IPACK OF NEXT VALUE TO
C                       UNPACK.  (INPUT/OUTPUT)
C                IPOS = HOLDS BIT POSITION IN IPACK(LOC) OF THE FIRST
C                       BIT OF THE NEXT VALUE TO UNPACK.  (INPUT/OUTPUT)
C               IC(K) = UNPACKED DATA RETURNED (K=1,NXY).  (OUTPUT)
C                 NXY = DIMENSION OF IC( ).  THE NUMBER
C                       OF UNPACKED VALUES RETURNED.  (INPUT)
C                NBIT = THE NUMBER OF BITS TO UNPACK FOR EACH VALUE.
C                       (INPUT)
C              L3264B = INTEGER WORD LENGTH OF MACHINE BEING USED.
C                       (INPUT)
C                 IER = ERROR RETURN.  (OUTPUT)
C                       6 = NDX IS NOT LARGE ENOUGH TO FURNISH THE BITS
C                           NECESSARY TO ACCOMMODATE NXY VALUES STARTING
C                           AT THE VALUES LOC AND IPOS.
C                       7 = IPOS NOT IN THE RANGE 1-L3264B.
C                       8 = IBIT NOT IN THE RANGE 0-32.
C                   * = ALTERNATE ERROR RETURN WHEN IER IS NOT "0".
C
C        NON SYSTEM SUBROUTINES CALLED 
C           NONE
C
      DIMENSION IPACK(NDX)
      DIMENSION IC(NXY)
C
C        SET ERROR RETURN AND ZERO ARRAYS.
C
      IER=0
C
C        CHECK LEGITIMATE VALUES OF LOC AND IPOS, AND WHETHER
C        NDX IS SUFFICIENT FOR ALL NXY VALUES.
C
      IF(IPOS.LE.0.OR.IPOS.GT.L3264B)THEN
         IER=7
D        WRITE(KFILDO,101)IPOS,IER
D101     FORMAT(/' IPOS = ',I6,' NOT IN THE RANGE 1 TO L3264B',
D    1           ' IN UNPKLX.  RETURN FROM UNPKLX WITH IER = ',I4)
         GO TO 900 
      ENDIF
C
      IF(NBIT.LT.0.OR.NBIT.GT.32)THEN
         IER=8
D        WRITE(KFILDO,102)NBIT,IER
D102     FORMAT(/' NBIT = ',I6,' NOT IN THE RANGE 0 TO 32 IN UNPKLX.',
D    1           ' RETURN FROM UNPKLX WITH IER = ',I4)
         GO TO 900
      ENDIF
C
      IF(NBIT*NXY.GT.(L3264B+1-IPOS)+(NDX-LOC)*L3264B)THEN
         IER=6
D        WRITE(KFILDO,103)NXY,NBIT,LOC,IPOS,NDX,IER
D103     FORMAT(/' NXY = ',I9,' AND NBIT = ',I6,' REQUIRE MORE BITS',
D    1           ' THAN ARE AVAILABLE IN IPACK( ),',
D    2           ' WITH LOC =',I8,', IPOS =',I4,', AND NDX =',I8,'.'/
D    3           ' RETURN FROM UNPKLX WITH IER =',I4)
         GO TO 900
      ENDIF
C      
      DO 300 K=1,NXY 
         NVALUE=0
C
      IF(NBIT.EQ.0)GO TO 150
C   
      NEWIPOS=IPOS+NBIT
C
      IF(NEWIPOS.LE.L3264B+1)THEN
         CALL MVBITS(IPACK(LOC),L3264B+1-NEWIPOS,NBIT,NVALUE,0)
C
         IF(NEWIPOS.LE.L3264B)THEN
            IPOS=NEWIPOS
         ELSE
            IPOS=1
            LOC=LOC+1
         ENDIF
C
      ELSE
         NBIT1=L3264B+1-IPOS
         NBIT2=NBIT-NBIT1
         CALL MVBITS(IPACK(LOC),0,NBIT1,NVALUE,NBIT2)
         LOC=LOC+1
         CALL MVBITS(IPACK(LOC),L3264B-NBIT2,NBIT2,NVALUE,0)
         IPOS=NBIT2+1
      ENDIF
C
 150  IC(K)=NVALUE
C
 300  CONTINUE
C
 900  IF(IER.NE.0)RETURN 1
C
      RETURN
      END

      SUBROUTINE UNPKPS(KFILDO,IPACK,ND5,LOCN,IPOS,MISSP,MISSS,
     1                  JMIN,LBIT,NOV,LX,IWORK,ND2X3,L3264B,IER)
C
C        JUNE 1997   GLAHN   TDL   MOS-2000
C        MAY  1999   GLAHN   CHANGED DIMENSION OF IWORK.
C        FEB  2001   LAWRENCE   UPDATED THIS ROUTINE TO USE
C                               MVBITS INSTEAD OF ISHFT.  THIS
C                               WILL IMPROVE THE UNPACKING
C                               EFFICIENCY OF THIS ROUTINE.
C
C        PURPOSE 
C            UNPACKS DATA IN TDLPACK FORMAT WHEN THERE CAN BE PRIMARY
C            AND SECONDARY MISSING VALUES.  SCALING IS NOT DONE IN THIS
C            ROUTINE. BUT THE REFERENCE VALUE IS USED.  CALLED FROM
C            UNPACK TO ELIMINATE MULTIPLE CALLS TO UNPKBG.  THE WORD
C            POINTER LOCN AND BIT POSITION POINTER IPOS ARE UPDATED
C            AS NECESSARY.
C
C        DATA SET USE 
C           KFILDO - UNIT NUMBER FOR OUTPUT (PRINT) FILE. (OUTPUT) 
C
C        VARIABLES 
C              KFILDO = UNIT NUMBER FOR OUTPUT (PRINT) FILE.  (INPUT)
C            IPACK(J) = ARRAY TO UNPACK FROM (J=1,ND5).  (INPUT)
C                 ND5 = DIMENSION OF IPACK( ).  (INPUT)
C                LOCN = WORD IN IPACK( ) TO START UNPACKING.  UPDATED
C                       AS NECESSARY AFTER UNPACKING IS COMPLETED.
C                       (INPUT/OUTPUT)
C                IPOS = BIT POSITION (COUNTING LEFTMOST BIT IN WORD
C                       AS 1) TO START UNPACKING.  MUST BE GE 1 AND
C                       LE L3264B.  UPDATED AS NECESSARY
C                       AFTER PACKING IS COMPLETED.  (INPUT/OUTPUT)
C               MISSP = THE PRIMARY MISSING VALUE TO RETURN IN IWORK( )
C                       WHEN THE PACKED DATUM INDICATES A PRIMARY
C                       MISSING VALUE.  (INPUT)
C               MISSS = THE SECONDARY MISSING VALUE TO RETURN IN
C                       IWORK( ) WHEN THE PACKED DATUM INDICATES
C                       A SECONDARY MISSING VALUE.  (INPUT)
C             JMIN(L) = THE MINIMUM VALUE SUBTRACTED FROM EACH GROUP
C                       L BEFORE PACKING (L=1,LX).  (INPUT)
C             LBIT(L) = THE NUMBER OF BITS NECESSARY TO HOLD THE
C                       PACKED VALUES FOR EACH GROUP L (L=1,LX). 
C                       (INPUT)
C              NOV(L) = THE NUMBER OF VALUES IN GROUP L (L=1,LX).
C                       (INPUT)
C                  LX = THE NUMBER OF VALUES IN LBIT( ), JMIN( ), AND
C                       NOV( ).  ALSO USED AS THEIR DIMENSIONS.
C                       (INPUT)
C            IWORK(J) = THE UNPACKED DATA ARE RETURNED
C                       (J=1,MAX OF ND2X3).  (OUTPUT)
C               ND2X3 = DIMENSION OF IWORK( ).  (INPUT)
C              L3264B = INTEGER WORD LENGTH OF MACHINE BEING USED.
C                       (INPUT)
C                 IER = STATUS RETURN:
C                       0 = GOOD RETURN.
C                       6 = NOT ENOUGH ROOM IN IPACK( ) OR IWORK( ) TO
C                           ACCOMMODATE THE DATA INDICATED BY LBIT( )
C                           AND NOV( ).
C                       7 = IPOS NOT IN RANGE 1 TO L3264B.
C                       8 = LBIT(L) NOT IN RANGE 0 TO 30.
C
C        LOCAL VARIABLES
C                   K = USED TO INDEX THE IWORK( ) ARRAY
C                       WHILE KEEPING TRACK OF THE CURRENT GROUP
C                       OF DATA BEING PROCESSED.
C                 L,M = LOOP INDEX VARIABLES.
C NEWIPOS,NBIT1,NBIT2 = VARIABLES USED IN THE MANIPULATION OF
C                       BIT POSITIONS WHILE UNPACKING VALUES FROM
C                       IPACK().
C
C        NON SYSTEM SUBROUTINES CALLED
C            NONE (MVBITS IS A SYSTEM INTRINSIC)
C
      DIMENSION IPACK(ND5)
      DIMENSION IWORK(ND2X3)
      DIMENSION JMIN(LX),LBIT(LX),NOV(LX)
C
      DIMENSION LB2M1(0:30),LB2M2(0:30)
C
      SAVE LB2M1,LB2M2
C
      DATA IFIRST/0/
C
C         CALCULATE THE POWERS OF 2 THE FIRST TIME ENTERED.
C
      IF(IFIRST.EQ.0)THEN
         IFIRST=1
         LB2M1(0)=0
         LB2M2(0)=-1
C
         DO 100 J=1,30
         LB2M1(J)=(LB2M1(J-1)+1)*2-1
         LB2M2(J)=(LB2M2(J-1)+2)*2-2
 100     CONTINUE
C
      ENDIF
C
C        CHECK CORRECTNESS OF INPUT AND SET STATUS RETURN.
C
      IER=0
C
      IF(IPOS.LE.0.OR.IPOS.GT.L3264B)THEN
         IER=7
D        WRITE(KFILDO,101)IPOS,IER
D101     FORMAT(/' IPOS = ',I6,' NOT IN THE RANGE 1 TO L3264B.',
D    1           '  RETURN FROM UNPKPS WITH IER = ',I4)
         GO TO 900 
      ENDIF
C
      K=0
C
      DO 350 L=1,LX
      IF(LBIT(L).LT.0.OR.LBIT(L).GT.30)THEN
         IER=8
D        WRITE(KFILDO,102)LBIT(L),L,IER
D102     FORMAT(/' ****LBIT(L) = ',I6,' FOR L =',I6,' NOT IN THE RANGE',
D    1           ' 0 TO 30.  RETURN FROM UNPKPS WITH IER = ',I4)
         GO TO 900
      ENDIF
C
      IF(LBIT(L)*NOV(L).GT.(L3264B+1-IPOS)+(ND5-LOCN)*L3264B)THEN
         IER=6
D        WRITE(KFILDO,103)NOV(L),LBIT(L),L,LOCN,IPOS,ND5,IER
D103     FORMAT(/' ****NOV(L) = ',I9,' AND LBIT(L) = ',I6,' FOR L =',I6,
D    1         ' REQUIRE MORE BITS THAN ARE AVAILABLE IN IPACK( ),',/,
D    2         '     WITH LOCN =',I8,', IPOS =',I4,', AND ND5 =',I8,'.',
D    3         '  RETURN FROM UNPKPS WITH IER =',I4)
         GO TO 900
      ENDIF
C
      IF(NOV(L)+K.GT.ND2X3)THEN
         IER=6
D        WRITE(KFILDO,104)NOV(L),L,ND2X3,IER
D104     FORMAT(/' ****NOV(L) = ',I9,' FOR L =',I6,
D    1          ' INDICATES MORE VALUES THAN CAN BE PUT INTO IWORK( ),'/
D    2          '     WITH ND2X3 =',I8,'.',
D    3          '  RETURN FROM UNPKOO WITH IER =',I4)
         GO TO 900
      ENDIF
C
      MISSPK=LB2M1(LBIT(L))
      MISSSK=LB2M2(LBIT(L))
C
C        NOTE THAT IT IS NOT NECESSARY TO TEST FOR LBIT(L) EQ 0,
C        AS IT IS IN UNPKOO AND UNPKPO, BECAUSE THIS CANNOT BE
C        TRUE WHEN THERE CAN BE SECONDARY MISSING VALUES.
C
      DO 355 M=1,NOV(L)
C
         K=K+1
C
C        TRANSFER LBIT(L) BITS FROM IPACK( ) TO NVALUE.
C        WORD BOUNDARIES MUST BE TAKEN INTO ACCOUNT.
C
         NVALUE=0
         NEWIPOS=IPOS+LBIT(L)
C
         IF(NEWIPOS.LE.L3264B+1)THEN
            CALL MVBITS(IPACK(LOCN),L3264B+1-NEWIPOS,LBIT(L),
     1                  NVALUE,0)
C
            IF(NEWIPOS.LE.L3264B)THEN
               IPOS=NEWIPOS
            ELSE
               IPOS=1
               LOCN=LOCN+1
            ENDIF
C
         ELSE
            NBIT1=L3264B+1-IPOS
            NBIT2=LBIT(L)-NBIT1
            CALL MVBITS(IPACK(LOCN),0,NBIT1,NVALUE,NBIT2)
            LOCN=LOCN+1
            CALL MVBITS(IPACK(LOCN),L3264B-NBIT2,NBIT2,NVALUE,0)
            IPOS=NBIT2+1
         ENDIF
C
         IF(NVALUE.EQ.MISSPK)THEN
            IWORK(K)=MISSP
         ELSEIF(NVALUE.EQ.MISSSK)THEN
            IWORK(K)=MISSS
         ELSE
            IWORK(K)=JMIN(L)+NVALUE
C
            IF(IWORK(K).EQ.MISSP)THEN
               IWORK(K)=IWORK(K)-1
            ELSEIF(IWORK(K).EQ.MISSS)THEN
               IWORK(K)=IWORK(K)-1
            ENDIF
C              THE ABOVE STATEMENTS ARE NECESSARY TO GUARD AGAINST A 
C              LEGITIMATE VALUE BEING INTERPRETED AS A MISSING.
C              MISSS MUST NOT BE EXACTLY ONE LESS THAN MISSP.
C
         ENDIF
C
 355  CONTINUE
C
 350  CONTINUE
C
 900  RETURN
      END

      SUBROUTINE UNPK_TEMP40(KFILDO,IPACK,ND5,IS4,NS4,L3264B,
     1                       LOCN,IPOS,IER,*)
C
C        MARCH    2000   LAWRENCE  GSC/TDL    ORIGINAL CODING
C        JANUARY  2001   GLAHN     COMMENTS;  CHANGED COMPUTATION OF
C                                  NEGATIVE VALUE; CHANGED TO STANDARD 
C                                  RETURN SEQUENCE; CHANGED IER = 14
C                                  TO 402  
C        FEBRUARY 2001   GLAHN     COMMENTS
C
C        PURPOSE
C            UNPACKS TEMPLATE 0, AN ANALYSIS OR FORECAST TEMPLATE,
C            FROM THE PRODUCT DEFINITION SECTION OF A GRIB2 MESSAGE.
C            IT IS THE RESPONSIBILITY OF THE CALLING ROUTINE TO UNPACK 
C            THE FIRST 9 OCTETS IN SECTION 4.
C
C            NOTE THAT TEMPLATE 4.0 FORMS THE BASIS FOR MANY OF THE
C            OTHER PRODUCT DEFINITION TEMPLATES AVAILABLE TO BE PACKED
C            IN SECTION 4 OF THE GRIB2 MESSAGE.
C
C        DATA SET USE
C           KFILDO - UNIT NUMBER FOR OUTPUT (PRINT) FILE. (OUTPUT)
C
C        VARIABLES
C              KFILDO = UNIT NUMBER FOR OUTPUT (PRINT) FILE. (INPUT)
C            IPACK(J) = THE ARRAY THAT HOLDS THE ACTUAL PACKED MESSAGE
C                       (J=1,ND5). (INPUT/OUTPUT)
C                 ND5 = THE SIZE OF THE ARRAY IPACK( ). (INPUT)
C              IS4(J) = THE PRODUCT DEFINITION INFORMATION FOR 
C                       TEMPLATE 4.0 IS WRITTEN TO ELEMENTS 10 THROUGH
C                       31 AS IT IS UNPACKED FROM IPACK( ) (J=1,NS4).
C                       (INPUT/OUTPUT)
C                 NS4 = SIZE OF IS4( ). (INPUT) 
C              L3264B = THE INTEGER WORD LENGTH IN BITS OF THE MACHINE
C                       BEING USED. VALUES OF 32 AND 64 ARE
C                       ACCOMMODATED. (INPUT)
C                LOCN = THE WORD POSITION FROM WHICH TO UNPACK THE
C                       NEXT VALUE. (INPUT/OUTPUT)
C                IPOS = THE BIT POSITION IN LOCN FROM WHICH TO START
C                       UNPACKING THE NEXT VALUE.  (INPUT/OUTPUT)
C                 IER = RETURN STATUS CODE. (OUTPUT)
C                         0 = GOOD RETURN.
C                       6-8 = ERROR CODES GENERATED BY UNPKBG. SEE THE 
C                             DOCUMENTATION IN THE UNPKBG ROUTINE.
C                       402 = IS4( ) HAS NOT BEEN DIMENSIONED LARGE
C                             ENOUGH TO CONTAIN THE ENTIRE TEMPLATE. 
C                   * = ALTERNATE RETURN WHEN IER NE 0. 
C
C             LOCAL VARIABLES
C             MINSIZE = THE SMALLEST ALLOWABLE DIMENSION FOR IS4( ).
C                   N = L3264B = THE INTEGER WORD LENGTH IN BITS OF
C                       THE MACHINE BEING USED. VALUES OF 32 AND
C                       64 ARE ACCOMMODATED.
C               ISIGN = SIGN OF VALUE BEING UNPACKED, 0 = POSITIVE,
C                       1 = NEGATIVE.  THE SIGN ALWAYS GOES IN THE
C                       LEFTMOST BIT OF THE AREA ASSIGNED TO THAT VALUE.
C
C        NON SYSTEM SUBROUTINES CALLED
C           UNPKBG
C
      PARAMETER(MINSIZE=31)
C
      DIMENSION IPACK(ND5),IS4(NS4)
C
      N=L3264B
      IER=0
C
C        CAN'T CHECK TEMPLATE NUMBER, BECAUSE THIS ROUTINE IS
C        NOT ONLY CALLED FOR TEMPLATE 4.0, BUT OTHERS. 
C
C        CHECK THE DIMENSIONS OF IS4( ).
C
      IF(NS4.LT.MINSIZE)THEN
D        WRITE(KFILDO,20)NS4,MINSIZE
D20      FORMAT(/' IS4( ) IS CURRENTLY DIMENSIONED TO CONTAIN'/
D    1           ' NS4=',I4,' ELEMENTS. THIS ARRAY MUST BE'/
D    2           ' DIMENSIONED TO AT LEAST ',I4,' ELEMENTS'/
D    3           ' TO CONTAIN ALL OF THE DATA IN PRODUCT'/
D    4           ' DEFINITION TEMPLATE 4.0.'/)
         IER=402
         GO TO 900
      ENDIF
C
C        UNPACK THE PRODUCT DEFINITION TEMPLATE.
C        
C        UNPACK THE PARAMETER CATEGORY.
      CALL UNPKBG(KFILDO,IPACK,ND5,LOCN,IPOS,IS4(10),8,N,IER,*900)
C
C        UNPACK THE PARAMETER NUMBER.
      CALL UNPKBG(KFILDO,IPACK,ND5,LOCN,IPOS,IS4(11),8,N,IER,*900)
C
C        UNPACK THE TYPE OF GENERATING PROCESS.
      CALL UNPKBG(KFILDO,IPACK,ND5,LOCN,IPOS,IS4(12),8,N,IER,*900)
C
C        UNPACK THE BACKGROUND GENERATING PROCESS IDENTIFIER.
      CALL UNPKBG(KFILDO,IPACK,ND5,LOCN,IPOS,IS4(13),8,N,IER,*900)
C
C        UNPACK THE ANALYSIS OR FORECAST GENERATING PROCESS IDENTIFIER.
      CALL UNPKBG(KFILDO,IPACK,ND5,LOCN,IPOS,IS4(14),8,N,IER,*900)
C
C        UNPACK THE HOURS OF OBSERVATIONAL DATA CUTOFF AFTER 
C        REFERENCE TIME.
      CALL UNPKBG(KFILDO,IPACK,ND5,LOCN,IPOS,IS4(15),16,N,IER,*900)
C
C        UNPACK THE MINUTES OF OBSERVATIONAL DATA CUTOFF AFTER
C        REFERENCE TIME.
      CALL UNPKBG(KFILDO,IPACK,ND5,LOCN,IPOS,IS4(17),8,N,IER,*900)
C
C        UNPACK THE INDICATOR OF UNIT OF TIME RANGE.
      CALL UNPKBG(KFILDO,IPACK,ND5,LOCN,IPOS,IS4(18),8,N,IER,*900)
C
C        UNPACK THE FORECAST TIME IN UNITS DEFINED BY OCTET 16.
      CALL UNPKBG(KFILDO,IPACK,ND5,LOCN,IPOS,IS4(19),32,N,IER,*900)
C
C        UNPACK THE TYPE OF FIRST FIXED SURFACE.
      CALL UNPKBG(KFILDO,IPACK,ND5,LOCN,IPOS,IS4(23),8,N,IER,*900)
C
C        UNPACK THE SCALE FACTOR OF FIRST FIXED SURFACE.
      CALL UNPKBG(KFILDO,IPACK,ND5,LOCN,IPOS,ISIGN,1,N,IER,*900)
      CALL UNPKBG(KFILDO,IPACK,ND5,LOCN,IPOS,IS4(24),7,N,IER,*900)
      IF(ISIGN.EQ.1)IS4(24)=-IS4(24)
C
C        UNPACK THE SCALED VALUE OF FIRST FIXED SURFACE.
      CALL UNPKBG(KFILDO,IPACK,ND5,LOCN,IPOS,IS4(25),32,N,IER,*900)
C
C        UNPACK THE TYPE OF SECOND FIXED SURFACE.
      CALL UNPKBG(KFILDO,IPACK,ND5,LOCN,IPOS,IS4(29),8,N,IER,*900)
C
C        UNPACK THE SCALE FACTOR OF SECOND FIXED SURFACE.
      CALL UNPKBG(KFILDO,IPACK,ND5,LOCN,IPOS,ISIGN,1,N,IER,*900)
      CALL UNPKBG(KFILDO,IPACK,ND5,LOCN,IPOS,IS4(30),7,N,IER,*900)
      IF(ISIGN.EQ.1)IS4(30)=-IS4(30)
C
C        UNPACK THE SCALED VALUE OF SECOND FIXED SURFACE.
      CALL UNPKBG(KFILDO,IPACK,ND5,LOCN,IPOS,IS4(31),32,N,IER,*900)
C
C       ERROR RETURN SECTION
c
 900  IF(IER.NE.0)RETURN 1
C
      RETURN
      END

      SUBROUTINE UNPK_EQUATOR(KFILDO,IPACK,ND5,IS3,NS3,L3264B,
     1                        LOCN,IPOS,BOUST,IER,*)
C
C        MARCH    2000   LAWRENCE  GSC/TDL    ORIGINAL CODING
C        JANUARY  2001   GLAHN     COMMENTS; ADDED * ARGUMENT
C                                  TO CALL TO UNEARTH; CHANGED
C                                  COMPUTATION OF NEGATIVE VALUE;
C                                  CHANGED TO STANDARD RETURN SEQUENCE   
C        FEBRUARY 2001   GLAHN     CHECKED SIZE OF NS3; COMMENTS
C        NOVEMBER 2001   GLAHN     COMMENT ON IS3( ) SIZE
C
C
C        PURPOSE
C            UNPACKS TEMPLATE 3.110, AN EQUATORIAL AZIMUTHAL
C            EQUIDISTANT MAP PROJECTION, FROM SECTION 3 OF A GRIB2
C            MESSAGE.  DATA ARE PLACED INTO THE IS3( ) ARRAY.
C            IT IS THE RESPONSIBILITY OF THE CALLING ROUTINE
C            TO UNPACK THE FIRST 14 OCTETS IN SECTION 3.
C
C        DATA SET USE
C           KFILDO - UNIT NUMBER FOR OUTPUT (PRINT) FILE. (OUTPUT)
C
C        VARIABLES
C              KFILDO = UNIT NUMBER FOR OUTPUT (PRINT) FILE. (INPUT)
C            IPACK(J) = THE ARRAY THAT HOLDS THE ACTUAL PACKED MESSAGE
C                       (J=1,ND5). (INPUT/OUTPUT)
C                 ND5 = THE SIZE OF THE ARRAY IPACK( ). (INPUT)
C              IS3(J) = THE EQUATORIAL AZIMUTHAL EQUIDISTANT 
C                       INFORMATION IS WRITTEN TO ELEMENTS 15 THROUGH
C                       57 AS IT IS UNPACKED FROM IPACK( ) (J=1,NS3).
C                       (INPUT/OUTPUT)
C                 NS3 = SIZE OF IS3( ). (INPUT) 
C              L3264B = THE INTEGER WORD LENGTH IN BITS OF THE MACHINE
C                       BEING USED. VALUES OF 32 AND 64 ARE
C                       ACCOMMODATED. (INPUT)
C                LOCN = THE WORD POSITION FROM WHICH TO UNPACK THE
C                       NEXT VALUE. (INPUT/OUTPUT)
C                IPOS = THE BIT POSITION IN LOCN FROM WHICH TO START
C                       UNPACKING THE NEXT VALUE.  (INPUT/OUTPUT)
C               BOUST = .TRUE. IF THE DATA FIELD WAS SCANNED
C                       BOUSTROPHEDONICALLY. .FALSE. OTHERWISE. 
C                       (LOGICAL) (OUTPUT)
C                 IER = RETURN STATUS CODE. (OUTPUT)
C                         0 = GOOD RETURN.
C                       6-8 = ERROR CODES GENERATED BY UNPKBG. SEE THE 
C                             DOCUMENTATION IN THE UNPKBG ROUTINE.
C                       302 = IS3( ) NOT DIMENSIONED LARGE ENOUGH.
C                       303 = UNSUPPORTED GRID TEMPLATE INDICATED 
C                             BY IS3(13).
C                       307 = UNRECOGNIZED OR UNSUPPORTED SHAPE OF
C                             EARTH CODE IN IS3(15) RETURNED FROM UNEARTH.
C                   * = ALTERNATE RETURN WHEN IER .NE. 0.
C
C             LOCAL VARIABLES
C               ISIGN = A FLAG INDICATING WHETHER AN UNPACKED VALUE
C                       IS POSITIVE OR NEGATIVE. 
C                   N = L3264B = THE INTEGER WORD LENGTH IN BITS OF 
C                       THE MACHINE BEING USED. VALUES OF 32 AND
C                       64 ARE ACCOMMODATED. 
C
C        NON SYSTEM SUBROUTINES CALLED
C           UNEARTH, UNPKBG
C
      LOGICAL BOUST
C
      DIMENSION IPACK(ND5),IS3(NS3)
C
      N=L3264B
      IER=0
C
C        CHECK TO MAKE SURE THAT AN EQUATORIAL AZIMUTHAL
C        EQUIDISTANT PROJECTION IS PACKED IN THIS MESSAGE.
      IF (IS3(13).NE.110)THEN
D        WRITE(KFILDO,10)IS3(13)
D10      FORMAT(/' MAP PROJECTION CODE ',I4,' INDICATED BY IS3(13)'/
D    1           ' IS NOT EQUATORIAL AZIMUTHAL. PLEASE REFER'/
D    2           ' TO THE GRIB2 DOCUMENTATION TO DETERMINE THE'/
D    3           ' CORRECT MAP PROJECTION PACKER TO CALL.'/)
         IER=303
         GO TO 900
      ENDIF
C
C        CHECK SIZE OF IS3( ).
C
      IF(NS3.LT.57)THEN
         IER=302
         GO TO 900
      ENDIF
C
C        UNPACK THE SHAPE OF THE EARTH.
      CALL UNEARTH(KFILDO,IPACK,ND5,IS3,NS3,N,LOCN,IPOS,IER,*900)
      IF(IER.NE.0)GOTO 900
C
C        UNPACK THE NUMBER OF POINTS ALONG THE X AND Y AXES
C        (Nx, Ny)
      CALL UNPKBG(KFILDO,IPACK,ND5,LOCN,IPOS,IS3(31),32,N,IER,*900)
      CALL UNPKBG(KFILDO,IPACK,ND5,LOCN,IPOS,IS3(35),32,N,IER,*900)
C
C        UNPACK THE LATITUDE & LONGITUDE OF THE TANGENCY POINT
      CALL UNPKBG(KFILDO,IPACK,ND5,LOCN,IPOS,ISIGN,1,N,IER,*900)
      CALL UNPKBG(KFILDO,IPACK,ND5,LOCN,IPOS,IS3(39),
     1          31,N,IER,*900)
      IF(ISIGN.EQ.1)IS3(39)=-IS3(39)
C
      CALL UNPKBG(KFILDO,IPACK,ND5,LOCN,IPOS,ISIGN,1,N,IER,*900)
      CALL UNPKBG(KFILDO,IPACK,ND5,LOCN,IPOS,IS3(43),
     1          31,N,IER,*900)
      IF(ISIGN.EQ.1)IS3(43)=-IS3(43)
C
C        UNPACK THE RESOLUTION AND COMPONENT FLAG.
      CALL UNPKBG(KFILDO,IPACK,ND5,LOCN,IPOS,IS3(47),8,N,IER,*900)
C
C        UNPACK Dx - X-DIRECTION GRID LENGTH IN UNITS OF 10-5 M
C        AS MEASURED AT THE POINT OF THE AXIS.
      CALL UNPKBG(KFILDO,IPACK,ND5,LOCN,IPOS,IS3(48),32,N,IER,*900)
C
C        UNPACK Dy - Y-DIRECTION GRID LENGTH IN UNITS OF 10-5 M
C        AS MEASURED AT THE POINT OF THE AXIS.
      CALL UNPKBG(KFILDO,IPACK,ND5,LOCN,IPOS,IS3(52),32,N,IER,*900)
C
C        UNPACK THE PROJECTION CENTER FLAG.
      CALL UNPKBG(KFILDO,IPACK,ND5,LOCN,IPOS,IS3(56),8,N,IER,*900)
C
C        UNPACK THE SCANNING MODE.
      CALL UNPKBG(KFILDO,IPACK,ND5,LOCN,IPOS,IS3(57),8,N,IER,*900)
C
      IF(IAND(IS3(57),16).EQ.16)THEN
C           THE MASK GETS BIT 4 (FROM THE LEFT); WHEN IT IS 1,
C           BOUST IS TRUE.; OTHERWISE BOUST IS FALSE.
         BOUST=.TRUE.
         IS3(57)=IAND(IS3(57),239)
C           BIT 4 IS SET = 0, BECAUSE THE DATA ARE RETURNED
C           NON-BOUSTROPHEDONICALLY ORDERED EVEN THOUGH THEY WERE
C           PACKED THAT WAY.  239 DECIMAL = 357 OCTAL PRESERVES
C           ALL OTHER BITS IN THE OCTET.
      ELSE
         BOUST=.FALSE.
      ENDIF
C
C       ERROR RETURN SECTION
C
 900  IF(IER.NE.0)RETURN 1 
C
      RETURN
      END

      SUBROUTINE UNPK_TEMP49(KFILDO,IPACK,ND5,IS4,NS4,L3264B,
     1                       LOCN,IPOS,IER,*)
C
C        JULY   2002,   RUDACK     USED TEMPLATE 4.0 AS A GUIDE.  
C
C        PURPOSE
C            UNPACKS TEMPLATE 4.9, A TEMPLATE FOR POP12
C            FROM THE PRODUCT DEFINITION SECTION OF A GRIB2 MESSAGE.
C            IT IS THE RESPONSIBILITY OF THE CALLING ROUTINE TO UNPACK 
C            THE FIRST 9 OCTETS IN SECTION 4.
C
C        DATA SET USE
C           KFILDO - UNIT NUMBER FOR OUTPUT (PRINT) FILE. (OUTPUT)
C
C        VARIABLES
C              KFILDO = UNIT NUMBER FOR OUTPUT (PRINT) FILE. (INPUT)
C            IPACK(J) = THE ARRAY THAT HOLDS THE ACTUAL PACKED MESSAGE
C                       (J=1,ND5). (INPUT/OUTPUT)
C                 ND5 = THE SIZE OF THE ARRAY IPACK( ). (INPUT)
C              IS4(J) = THE PRODUCT DEFINITION INFORMATION FOR 
C                       TEMPLATE 4.9 IS WRITTEN TO ELEMENTS 10 THROUGH
C                       55 OR MORE, DEPENDING ON THE TIME RANGE OVER 
C                       WHICH STATISTICAL PROCESSING IS DONE
C                       (J=1,NS4).  (INPUT/OUTPUT)
C                 NS4 = SIZE OF IS4( ). (INPUT) 
C              L3264B = THE INTEGER WORD LENGTH IN BITS OF THE MACHINE
C                       BEING USED. VALUES OF 32 AND 64 ARE
C                       ACCOMMODATED. (INPUT)
C                LOCN = THE WORD POSITION FROM WHICH TO UNPACK THE
C                       NEXT VALUE. (INPUT/OUTPUT)
C                IPOS = THE BIT POSITION IN LOCN FROM WHICH TO START
C                       UNPACKING THE NEXT VALUE.  (INPUT/OUTPUT)
C                 IER = RETURN STATUS CODE. (OUTPUT)
C                         0 = GOOD RETURN.
C                       6-8 = ERROR CODES GENERATED BY UNPKBG. SEE THE 
C                             DOCUMENTATION IN THE UNPKBG ROUTINE.
C                       402 = IS4( ) HAS NOT BEEN DIMENSIONED LARGE
C                             ENOUGH TO CONTAIN THE ENTIRE TEMPLATE.
C                       403 = IS4(8) DOES NOT CONTAIN A SUPPORTED 
C                             TEMPLATE NUMBER.
C                   * = ALTERNATE RETURN WHEN IER NE 0. 
C
C             LOCAL VARIABLES
C             MINSIZE = THE SMALLEST ALLOWABLE DIMENSION FOR IS4( ).
C                   N = L3264B = THE INTEGER WORD LENGTH IN BITS OF
C                       THE MACHINE BEING USED. VALUES OF 32 AND
C                       64 ARE ACCOMMODATED.
C               ISIGN = SIGN OF VALUE BEING UNPACKED, 0 = POSITIVE,
C                       1 = NEGATIVE.  THE SIGN ALWAYS GOES IN THE
C                       LEFTMOST BIT OF THE AREA ASSIGNED TO THAT VALUE.
C
C        NON SYSTEM SUBROUTINES CALLED
C           UNPKBG
C
      PARAMETER(MINSIZE=55)
C
      DIMENSION IPACK(ND5),IS4(NS4)
C
      N=L3264B
      IER=0
C
C        CHECK TO MAKE SURE THAT THIS IS TEMPLATE 4.9. 
C
      IF(IS4(8).NE.9)THEN
D        WRITE(KFILDO,10)IS4(8)
D10      FORMAT(/' TEMPLATE ',I4,' INDICATED BY IS4(8)'/
D    1           ' IS NOT CORRECT IN UNPK_TEMP49.'/)
         IER=403
         GO TO 900
      ENDIF
C
C        CHECK THE DIMENSIONS OF IS4( ).
C
      IF(NS4.LT.MINSIZE)THEN
D        WRITE(KFILDO,20)NS4,MINSIZE
D20      FORMAT(/' IS4( ) IS CURRENTLY DIMENSIONED TO CONTAIN'/
D    1           ' NS4=',I4,' ELEMENTS. THIS ARRAY MUST BE'/
D    2           ' DIMENSIONED TO AT LEAST ',I4,' ELEMENTS'/
D    3           ' TO CONTAIN ALL OF THE DATA IN PRODUCT'/
D    4           ' DEFINITION TEMPLATE 4.9.'/)
         IER=402
         GO TO 900
      ENDIF
C        
C        UNPACK THE PARAMETER CATEGORY.
      CALL UNPKBG(KFILDO,IPACK,ND5,LOCN,IPOS,IS4(10),8,N,IER,*900)
C
C        UNPACK THE PARAMETER NUMBER.
      CALL UNPKBG(KFILDO,IPACK,ND5,LOCN,IPOS,IS4(11),8,N,IER,*900)
C
C        UNPACK THE TYPE OF GENERATING PROCESS.
      CALL UNPKBG(KFILDO,IPACK,ND5,LOCN,IPOS,IS4(12),8,N,IER,*900)
C
C        UNPACK THE BACKGROUND GENERATING PROCESS IDENTIFIER.
      CALL UNPKBG(KFILDO,IPACK,ND5,LOCN,IPOS,IS4(13),8,N,IER,*900)
C
C        UNPACK THE ANALYSIS OR FORECAST GENERATING PROCESS IDENTIFIER.
      CALL UNPKBG(KFILDO,IPACK,ND5,LOCN,IPOS,IS4(14),8,N,IER,*900)
C
C        UNPACK THE HOURS OF OBSERVATIONAL DATA CUTOFF AFTER 
C        REFERENCE TIME.
      CALL UNPKBG(KFILDO,IPACK,ND5,LOCN,IPOS,IS4(15),16,N,IER,*900)
C
C        UNPACK THE MINUTES OF OBSERVATIONAL DATA CUTOFF AFTER
C        REFERENCE TIME.
      CALL UNPKBG(KFILDO,IPACK,ND5,LOCN,IPOS,IS4(17),8,N,IER,*900)
C
C        UNPACK THE INDICATOR OF UNIT OF TIME RANGE.
      CALL UNPKBG(KFILDO,IPACK,ND5,LOCN,IPOS,IS4(18),8,N,IER,*900)
C
C        UNPACK THE FORECAST TIME IN UNITS DEFINED BY OCTET 18.
      CALL UNPKBG(KFILDO,IPACK,ND5,LOCN,IPOS,IS4(19),32,N,IER,*900)
C
C        UNPACK THE TYPE OF FIRST FIXED SURFACE.
      CALL UNPKBG(KFILDO,IPACK,ND5,LOCN,IPOS,IS4(23),8,N,IER,*900)
C
C        UNPACK THE SCALE FACTOR OF FIRST FIXED SURFACE.
      CALL UNPKBG(KFILDO,IPACK,ND5,LOCN,IPOS,ISIGN,1,N,IER,*900)
      CALL UNPKBG(KFILDO,IPACK,ND5,LOCN,IPOS,IS4(24),7,N,IER,*900)
      IF(ISIGN.EQ.1)IS4(24)=-IS4(24)
C
C        UNPACK THE SCALED VALUE OF FIRST FIXED SURFACE.
      CALL UNPKBG(KFILDO,IPACK,ND5,LOCN,IPOS,IS4(25),32,N,IER,*900)
C
C        UNPACK THE TYPE OF SECOND FIXED SURFACE.
      CALL UNPKBG(KFILDO,IPACK,ND5,LOCN,IPOS,IS4(29),8,N,IER,*900)
C
C        UNPACK THE SCALE FACTOR OF SECOND FIXED SURFACE.
      CALL UNPKBG(KFILDO,IPACK,ND5,LOCN,IPOS,ISIGN,1,N,IER,*900)
      CALL UNPKBG(KFILDO,IPACK,ND5,LOCN,IPOS,IS4(30),7,N,IER,*900)
      IF(ISIGN.EQ.1)IS4(30)=-IS4(30)
C
C        UNPACK THE SCALED VALUE OF SECOND FIXED SURFACE.
      CALL UNPKBG(KFILDO,IPACK,ND5,LOCN,IPOS,IS4(31),32,N,IER,*900)
C
C        UNPACK THE FORECAST PROBABILITY NUMBER.
      CALL UNPKBG(KFILDO,IPACK,ND5,LOCN,IPOS,IS4(35),8,N,IER,*900)
C
C        UNPACK THE TOTAL NUMBER OF FORECAST PROBABILITIES.
      CALL UNPKBG(KFILDO,IPACK,ND5,LOCN,IPOS,IS4(36),8,N,IER,*900)
C
C        UNPACK THE PROBABILITY TYPE.
      CALL UNPKBG(KFILDO,IPACK,ND5,LOCN,IPOS,IS4(37),8,N,IER,*900)
C
C        UNPACK THE SCALE FACTOR OF LOWER LIMIT.
      CALL UNPKBG(KFILDO,IPACK,ND5,LOCN,IPOS,IS4(38),8,N,IER,*900)
C
C        UNPACK THE SCALED VALUE OF LOWER LIMIT.
      CALL UNPKBG(KFILDO,IPACK,ND5,LOCN,IPOS,IS4(39),32,N,IER,*900)
C
C        UNPACK THE SCALE VALUE OF UPPER LIMIT.
      CALL UNPKBG(KFILDO,IPACK,ND5,LOCN,IPOS,IS4(43),8,N,IER,*900)
C
C        UNPACK THE SCALED VALUE OF UPPER LIMIT.
      CALL UNPKBG(KFILDO,IPACK,ND5,LOCN,IPOS,IS4(44),32,N,IER,*900)
C
C        UNPACK YEAR OF END OF OVERALL TIME INTERVAL. 
      CALL UNPKBG(KFILDO,IPACK,ND5,LOCN,IPOS,IS4(48),16,N,IER,*900)
C
C        UNPACK MONTH OF END OF OVERALL TIME INTERVAL. 
      CALL UNPKBG(KFILDO,IPACK,ND5,LOCN,IPOS,IS4(50),8,N,IER,*900)
C
C        UNPACK DAY OF END OF OVERALL TIME INTERVAL. 
      CALL UNPKBG(KFILDO,IPACK,ND5,LOCN,IPOS,IS4(51),8,N,IER,*900)
C
C        UNPACK HOUR OF END OF OVERALL TIME INTERVAL. 
      CALL UNPKBG(KFILDO,IPACK,ND5,LOCN,IPOS,IS4(52),8,N,IER,*900)
C
C        UNPACK MINUTE OF END OF OVERALL TIME INTERVAL.  
      CALL UNPKBG(KFILDO,IPACK,ND5,LOCN,IPOS,IS4(53),8,N,IER,*900)
C
C        UNPACK SECOND OF END OF OVERALL TIME INTERVAL. 
      CALL UNPKBG(KFILDO,IPACK,ND5,LOCN,IPOS,IS4(54),8,N,IER,*900)
C
C        UNPACK THE NUMBER OF TIME RANGE SPECIFICATIONS DESCRIBING
C        THE TIME INTERVALS USED TO CALCULATE THE STATISTICALLY
C        PROCESSED FIELD.
      CALL UNPKBG(KFILDO,IPACK,ND5,LOCN,IPOS,IS4(55),8,N,IER,*900)
C
C        CHECK TO MAKE SURE THAT IS4( ) WAS DIMENSIONED LARGE ENOUGH
C        TO CONTAIN THE DATA FOR ALL OF THE IS4(55) TIME RANGES.
C
      ISIZE=56+12*(IS4(55)-1)
      IF(NS4.LT.ISIZE)THEN
D        WRITE(KFILDO,19)NS4,ISIZE
D19      FORMAT(/' IS4( ) IS CURRENTLY DIMENSIONED TO CONTAIN'/
D    1           ' NS4=',I4,' ELEMENTS.  THIS ARRAY MUST BE'/
D    2           ' DIMENSIONED TO AT LEAST ',I4,' ELEMENTS'/
D    3           ' TO CONTAIN ALL OF THE TIME RANGES'/
D    4           ' IN PRODUCT DEFINITION TEMPLATE 4.9.'/)
         IER=402
         GO TO 900
      ENDIF
C
      DO 30 I=1,IS4(55)
         IC=12*(I-1)
C
C           UNPACK THE TOTAL NUMBER OF DATA VALUES MISSING IN
C           STATISTICAL PROCESS.
         CALL UNPKBG(KFILDO,IPACK,ND5,LOCN,IPOS,IS4(56+IC),32,N,
     1               IER,*900)
C
C           UNPACK THE STATISTICAL PROCESS USED TO CALCULATE THE
C           PROCESSED FIELD FROM THE FIELD AT EACH TIME INCREMENT
C           DURING THE TIME RANGE.
         CALL UNPKBG(KFILDO,IPACK,ND5,LOCN,IPOS,IS4(60+IC),8,N,
     1               IER,*900)
C
C           UNPACK THE TYPE OF TIME INCREMENT BETWEEN SUCCESSIVE
C           FIELDS USED IN THE STATISTICAL PROCESS.
         CALL UNPKBG(KFILDO,IPACK,ND5,LOCN,IPOS,IS4(61+IC),8,N,
     1               IER,*900)
C
C           UNPACK THE INDICATOR OF UNIT OF TIME FOR TIME RANGE OVER
C           WHICH STATISTICAL PROCESSING IS DONE.
         CALL UNPKBG(KFILDO,IPACK,ND5,LOCN,IPOS,IS4(62+IC),8,N,
     1               IER,*900)
C
C           UNPACK THE LENGTH OF THE TIME RANGE OVER WHICH STATISTICAL
C           PROCESSING IS DONE, IN UNITS DEFINED BY THE PREVIOUS
C           OCTET.
         CALL UNPKBG(KFILDO,IPACK,ND5,LOCN,IPOS,IS4(63+IC),32,N,
     1               IER,*900)
C
C           UNPACK THE INDICATOR OF UNIT OF TIME FOR THE INCREMENT
C           BETWEEN THE SUCCESSIVE FIELDS USED.
         CALL UNPKBG(KFILDO,IPACK,ND5,LOCN,IPOS,IS4(67+IC),8,N,
     1               IER,*900)
C
C           UNPACK THE TIME INCREMENT BETWEEN SUCCESSIVE FIELDS,
C           IN UNITS DEFINED BY THE PREVIOUS OCTET.
         CALL UNPKBG(KFILDO,IPACK,ND5,LOCN,IPOS,IS4(68+IC),32,N,
     1               IER,*900)
C
 30   ENDDO
C
C       ERROR RETURN SECTION
C
 900  IF(IER.NE.0)RETURN 1
C
      RETURN
      END

      SUBROUTINE UNPK_SECT1(KFILDO,IPACK,ND5,IS1,NS1,L3264B,
     1                      LOCN,IPOS,IER,ISEVERE,*)
C
C        MARCH    2000   LAWRENCE  GSC/TDL   ORIGINAL CODING
C        JANUARY  2001   GLAHN     COMMENTS; ELIMINATED EXISTS;
C                                  SET IER = 100 WHEN IS1(5) DOES
C                                  NOT INDICATE SECTION 1
C        FEBRUARY 2001   GLAHN     CHECKED SIZE OF NS1
C        NOVEMBER 2001   GLAHN     MOVED ISEVERE=2 UP TO BEGINNING
C
C        PURPOSE
C            UNPACKS SECTION 1, THE IDENTIFICATION SECTION, OF A GRIB2
C            MESSAGE.
C
C        DATA SET USE
C           KFILDO - UNIT NUMBER FOR OUTPUT (PRINT) FILE. (OUTPUT)
C
C        VARIABLES
C              KFILDO = UNIT NUMBER FOR OUTPUT (PRINT) FILE. (INPUT)
C            IPACK(J) = THE ARRAY THAT HOLDS THE ACTUAL PACKED MESSAGE
C                       (J=1,ND5). (INPUT/OUTPUT)
C                 ND5 = THE SIZE OF THE ARRAY IPACK( ). (INPUT)
C              IS1(J) = THE IDENTIFICATION DATA THAT IS UNPACKED FROM
C                       IPACK( ) IS WRITTEN TO THIS ARRAY (J=1,NS1).
C                       (OUTPUT)
C                 NS1 = SIZE OF IS1( ). (INPUT)
C              L3264B = THE INTEGER WORD LENGTH IN BITS OF THE MACHINE
C                       BEING USED. VALUES OF 32 AND 64 ARE
C                       ACCOMMODATED. (INPUT)
C                LOCN = THE WORD POSITION FROM WHICH TO UNPACK THE
C                       NEXT VALUE. (INPUT/OUTPUT)
C                IPOS = THE BIT POSITION IN LOCN FROM WHICH TO START
C                       UNPACKING THE NEXT VALUE.  (INPUT/OUTPUT)
C                 IER = RETURN STATUS CODE. (OUTPUT)
C                          0 = GOOD RETURN.
C                        6-8 = ERROR CODES GENERATED BY UNPKBG. SEE THE
C                              DOCUMENTATION IN THE UNPKBG ROUTINE.
C                        100 = NO SECTION 1 ON A NEW PRODUCT.
C                        102 = IS1( ) HAS NOT BEEN DIMENSIONED LARGE
C                              ENOUGH TO CONTAIN THE ENTIRE TEMPLATE. 
C                        199 = UNEXPECTED END OF MESSAGE.
C             ISEVERE = THE SEVERITY LEVEL OF THE ERROR.  THE ONLY
C                       VALUE RETUNED IS:
C                       2 = A FATAL ERROR  (OUTPUT)
C                   * = ALTERNATE RETURN WHEN IER NE 0.
C
C             LOCAL VARIABLES
C             LOCN1_1 = SAVES THE WORD POSITION LOCN IN IPACK
C                       UPON ENTRY TO STORE BACK TO LOCN IN CASE
C                       THERE IS A FATAL ERROR.
C             IPOS1_1 = SAVES THE BIT POSITION IPOS IN LOCN
C                       UPON ENTRY TO STORE BACK TO IPOS IN CASE
C                       THERE IS A FATAL ERROR.
C               LSECT = CONTAINS THE LENGTH OF SECTION 1
C                       AS UNPACKED FROM THE FIRST FOUR
C                       BYTES IN THE SECTION.
C               NSECT = SECTION NUMBER.
C                   K = A LOOPING INDEX VARIABLE.
C                   N = L3264B = THE INTEGER WORD LENGTH IN BITS OF
C                       THE MACHINE BEING USED. VALUES OF 32 AND
C                       64 ARE ACCOMMODATED.
C
C        NON SYSTEM SUBROUTINES CALLED
C           ENDOMESS, UNPKBG
C
      DIMENSION IPACK(ND5),IS1(NS1)
C
      LOGICAL ENDOMESS
C
      N=L3264B
      IER=0
C
C        ANY ERRORS GENERATED FROM WITHIN THIS ROUTINE WILL BE FATAL.
      ISEVERE=2
C
C        CHECK SIZE OF IS1( ).
C
      IF(NS1.LT.21)THEN
         IER=102
         GO TO 900
      ENDIF
C
      LOCN1_1=LOCN
      IPOS1_1=IPOS
C
C        UNPACK SECTION LENGTH, LSECT.
      CALL UNPKBG(KFILDO,IPACK,ND5,LOCN,IPOS,LSECT,32,N,IER,*900)
C
C        CHECK FOR AN UNEXPECTED END OF MESSAGE.
      IF(ENDOMESS(LSECT,N))THEN
         IER=199
         GO TO 900
      ENDIF
C
C        UNPACK THE SECTION NUMBER. CHECK TO SEE IF THIS
C        IS SECTION 1.
      CALL UNPKBG(KFILDO,IPACK,ND5,LOCN,IPOS,NSECT,8,N,IER,*900)
C
      IF(NSECT.NE.1)THEN
         IER=100
C           A SECTION 1 MUST BE PRESENT WHEN UNPK_SECT1 IS CALLED
C           OR IT IS A FATAL ERROR.
         LOCN=LOCN1_1
         IPOS=IPOS1_1 
         GO TO 900 
      ENDIF
C
      DO K=1,NS1
         IS1(K)=0
      ENDDO
C
      IS1(1)=LSECT
      IS1(5)=NSECT
C
C        UNPACK OCTETS 6 THRU 13.
      CALL UNPKBG(KFILDO,IPACK,ND5,LOCN,IPOS,IS1(6),16,N,IER,*900)
      CALL UNPKBG(KFILDO,IPACK,ND5,LOCN,IPOS,IS1(8),16,N,IER,*900)  
      CALL UNPKBG(KFILDO,IPACK,ND5,LOCN,IPOS,IS1(10),8,N,IER,*900)  
      CALL UNPKBG(KFILDO,IPACK,ND5,LOCN,IPOS,IS1(11),8,N,IER,*900)  
      CALL UNPKBG(KFILDO,IPACK,ND5,LOCN,IPOS,IS1(12),8,N,IER,*900)
      CALL UNPKBG(KFILDO,IPACK,ND5,LOCN,IPOS,IS1(13),16,N,IER,*900)
C
C         UNPACK OCTETS 15 THRU 21.      
C
      DO 160 K=15,21
         CALL UNPKBG(KFILDO,IPACK,ND5,LOCN,IPOS,IS1(K),8,N,IER,*900)  
 160  CONTINUE
C
C       ERROR RETURN SECTION
 900  IF(IER.NE.0)RETURN 1
C
      RETURN
      END

      SUBROUTINE UNPKBMAP(KFILDO,IPACK,ND5,IB,NXY,L3264B,
     1                    LOCN,IPOS,IER,*)
C
C       MARCH   2000   LAWRENCE   GSC/TDL   ORIGINAL CODING
C       JANUARY 2001   GLAHN      COMMENTS
C       MARCH   2001   LAWRENCE   ADDED A LINE OF CODE TO ZERO
C                                 OUT EACH ELEMENT OF IB( )
C                                 BEFORE THE BIT-MAP IS READ INTO
C                                 IT. 
C
C        PURPOSE
C           UNPACKS THE BIT-MAP FROM THE IPACK ARRAY INTO IB(NXY).
C           THIS ROUTINE WAS DEVELOPED TO MAKE THE PROCESS OF UNPACKING
C           A BIT-MAP EFFICIENT BY REDUCING THE NUMBER OF CALLS
C           TO UNPKBG.
C
C        DATA SET USE
C           KFILDO - UNIT NUMBER FOR OUTPUT (PRINT) FILE. (OUTPUT)
C
C        VARIABLES
C              KFILDO = UNIT NUMBER FOR OUTPUT (PRINT) FILE. (INPUT)
C            IPACK(J) = THE ARRAY THAT HOLDS THE ACTUAL PACKED
C                       MESSAGE (J=1,ND5). (INPUT)
C                 ND5 = THE SIZE OF THE ARRAY IPACK( ). (INPUT)
C               IB(J) = THE UNPACKED BIT-MAP GOES IN HERE.
C                       (J=1,NXY). (OUTPUT)
C                 NXY = THE DIMENSIONS OF IB( ). THIS
C                       REFLECTS THE TRUE SIZE OF THE PRODUCT. (INPUT)
C              L3264B = THE INTEGER WORD LENGTH IN BITS OF THE MACHINE
C                       BEING USED. VALUES OF 32 AND 64 ARE
C                       ACCOMMODATED. (INPUT)
C                LOCN = THE WORD POSITION FROM WHICH TO UNPACK THE
C                       NEXT VALUE. (INPUT/OUTPUT)
C                IPOS = THE BIT POSITION IN LOCN FROM WHICH TO START
C                       UNPACKING THE NEXT VALUE.  (INPUT/OUTPUT)
C                 IER = RETURN STATUS CODE. (OUTPUT)
C                         0 = GOOD RETURN.
C                       6-8 = ERROR CODES GENERATED BY UNPKBG. SEE THE
C                             DOCUMENTATION IN THE UNPKBG ROUTINE.
C                   * = ALTERNATIVE ERROR RETURN.
C
C             LOCAL VARIABLES
C               IFILL = CONTAINS THE NUMBER OF BITS ZERO-PADDED 
C                       TO MAKE THE PACKED BIT-MAP OCCUPY A
C                       WHOLE NUMBER OF OCTETS.
C              ITRASH = HOLDS EXTRANEOUS INFORMATION READ IN
C                       FROM IPACK.
C                   J = LOOP INDEX.
C                   N = AN ABBREVIATED FORM OF L3264B. THIS IS 
C                       HELPFUL IN KEEPING THE LINES OF CODE
C                       UNDER 72 COLUMNS.
C
C        NON SYSTEM SUBROUTINES CALLED
C           UNPKBG
C
      DIMENSION IPACK(ND5),IB(NXY)
C
      N=L3264B
C
      DO J=1,NXY
C
         IB(J)=0
         CALL MVBITS(IPACK(LOCN),N-IPOS,1,IB(J),0)
C
         IF(IPOS.EQ.N)THEN
            IPOS=1
            LOCN=LOCN+1
         ELSE
            IPOS=IPOS+1
         ENDIF
      END DO
C
C        DETERMINE IF SOME TRAILING BITS NEED TO BE UNPACKED 
C        BECAUSE THE PACKED BIT-MAP DID NOT OCCUPY A WHOLE
C        NUMBER OF OCTETS. 
      IFILL=MOD(33-IPOS,8)
C
      IF(IFILL.NE.0)THEN
         CALL UNPKBG(KFILDO,IPACK,ND5,LOCN,IPOS,ITRASH,IFILL,N,IER,*900)
      ENDIF
C
C       ERROR RETURN SECTION
C
 900  IF(IER.NE.0)RETURN 1
C
      RETURN
      END

      SUBROUTINE UNPK_TEMP41(KFILDO,IPACK,ND5,IS4,NS4,L3264B,
     1                       LOCN,IPOS,IER,*)
C
C        MARCH    2000   LAWRENCE  GSC/TDL    ORIGINAL CODING
C        JANUARY  2001   GLAHN     COMMENTS; CHANGED TO STANDARD 
C                                  RETURN SEQUENCE; CHANGED IER = 14
C                                  TO 402  
C        FEBRUARY 2001   GLAHN     CHECKED TEMPLATE NUMBER; COMMENTS
C
C        PURPOSE
C            UNPACKS TEMPLATE 1, AN INDIVIDUAL EMSEMBLE FORECAST TEMPLATE,
C            FROM THE PRODUCT DEFINITION SECTION OF A GRIB2 MESSAGE.
C            IT IS THE RESPONSIBILITY OF THE CALLING ROUTINE TO UNPACK 
C            THE FIRST 9 OCTETS IN SECTION 4.
C
C        DATA SET USE
C           KFILDO - UNIT NUMBER FOR OUTPUT (PRINT) FILE. (OUTPUT)
C
C        VARIABLES
C              KFILDO = UNIT NUMBER FOR OUTPUT (PRINT) FILE. (INPUT)
C            IPACK(J) = THE ARRAY THAT HOLDS THE ACTUAL PACKED MESSAGE
C                       (J=1,ND5). (INPUT/OUTPUT)
C                 ND5 = THE SIZE OF THE ARRAY IPACK( ). (INPUT)
C              IS4(J) = THE PRODUCT DEFINITION INFORMATION FOR
C                       TEMPLATE 4.1 IS WRITTEN TO ELEMENTS 10 THROUGH
C                       37 AS IT IS UNPACKED FROM IPACK( ) (J=1,NS4).
C                       (INPUT/OUTPUT)
C                 NS4 = SIZE OF IS4( ). (INPUT) 
C              L3264B = THE INTEGER WORD LENGTH IN BITS OF THE MACHINE
C                       BEING USED. VALUES OF 32 AND 64 ARE
C                       ACCOMMODATED. (INPUT)
C                LOCN = THE WORD POSITION FROM WHICH TO UNPACK THE
C                       NEXT VALUE. (INPUT/OUTPUT)
C                IPOS = THE BIT POSITION IN LOCN FROM WHICH TO START
C                       UNPACKING THE NEXT VALUE.  (INPUT/OUTPUT)
C                 IER = RETURN STATUS CODE. (OUTPUT)
C                         0 = GOOD RETURN.
C                       6-8 = ERROR CODES GENERATED BY UNPKBG. SEE THE 
C                             DOCUMENTATION IN THE UNPKBG ROUTINE.
C                       402 = IS4( ) HAS NOT BEEN DIMENSIONED LARGE
C                             ENOUGH TO CONTAIN THE ENTIRE TEMPLATE.
C                       403 = NOT THE CORRECT TEMPLATE. 
C                   * = ALTERNATE RETURN WHEN IER NE 0. 
C
C             LOCAL VARIABLES
C             MINSIZE = THE SMALLEST ALLOWABLE DIMENSION FOR IS4( ).
C                   N = L3264B = THE INTEGER WORD LENGTH IN BITS OF
C                       THE MACHINE BEING USED. VALUES OF 32 AND
C                       64 ARE ACCOMMODATED.
C
C        NON SYSTEM SUBROUTINES CALLED
C           UNPKBG, UNPK_TEMP40
C
      PARAMETER(MINSIZE=37)
C
      DIMENSION IPACK(ND5),IS4(NS4)
C
      N=L3264B
      IER=0
C
C        CHECK TO MAKE SURE THAT THIS IS TEMPLATE 4.1. 
C
      IF(IS4(8).NE.1)THEN
D        WRITE(KFILDO,10)IS4(8)
D10      FORMAT(/' TEMPLATE ',I4,' INDICATED BY IS4(8)'/
D    1           ' IS NOT CORRECT IN UNPK_TEMP41.'/)
         IER=403
         GO TO 900
      ENDIF
C
C        CHECK THE DIMENSIONS OF IS4( ).
c
      IF(NS4.LT.MINSIZE)THEN
D        WRITE(KFILDO,20)NS4,MINSIZE
D20      FORMAT(/' IS4( ) IS CURRENTLY DIMENSIONED TO CONTAIN'/
D    1           ' NS4=',I4,' ELEMENTS. THIS ARRAY MUST BE'/
D    2           ' DIMENSIONED TO AT LEAST ',I4,' ELEMENTS'/
D    3           ' TO CONTAIN ALL OF THE DATA IN PRODUCT'/
D    4           ' DEFINITION TEMPLATE 4.1.'/)
         IER=402
         GO TO 900
      ENDIF
C
C        SINCE THIS TEMPLATE SHARES THE SAME INFORMATION
C        AS TEMPLATE 4.0, CALL THE UNPK_TEMP40 ROUTINE
C        TO RETRIEVE OCTETS 10 THROUGH 34.
C
      CALL UNPK_TEMP40(KFILDO,IPACK,ND5,IS4,NS4,L3264B,LOCN,IPOS,
     1                 *900)
C
C        UNPACK THE TYPE OF ENSEMBLE FORECAST
      CALL UNPKBG(KFILDO,IPACK,ND5,LOCN,IPOS,IS4(35),8,N,IER,*900)
C
C        UNPACK THE PERTURBATION NUMBER
      CALL UNPKBG(KFILDO,IPACK,ND5,LOCN,IPOS,IS4(36),8,N,IER,*900)
C
C        UNPACK THE NUMBER OF FORECASTS IN ENSEMBLE
      CALL UNPKBG(KFILDO,IPACK,ND5,LOCN,IPOS,IS4(37),8,N,IER,*900)
C
C       ERROR RETURN SECTION
c
 900  IF(IER.NE.0)RETURN 1
C
      RETURN
      END

      SUBROUTINE UNPK_SECT2(KFILDO,IPACK,ND5,IS2,NS2,RDAT,NRDAT,IDAT,
     1                      NIDAT,L3264B,LOCN,IPOS,EXISTS,IER,
     2                      ISEVERE,*)
C
C        FEBRUARY 2001   LAWRENCE   GSC/MDL  ORIGINAL CODING
C        NOVEMBER 2001   GLAHN   CHECKED IER AFTER CALL TO UNPKLXBM;
C                                MOVED ISEVERE=2 UP TO BEGINNING
C
C        PURPOSE
C            UNPACKS SECTION 2, THE LOCAL USE SECTION, OF A
C            GRIB2 MESSAGE.  SECTION 2 IS OPTIONAL.
C
C            THIS ROUTINE EXPECTS THE PACKED DATA IN SECTION 2 OF
C            THE GRIB2 MESSAGE TO HAVE THE FOLLOWING FORMAT:
C            SECTION 2 OCTET(S)   DESCRIPTION
C            1-4                  TOTAL LENGTH OF SECTION 2
C            5                    SECTION NUMBER (2)
C            6                    SECTION 2 FORMAT VERSION NUMBER
C            7-8                  TOTAL NUMBER OF DATA GROUPS IN
C                                 THE LOCAL USE SECTION (N)
C            9-12                 NUMBER OF VALUES IN FIRST
C                                 GROUP OF LOCAL USE DATA (N1)
C            13-16                REFERENCE VALUE OF FIRST GROUP OF
C                                 DATA
C            17-18                DECIMAL SCALE FACTOR
C            19                   NUMBER OF BITS USED TO PACK EACH
C                                 VALUE OF THE FIRST GROUP OF DATA
C            20                   TYPE OF DATA IN FIRST GROUP OF DATA
C                                 ("0" = FLOATING POINT, "1" =
C                                 INTEGER)
C            21-NN                THE VALUES OF THE FIRST GROUP OF
C                                 DATA PACKED USING THE SIMPLE PACKING
C                                 METHOD
C            (NN+1)-(NN+4)        THE NUMBER OF VALUES IN THE SECOND
C                                 GROUP OF DATA
C            (NN+5)-(NN+8)        THE REFERENCE VALUE OF THE SECOND
C                                 GROUP OF DATA
C            (NN+9)-(NN+10)       THE DECIMAL SCALE FACTOR OF THE
C                                 SECOND GROUP OF DATA
C            (NN+11)              THE NUMBER OF BITS USED TO PACK EACH
C                                 VALUE OF THE SECOND GROUP OF DATA
C            (NN+12)              TYPE OF DATA IN THE SECOND GROUP OF
C                                 DATA ("0" = FLOATING POINT, "1" =
C                                 INTEGER)
C            (NN+13) - MM         THE SECOND GROUP OF DATA PACKED
C                                 USING THE SIMPLE PACKING METHOD
C
C            THIS PATTERN REPEATS ITSELF FOR EACH OF THE N GROUPS
C            OF LOCAL USE DATA SPECIFIED IN OCTETS 7-8 OF THIS
C            SECTION.
C
C            THIS ROUTINE ALLOWS THE FOR THE EXISTENCE OF BOTH
C            INTEGER AND FLOATING POINT GROUPS OF LOCAL USE DATA
C            IN SECTION 2 OF THE GRIB2 MESSAGE BEING UNPACKED.  EACH
C            OF THESE GROUPS OF DATA (THE NUMBER OF WHICH IS SPECIFIED
C            BY OCTETS 6-7 OF SECTION 2) IS UNPACKED USING THE  
C            SIMPLE UNPACKING METHOD.  UNPACKED GROUPS OF INTEGER
C            LOCAL USE DATA ARE PLACED INTO THE IDAT( ) ARRAY.
C            UNPACKED GROUPS OF FLOATING POINT LOCAL USE DATA ARE
C            PLACED INTO THE RDAT( ) ARRAY.  THE UNPACKED GROUPS OF
C            LOCAL USE DATA ARE RETURNED TO THE USER IN THE IDAT( )
C            AND RDAT( ) ARRAYS USING THE FOLLOWING FORMAT:
C
C            FOR 1 TO K GROUPS OF DATA:
C
C            RDAT(1)        = NUMBER OF VALUES IN THE FIRST GROUP
C                             OF LOCAL USE DATA (N1)
C            RDAT(2)        = THE DECIMAL SCALE FACTOR USED IN
C                             UNPACKING THE FIRST GROUP OF LOCAL USE
C                             DATA.
C            RDAT(3)
C            -RDAT(N1+2)    = FIRST GROUP OF LOCAL USE DATA VALUES
C            RDAT(N1+3))    = NUMBER OF VALUES IN THE SECOND GROUP OF
C                             LOCAL USE DATA (N2)
C            RDAT(N1+4)     = THE DECIMAL SCALE FACTOR USED IN 
C                             UNPACKING THE SECOND GROUP OF LOCAL USE
C                             DATA.
C            RDAT(N1+5)
C            -RDAT(N1+N2+4) = SECOND GROUP OF LOCAL USE DATA
C                             VALUES
C
C                               ........
C
C            RDAT((K-1)*2+1+N1+N2+...+N(k-1))  = NUMBER OF VALUES IN
C                                                THE Kth GROUP OF DATA
C                                                (Nk)
C            RDAT((K-1)*2+2+N1+N2+...+N(k-1))  = THE DECIMAL SCALE
C                                                FACTOR USED IN
C                                                UNPACKING THE Kth
C                                                GROUP OF DATA
C            RDAT((K-1)*2+3+N1+N2+...+N(k-1)) -
C            RDAT((K-1)*2+N1+N2+...+N(k-1)+Nk) = THE NUMBER OF
C                                                VALUES IN THE Kth
C                                                GROUP OF DATA
C            RDAT((K-1)*2+1+N1+N2+...+Nk)      = 0 NO MORE DATA
C
C            ALTHOUGH THE RDAT( ) ARRAY WAS USED IN THE EXAMPLE
C            ABOVE, THE SAME FORMAT APPLIES TO THE LOCAL USE DATA
C            STORED IN THE IDAT( ) ARRAY. 
C            
C            SINCE SECTION 2 IS OPTIONAL, IT IS POSSIBLE THAT
C            THERE IS NO LOCAL USE DATA PRESENT IN THE GRIB2
C            MESSAGE.  IN THE CASE WHERE THERE IS NO SECTION 2
C            PACKED IN THE MESSAGE, THE "EXISTS" CALLING 
C            ARGUMENT (SEE BELOW) WILL BE SET TO .FALSE., THE
C            VALUES OF IDAT(1) AND RDAT(1) WILL BE "0", AND THE 
C            LENGTH OF SECTION 2 SPECIFIED BY IS2(1) WILL BE
C            "0".
C
C            BEFORE THIS ROUTINE ATTEMPTS TO UNPACK THE DATA IN
C            SECTION 2, IT CHECKS TO MAKE SURE THAT THE DATA 
C            IS IN A FORMAT THAT THIS ROUTINE CAN INTERPRET.
C            IT DOES THIS BY CHECKING THE VERSION NUMBER CONTAINED
C            IN OCTET 6 OF SECTION 2.  IF THIS VERSION NUMBER IS
C            NOT "1", THEN IT RETURNS A NON-FATAL ERROR CODE OF
C            208 INDICATING THAT THERE WAS DATA IN THE LOCAL
C            USE SECTION, BUT IT WAS SKIPPED AND NOT UNPACKED.
C            
C        DATA SET USE
C           KFILDO - UNIT NUMBER FOR OUTPUT (PRINT) FILE. (OUTPUT)
C
C        VARIABLES
C              KFILDO = UNIT NUMBER FOR OUTPUT (PRINT) FILE. (INPUT)
C            IPACK(J) = THE ARRAY THAT HOLDS THE ACTUAL PACKED MESSAGE
C                       (J=1,ND5). (INPUT)
C                 ND5 = THE SIZE OF THE ARRAY IPACK( ). (INPUT)
C              IS2(J) = CONTAINS THE SIZE OF SECTION 2 IN ELEMENTS
C                       1-4, THE SECTION NUMBER "2" IN ELEMENT 5,
C                       AND THE TOTAL NUMBER OF DATA GROUPS PACKED IN
C                       SECTION 2 IN ELEMENT 6 (J=1,NS2).  (OUTPUT)
C                 NS2 = SIZE OF IS2( ). SHOULD BE AT LEAST "6". (INPUT)
C             RDAT(J) = THE ARRAY CONTAINING THE LOCAL USE GROUPS
C                       CONSISTING OF FLOATING POINT DATA UNPACKED
C                       FROM SECTION 2 (J=1,NRDAT).  (OUTPUT)
C               NRDAT = THE DIMENSION OF THE RDAT( ) ARRAY.  (INPUT)
C             IDAT(J) = THE ARRAY CONTAINING THE LOCAL USE GROUPS
C                       CONSISTING OF INTEGER DATA UNPACKED FROM 
C                       SECTION 2 (J=1,NIDAT).  (OUTPUT) 
C               NIDAT = THE DIMENSION OF THE IDAT( ) ARRAY.  (INPUT)
C              L3264B = THE INTEGER WORD LENGTH IN BITS OF THE
C                       MACHINE BEING USED.  VALUES OF 32 AND 64 ARE
C                       ACCOMODATED.  (INPUT) 
C                LOCN = THE WORD POSITION TO PLACE THE NEXT VALUE.
C                       (INPUT/OUTPUT)
C                IPOS = THE BIT POSITION IN LOCN TO START PLACING
C                       THE NEXT VALUE.  (INPUT/OUTPUT)
C              EXISTS = INDICATES TO THE CALLING ROUTINE WHETHER OR NOT
C                       SECTION 2 EXISTS (LOGICAL).  (OUTPUT)
C                 IER = RETURN STATUS CODE. (OUTPUT)
C                        0 = GOOD RETURN.
C                        6-8 = ERROR CODES GENERATED BY UNPKBG AND
C                              UNPKLXBM. SEE THE DOCUMENTATION IN
C                              THE UNPKBG AND UNPKLXBM ROUTINES.
C                          9 = ERROR CODE GENERATED BY UNPKLXBM. SEE
C                              THE DOCUMENTATION IN THE UNPKLXBM
C                              ROUTINE.
C                        202 = IS2( ) HAS NOT BEEN DIMENSIONED LARGE
C                              ENOUGH TO CONTAIN THE ENTIRE TEMPLATE.
C                        204 = THE NUMBER LOCAL USE DATA GROUPS 
C                              SPECIFIED IN OCTET 6 OF SECTION 2 
C                              IS 0.
C                        206 = INVALID DATA TYPE INDICATOR VALUE
C                              IN SECTION 2.
C                        208 = THE DATA IN SECTION 2 HAS AN
C                              UNRECOGNIZED FORMAT.  IT HAS
C                              BEEN SKIPPED AND NOT UNPACKED
C                              (NON-FATAL ERROR RETURN).
C                        299 = UNEXPECTED END OF MESSAGE.
C             ISEVERE = THE SEVERITY LEVEL OF THE ERROR.
C                       1 = A WARNING.  A NON-FATAL ERROR (OUTPUT)
C                       2 = A FATAL ERROR  (OUTPUT)
C                   * = ALTERNATE ERROR RETURN.
C
C             LOCAL VARIABLES
C             IBMP(J) = THIS IS A DUMMY ARRAY USED IN PLACE OF
C                       THE BITMAP ARRAY ARGUMENT OF THE UNPKLXBM
C                       ROUTINE.  A BITMAP IS NOT USED WHILE UNPACKING
C                       LOCAL USE DATA FROM SECTION 2
C                       (J=1,NIDAT+NRDAT).
C               IFILL = CONTAINS THE NUMBER OF BITS PADDING THE
C                       END OF A PACKED GROUP OF LOCAL USE DATA
C                       FROM AN OCTET BOUNDARY.  
C              IGROUP = THE NUMBER OF GROUPS OF LOCAL USE DATA PACKED
C                       INTO SECTION 2 OF THE GRIB2 MESSAGE.
C               INDEX = A VARIABLE USED TO KEEP TRACK OF THE POSITION
C                       IN THE IDAT( ) ARRAY TO PLACE THE NEXT LOCAL
C                       USE DATA VALUE. 
C             IPOS2_1 = SAVES THE BIT POSITION IPOS IN LOCN
C                       UPON ENTRY TO STORE BACK TO IPOS IN CASE
C                       THERE IS NO SECTION 2 IN THE GRIB2 MESSAGE.
C               ISIZE = THE NUMBER OF VALUES IN THE GROUP OF LOCAL
C                       USE DATA CURRENTLY BEING UNPACKED.
C               ITYPE = THE TYPE OF THE VALUES IN THE GROUP OF
C                       LOCAL USE DATA CURRENTLY BEING UNPACKED.
C              IVALUE = EQUIVALENCED TO RVALUE.  USED TO RETRIEVE
C                       A FLOATING POINT REPRESENTATION OF A 
C                       FOUR BYTE INTEGER UNPACKED FROM THE GRIB2
C                       MESSAGE. 
C            IVERSION = THE VERSION NUMBER OF THE SECTION 2 FORMAT.
C                       THIS ROUTINE IS DESIGNED TO UNPACK VERSION
C                       1.
C                 J,K = LOOP INDEXES.
C               KNDEX = A VARIABLE USED TO KEEP TRACK OF THE POSITION
C                       IN THE RDAT( ) ARRAY TO STORE THE NEXT LOCAL
C                       USE DATA VALUE.
C             LOCN2_1 = SAVES THE WORD POSITION LOCN IN IPACK
C                       UPON ENTRY TO STORE BACK TO LOCN IN CASE
C                       THERE IS NO SECTION 2 IN THE GRIB2 MESSAGE.
C               LSECT = THE LENGTH OF SECTION 2.
C                   N = AN ALIAS FOR L3264B (SEE ABOVE).
C                NBIT = THE NUMBER OF BITS THAT WERE USED TO PACK
C                       EACH VALUE OF A LOCAL USE DATA GROUP.
C               NSECT = THE NUMBER OF THE SECTION THAT IS BEING
C                       UNPACKED.  IF THERE IS A SECTION 2 IN THIS
C                       GRIB2 MESSAGE, THEN THIS SHOULD HAVE A VALUE
C                       OF "2".
C                 REF = THE SMALLEST VALUE IN A GROUP OF LOCAL USE
C                       DATA VALUES.
C            RTEMP(J) = PROVIDES TEMPORARY STORAGE OF UNPACKED
C                       LOCAL USE DATA BEFORE IT IS COPIED INTO
C                       EITHER THE RDAT( ) OR IDAT( ) ARRAYS
C                       (J=1,NIDAT+NRDAT).
C              RVALUE = EQUIVALENCED TO IVALUE. USED TO RETRIEVE 
C                       THE FLOATING POINT REFERENCE VALUE (SEE "REF"
C                       ABOVE).
C              SCAL10 = THE DECIMAL SCALING FACTOR.
C               SCAL2 = THE BINARY SCALING FACTOR.  WHEN RETRIEVING
C                       DATA FROM SECTION 2, THIS WILL ALWAYS BE
C                       1.0 .
C
C        NON SYSTEM SUBROUTINES CALLED
C           ENDOMESS,UNPKBG,UNPKLXBM 
C
      LOGICAL ENDOMESS,EXISTS
C
      DIMENSION IDAT(NIDAT),IPACK(ND5),IS2(NS2),RDAT(NRDAT)
c      DIMENSION IBMP(NIDAT+NRDAT),RTEMP(NIDAT+NRDAT)  
      DIMENSION IBMP(100000),RTEMP(100000)  
C
      EQUIVALENCE(RVALUE,IVALUE)

	INTEGER IS2_TEMP(10)

      N=L3264B
      IER=0
C
C        NEARLY ALL ERRORS GENERATED BY THIS ROUTINE ARE FATAL.
      ISEVERE=2
C
C        CHECK THE SIZE OF IS2( ).  IT MUST BE AT LEAST 7 ELEMENTS
C        LARGE.  THE IS2( ) ARRAY IS ONLY USED TO RETURN THE SECTION 
C        SIZE, SECTION NUMBER, AND THE TOTAL NUMBER OF LOCAL USE
C        DATA GROUPS TO THE CALLER OF THIS ROUTINE.
      IF(NS2.LT.7)THEN
         IER=202
         GOTO 900
      ENDIF
C
      EXISTS=.TRUE.
C
      LOCN2_1=LOCN
      IPOS2_1=IPOS
C
C        UNPACK THE LENGTH OF THE SECTION.
      CALL UNPKBG(KFILDO,IPACK,ND5,LOCN,IPOS,LSECT,32,N,IER,*900)
C
C        CHECK FOR AN UNEXPECTED END OF MESSAGE.
      IF(ENDOMESS(LSECT,N))THEN
         IER=299
         GO TO 900
      ENDIF
C
C        UNPACK THE SECTION NUMBER.  CHECK TO SEE IF THIS IS
C        SECTION 2.
C
      CALL UNPKBG(KFILDO,IPACK,ND5,LOCN,IPOS,NSECT,8,N,IER,*900)
C
C        IS THIS SECTION 2?
      IF(NSECT.NE.2)THEN
         EXISTS=.FALSE.
         LOCN=LOCN2_1
         IPOS=IPOS2_1
         IS2(1)=0
         IDAT(1)=0
         RDAT(1)=0
         GO TO 900
      ENDIF
C
C        INITIALIZE THE IS2( ) ARRAY.
      DO 10 K=1,NS2
         IS2(K)=0
 10   CONTINUE
C
C        INITIALIZE THE IDAT( ) ARRAY.
      DO 20 K=1,NIDAT
         IDAT(K)=0
 20   CONTINUE      
C
C        INTIALIZE THE RDAT( ) ARRAY.
      DO 30 K=1,NRDAT
         RDAT(K)=0.
 30   CONTINUE      
C
      IS2(1)=LSECT
      IS2(5)=NSECT
C
C        UNPACK THE VERSION NUMBER OF THE SECTION 2 FORMAT.
      CALL UNPKBG(KFILDO,IPACK,ND5,LOCN,IPOS,IVERSION,8,N,IER,*900)
C
      IF(IVERSION.NE.1)THEN
         IER=208
         GOTO 910
      ENDIF
C
C        UNPACK THE TOTAL NUMBER OF LOCAL USE DATA GROUPS CONTAINED
C        WITHIN THIS PRODUCT.
      CALL UNPKBG(KFILDO,IPACK,ND5,LOCN,IPOS,IGROUP,16,N,IER,*900)
C
      IF(IGROUP.LE.0)THEN
         IER=204
         GOTO 900
      ENDIF
C
      IS2(6)=IGROUP
C
C        LOOP OVER AND UNPACK EACH GROUP OF LOCAL USE DATA
C        STORED IN SECTION 2 OF THIS GRIB2 MESSAGE.
      INDEX = 1
      KNDEX = 1
C
c	DO x = 1, NS2, 1
c	    IS2_TEMP(x) = IS2(x)
c	enddo
      DO 40 K=1,IGROUP
C
C           UNPACK THE NUMBER OF VALUES IN THE CURRENT GROUP
C           OF LOCAL USE DATA BEING RETRIEVED. 
         CALL UNPKBG(KFILDO,IPACK,ND5,LOCN,IPOS,ISIZE,32,N,IER,*900)
C
C           UNPACK THE REFERENCE VALUE OF THE CURRENT GROUP
C           OF LOCAL USE DATA BEING RETRIEVED. 
         CALL UNPKBG(KFILDO,IPACK,ND5,LOCN,IPOS,IVALUE,32,N,IER,*900)
         REF=RDIEEE(RVALUE)
C
C           UNPACK THE DECIMAL SCALE FACTOR OF THE CURRENT
C           GROUP OF LOCAL USE DATA BEING RETRIEVED.
         CALL UNPKBG(KFILDO,IPACK,ND5,LOCN,IPOS,ID,16,N,IER,*900)
C
C           UNPACK THE NUMBER OF BITS THAT WAS NEEDED TO PACK EACH
C           OF THE DATA VALUES IN THIS GROUP OF LOCAL USE DATA.
         CALL UNPKBG(KFILDO,IPACK,ND5,LOCN,IPOS,NBIT,8,N,IER,*900)
C
C           UNPACK THE TYPE OF THE VALUES CONTAINED WITHIN THIS 
C           GROUP OF LOCAL USE DATA. 
         CALL UNPKBG(KFILDO,IPACK,ND5,LOCN,IPOS,ITYPE,8,N,IER,*900)
C
C           DEPENDING ON THE TYPE OF DATA, UNPACK THE INFORMATION
C           INTO IDAT( ) OR RDAT( ).
C
         IF(ITYPE.EQ.0)THEN
C
C              FLOATING POINT DATA.  CHECK TO SEE IF RDAT( ) HAS BEEN
C              DIMENSIONED LARGE ENOUGH TO CONTAIN THE DATA IN THIS
C              GROUP PLUS ONE ADDITIONAL ELEMENT TO CONTAIN THE
C              THE SIZE OF THE NEXT DATA GROUP.
            IF(NRDAT.LT.(ISIZE+KNDEX+2))THEN
               IER=202
               GOTO 900
            ENDIF
C
            RDAT(KNDEX)=FLOAT(ISIZE)
            KNDEX=KNDEX+1
            RDAT(KNDEX)=FLOAT(ID)
            KNDEX=KNDEX+1
C
C              UNPACK THE DATA USING THE SIMPLE UNPACKING METHOD.
            SCAL10=10.**ID
            SCAL2=1.0
            CALL UNPKLXBM(KFILDO,IPACK,ND5,LOCN,IPOS,RTEMP,IBMP,ISIZE,
     1                    NBIT,0.,REF,0,1,SCAL10,SCAL2,.TRUE.,N,
     2                    IER)
            IF(IER.NE.0)GO TO 900
C
C              COPY THE LOCAL USE DATA FOR THIS GROUP FROM RTEMP( )
C              INTO RDAT( ).
            DO 50 J=1,ISIZE
               RDAT(KNDEX)=RTEMP(J)
               KNDEX=KNDEX+1
 50         CONTINUE
C
         ELSEIF(ITYPE.EQ.1)THEN
C
C              INTEGER DATA.  CHECK TO SEE IF IDAT( ) HAS BEEN
C              DIMENSIONED LARGE ENOUGH TO CONTAIN THE DATA IN THIS
C              GROUP PLUS ONE ADDITIONAL ELEMENT TO CONTAIN THE
C              THE SIZE OF THE NEXT DATA GROUP.
            IF(NIDAT.LT.(ISIZE+INDEX+2))THEN
               IER=202
               GOTO 900
            ENDIF
C
            IDAT(INDEX)=ISIZE
            INDEX=INDEX+1
            IDAT(INDEX)=ID
            INDEX=INDEX+1
C
C              UNPACK THE DATA USING THE SIMPLE UNPACKING METHOD.
            SCAL10=10.**ID
            SCAL2=1.0
            CALL UNPKLXBM(KFILDO,IPACK,ND5,LOCN,IPOS,RTEMP,IBMP,ISIZE,
     1                    NBIT,0.,REF,0,1,SCAL10,SCAL2,.TRUE.,N,
     2                    IER)
            IF(IER.NE.0)GO TO 900
C
C              COPY THE LOCAL USE DATA FOR THIS GROUP FROM RTEMP( )
C              INTO IDAT( ).
            DO 60 J=1,ISIZE
               IDAT(INDEX)=INT(RTEMP(J))
               INDEX=INDEX+1
 60         CONTINUE
C
         ELSE
C        
C              INVALID DATA TYPE INDICATOR VALUE.
            IER=206
            GOTO 900
         ENDIF 
c	do x = 1, NS2, 1
c	    IS2(x) = IS2_TEMP(x)
c	enddo
c	do x = 1, ISIZE, 1
c	    IDAT(x+2)=INT(RTEMP(x))
c	enddo
C
C           DETERMINE IF SOME TRAILING BITS NEED TO BE 
C           UNPACKED BECAUSE THE PACKED DATA GROUP DID NOT
C           OCCUPY A WHOLE NUMBER OF OCTETS.
         IFILL=MOD(33-IPOS,8)
C
         IF(IFILL.NE.0)THEN
            CALL UNPKBG(KFILDO,IPACK,ND5,LOCN,IPOS,ITRASH,IFILL,
     1                  N,IER,*900)
         ENDIF
C
 40   CONTINUE
C
C        ERROR RETURN SECTION
C
 900  IF(IER.NE.0)RETURN 1
C
 910  RETURN
      END

      SUBROUTINE LOCPOS(KFILDO,LOC1,IPOS1,NBYTES,LBYPWD,
     1                  LOC,IPOS)
C
C        MAY     1999   GLAHN   TDL   GRIB2
C        JANUARY 2001   GLAHN   COMMENTS
C 
C        PURPOSE 
C            ACCEPTS A WORD LOCATION, LOC1, AND BIT POSITION
C            WITHIN THAT WORD, IPOS1, ADDS NBYTES, AND 
C            CALCULATES A NEW WORD LOCATION, LOC, AND BIT
C            POSITION, IPOS.  IT IS ASSUMED THAT IPOS1 POINTS
C            TO A BIT JUST AFTER A FULL BYTE.  CALUCLATIONS 
C            ARE IN BYTES RATHER THAN BITS TO PREVENT POSSIBLE
C            OVERFLOW.  USED WITH GRIB2 ROUTINE UNPK_GRIB2.  
C            FOR INSTANCE, IF LOC1 AND IPOS1 IS THE BEGINNING
C            OF A SECTION, AND THE SECTION IS NBYTES LONG, THEN
C            THE NEXT SECTION SHOULD START AT IPOS IN LOC.
C
C        DATA SET USE 
C           KFILDO - UNIT NUMBER FOR OUTPUT (PRINT) FILE. (OUTPUT) 
C
C        VARIABLES 
C              KFILDO = UNIT NUMBER FOR OUTPUT (PRINT) FILE.  (INPUT)
C                LOC1 = WORD POSITION OF NEXT BYTE.  (INPUT)
C               IPOS1 = BIT POSITION IN LOC1.  (INPUT)
C              NBYTES = NUMBER OF BYTES TO ADD.  (INPUT)
C              LBYPWD = BYTES PER WORD FOR EITHER A 32- OR 64-BIT
C                       MACHINE.  (INPUT)
C                 LOC = WORD POSITION OF NEXT BYTE.  (OUTPUT)
C                IPOS = BIT POSITION OF BEGINNING OF NEXT BYTE.
C                       (OUTPUT)
C
C             LOCAL VARIABLES
C              KBYTES = THE NUMBER OF BYTES PRIOR TO BIT POS1 IN
C                       WORD LOC1.
C
C        NON SYSTEM SUBROUTINES CALLED 
C           NONE
C
      KBYTES=(LOC1-1)*LBYPWD+(IPOS1-1)/8
C        KBYTES IS THE NUMBER OF BYTES PRIOR TO BIT IPOS1 IN
C        WORD LOC1.
      KBYTES=KBYTES+NBYTES
      LOC=KBYTES/LBYPWD+1
      IPOS=(KBYTES-(LOC-1)*LBYPWD)*8+1
      RETURN
      END

      SUBROUTINE UNPKCMBM(KFILDO,IPACK,NDX,LOC,IPOS,A,IBMP,NXY,LBIT,
     1                    JMIN,NOV,LX,MAXGPREF,IMISSING,XMISSP,XMISSS,
     2                    REF,MAPBIT,SCAL10,SCAL2,CLEAN,L3264B,IER)
C
C        APRIL   1997   GLAHN    TDL   HP
C        MAY     1997   GLAHN    MODIFIED UNPACKING ALGORITHM TO USE
C                                MVBITS RATHER THAN SHIFTING AND ORING.
C        JULY    1999   LAWRENCE UPDATED THIS ROUTINE TO CONSIDER A BITMAP
C                                (IF ONE IS PRESENT) AND TO PERFORM THE
C                                THE NECESSARY SCALINGS AND COMPUTATIONS
C                                INTERNALLY. THIS HAS BEEN DONE IN ATTEMPT
C                                TO SPEED UP THE COMPLEX UNPACKING
C                                PROCEDURE.
C        JULY    1999   LAWRENCE FIXED AN ELUSIVE BUG...
C        APRIL   2000   LAWRENCE UPDATED THIS ROUTINE TO MEET THE NEEDS
C                                OF THE LATEST GRIB2 DOCUMENTATION.
C                                NOTE THAT THE SECONDARY BIT-MAP HAS
C                                BEEN DONE AWAY WITH.
C        NOVEMBER 2001   GLAHN   MODIFIED TO HANDLE BOTH PRIMARY AND
C                                SECONDARY MISSINGS PROPERLY WHEN A
C                                GROUP IS ALL OF ONE VALUE AND MISSING.
C                                ADDED IBXX2( ).  CHANGED UNDEFINED 
C                                FMISS TO XMISSP IN TWO PLACES
C                                REGARDING BIT MAP. ADDED MAXGPREF TO
C                                CALL
C        JANUARY  2001   GLAHN   ELIMINATED NVALUE WHEN NO MISSINGS AND
C                                ALL VALUES THE SAME
C                                
C
C        PURPOSE 
C            TO UNPACK NXY VALUES FROM IPACK( ) USING THE COMPLEX
C            UNPACKING METHOD. THE PACKED VALUES ARE RETURNED
C            IN A( ) WITH REFERENCE VALUE AND SCALING
C            FACTORS CONSIDERED.  UNPKCMBM ELIMINATES THE 
C            MULTIPLE CALLS TO UNPKBG, AND RATHER INCORPORATES IT
C            INTO THE LOOP.  SINCE THIS IS A HIGHLY USED ROUTINE, ALL 
C            REASONABLE ATTEMPTS AT EFFICIENCY MUST BE PURSUED.
C        NOTE:  BECAUSE FLOATING POINT COMPUTATIONS ARE USED, AN
C            EXACT INTEGER VALUE MAY NOT BE RETURNED WHEN VERY LARGE.
C            FOR INSTANCE, AN INTEGER VALUE OF 2**30-1 WILL BE
C            RETURNED 2**30 REAL (INCORRECT BY ONE DIGIT).  THIS IS
C            ALSO TRUE OF 2**25-1, BUT 2**24-1 IS OK.
C
C        DATA SET USE 
C           KFILDO - UNIT NUMBER FOR OUTPUT (PRINT) FILE. (OUTPUT) 
C
C        VARIABLES 
C              KFILDO = UNIT NUMBER FOR OUTPUT (PRINT) FILE.  (INPUT) 
C            IPACK(J) = THE ARRAY HOLDING THE ACTUAL PACKED MESSAGE
C                       (J=1,MAX OF NDX).  (INPUT)
C                 NDX = DIMENSION OF IPACK( ).  (INPUT)
C                 LOC = HOLDS WORD POSITION IN IPACK OF NEXT VALUE TO
C                       UNPACK.  (INPUT/OUTPUT)
C                IPOS = HOLDS BIT POSITION IN IPACK(LOC) OF THE FIRST
C                       BIT OF THE NEXT VALUE TO UNPACK.  (INPUT/OUTPUT)
C                A(K) = UNPACKED DATA RETURNED (K=1,NXY).  (OUTPUT)
C             IBMP(K) = CONTAINS A BITMAP CORRESPONDING TO
C                       TO THE DATA TO BE UNPACKED INTO A() (K=1,NXY).
C                       (INPUT)
C                 NXY = DIMENSION OF IC( ).  THE NUMBER
C                       OF UNPACKED VALUES RETURNED.  (INPUT)
C             LBIT(K) = THE NUMBER OF BITS TO UNPACK FOR EACH VALUE
C                       (K=1,LX). (INPUT)
C             JMIN(K) = THE SECONDARY MINIMA OF THE GROUPS (K=1,LX)
C                       (INPUT) 
C              NOV(K) = THE NUMBER OF VALUES PER EACH GROUP (K=1,LX).
C                       (INPUT)
C                  LX = THE NUMBER OF GROUPS IN THIS PRODUCT. (INPUT)
C            MAXGPREF = THE MAXIMUM VALUE THAT CAN BE STORED IN THE
C                       GROUP REFERENCES.  (INPUT)
C            IMISSING = REPRESENTS OCTET 23 OF SECTION 5. DETERMINES
C                       IF THERE ARE NO MISSING VALUES, PRIMARY MISSING
C                       VALUES, OR PRIMARY AND SECONDARY MISSING VALUES.
C                       (INPUT)
C              XMISSP = VALUE TO INSERT INTO A( ) AT POINTS WHERE
C                       THERE IS A PRIMARY MISSING VALUE.  (INPUT)
C              XMISSS = VALUE TO INSERT INTO A( ) AT POINTS WHERE
C                       THERE IS A SECONDARY MISSING VALUE.  (INPUT)
C                 REF = THE REFERENCE VALUE THAT WE WILL BE USING
C                       TO UNPACK THE DATA. (INPUT)
C              MAPBIT = A FLAG INDICATING IF A BIT-MAP IS PRESENT.
C                       0 WHEN A BIT-MAP IS PRESENT; 1 OTHERWISE.
C                       (INPUT)
C              SCAL10 = DECIMAL SCALING PARAMETER. (INPUT)
C               SCAL2 = BINARY SCALING PARAMETER. (INPUT)
C               CLEAN = .TRUE. IF THERE ARE NO MISSING
C                       VALUES IN THE DATA FIELD.
C                       .FALSE. IF THERE ARE MISSING
C                       VALUES IN THE DATA FIELD (LOGICAL). (INPUT)
C              L3264B = INTEGER WORD LENGTH OF MACHINE BEING USED.
C                       (INPUT)
C                 IER = ERROR RETURN.  (OUTPUT)
C                       6 = NDX IS NOT LARGE ENOUGH TO FURNISH THE BITS
C                           NECESSARY TO ACCOMMODATE NXY VALUES STARTING
C                           AT THE VALUES LOC AND IPOS.
C                       7 = IPOS NOT IN THE RANGE 1-L3264B.
C                       8 = IBIT NOT IN THE RANGE 0-32.
C                      18 = UNRECOGNIZED MISSING VALUE CODE IN
C                           IMISSING.
C
C        LOCAL VARIABLES
C                   K = A LOOP INDEXING VARIABLE.
C                   L = KEEPS TRACK OF THE CURRENT GROUP THAT
C                       WE ARE PROCESSING.
C                   M = KEEPS TRACK OF OUR POSITION IN THE SECONDARY
C                       BIT-MAP DURING THE UNPACK.
C                MISS = CONTAINS THE VALUE OF 2**LBIT(K)-1. WHEN
C                       THERE CAN BE MISSING VALUES, THE MISSING
C                       VALUE IS STORED AS THE LARGEST POSSIBLE
C                       NUMBER STOREABLE IN THE NUMBER OF BITS
C                       NECESSARY TO CONTAIN ALL THE VALUES IN 
C                       THE GROUP.
C NEWIPOS,NBIT1,NBIT2 = VARIABLES USED IN MANIPULATING BIT POSITIONS
C                       DURING THE UNPACKING OF VALUES FROM
C                       IPACK(). 
C              NVALUE = CONTAINS THE VALUE RETRIEVED FROM IPACK().
C                       THIS IS THE VALUE BEFORE WE MULTIPLY
C                       BY THE DECIMAL AND BINARY SCALE FACTORS
C                       AND ADD ON THE 1ST AND SECOND ORDER
C                       MINIMA.
C            IBXX2(J) = AN ARRAY THAT WHEN THIS ROUTINE IS FIRST ENTERED
C                       IS SET TO 2**J, J=0,30. IBXX2(30) = 2**30, WHICH
C                       IS THE LARGEST VALUE PACKABLE, BECAUSE 2**31
C                       IS LARGER THAN THE INTEGER WORD SIZE.
C
C        NON SYSTEM SUBROUTINES CALLED 
C            NONE (MVBITS IS A BITS INTRINSIC)
C
      LOGICAL CLEAN
C
      DIMENSION IPACK(NDX)
      DIMENSION A(NXY)
      DIMENSION IBMP(NXY)
      DIMENSION JMIN(LX),LBIT(LX),NOV(LX)
      DIMENSION IBXX2(0:30)
C
      DATA IFIRST/0/
C
      SAVE IBXX2
C
C        SET ERROR RETURN AND ZERO ARRAYS.
      IER=0
C
C         CALCULATE THE POWERS OF 2 THE FIRST TIME ENTERED.
C
      IF(IFIRST.EQ.0)THEN
         IFIRST=1
         IBXX2(0)=1
C
         DO 104 J=1,30
         IBXX2(J)=IBXX2(J-1)*2
 104     CONTINUE
C
      ENDIF
C
C        CHECK LEGITIMATE VALUE OF LOC.
C
      IF(IPOS.LE.0.OR.IPOS.GT.L3264B)THEN
         IER=7
D        WRITE(KFILDO,105)IPOS,IER
D105     FORMAT(/' IPOS = ',I6,' NOT IN THE RANGE 1 TO L3264B',
D    1           ' IN UNPKLX.  RETURN FROM UNPKLX WITH IER = ',I4)
         GO TO 900
      ENDIF
C
C       TEST FOR THE EXISTENCE OF A BITMAP HERE...
C
      M=0
C
      IF(MAPBIT.EQ.0)THEN
C
C        A BIT MAP IS NOT PRESENT.
C
         DO K=1,LX
C
C              CHECK TO SEE IF THE NUMBER OF BITS
C              TO UNPACK FOR EACH VALUE IS 0.  IF IT
C              IS 0, THEN DETERMINE IF THE FIELD CAN
C              HAVE MISSING VALUES.  IF IT CAN,
C              THEN A VALUE OF ALL 1'S IN THE FIELD MEANS
C              A PRIMARY MISSING VALUE, AND A VALUE OF ALL
C              1'S MINUE 1 MEANS A SECONDARY MISSING VALUE.
C              OTHERWISE, ALL OF THE VALUES ARE VALID AND
C              THE SAME AS EACH OTHER.
C
            IF(LBIT(K).EQ.0)THEN
C
               IF(IMISSING.EQ.1)THEN
C
                  IF(JMIN(K).EQ.MAXGPREF)THEN
                     VALUE=XMISSP
                  ENDIF
C
               ELSEIF(IMISSING.EQ.2)THEN
C
                  IF(JMIN(K).EQ.MAXGPREF)THEN
                     VALUE=XMISSP
                  ELSEIF(JMIN(K).EQ.MAXGPREF-1)THEN
                     VALUE=XMISSS
                  ENDIF
C
               ELSE
                  VALUE=((JMIN(K)*SCAL2)+REF)/SCAL10
               ENDIF
C
               DO J=1,NOV(K)
                  A(M+J)=VALUE
               ENDDO
C
            ELSE
C
               PMISS=IBXX2(LBIT(K))-1
               SMISS=IBXX2(LBIT(K))-2
C
               DO J=1,NOV(K)
                  NVALUE=0
                  NEWIPOS=IPOS+LBIT(K)
C
                  IF(NEWIPOS.LE.L3264B+1)THEN
                     CALL MVBITS(IPACK(LOC),L3264B+1-NEWIPOS,LBIT(K),
     1                           NVALUE,0)
C
                     IF(NEWIPOS.LE.L3264B)THEN
                        IPOS=NEWIPOS
                     ELSE
                        IPOS=1
                        LOC=LOC+1
                     ENDIF
C
                  ELSE
                     NBIT1=L3264B+1-IPOS
                     NBIT2=LBIT(K)-NBIT1
                     CALL MVBITS(IPACK(LOC),0,NBIT1,NVALUE,NBIT2)
                     LOC=LOC+1
                     CALL MVBITS(IPACK(LOC),L3264B-NBIT2,NBIT2,
     1                           NVALUE,0)
                     IPOS=NBIT2+1
                  ENDIF
C
c                  SELECT CASE (IMISSING)
C
c                     CASE (0)
                   IF (IMISSING.EQ.0) THEN
C
C                          THERE ARE NO MISSING VALUES IN THIS
C                          DATA FIELD.
                        A(M+J)=(((FLOAT(JMIN(K)+NVALUE)*SCAL2)+REF)/
     1                            SCAL10)
C
c                     CASE (1)
                    ELSEIF (IMISSING.EQ.1) THEN
C
C                          THERE ARE PRIMARY MISSING VALUES IN
C                          THIS DATA FIELD.
                        IF(NVALUE.EQ.PMISS)THEN
                           A(M+J)=XMISSP
                        ELSE
                           A(M+J)=(((FLOAT(JMIN(K)+NVALUE)*SCAL2)+REF)/
     1                               SCAL10)
                        ENDIF
C
c                     CASE (2)
                    ELSEIF (IMISSING.EQ.2) THEN
C
C                          THERE ARE PRIMARY AND SECONDARY MISSING
C                          VALUES IN THIS DATA FIELD.
                        IF(NVALUE.EQ.PMISS)THEN
                           A(M+J)=XMISSP
                        ELSEIF(NVALUE.EQ.SMISS)THEN
                           A(M+J)=XMISSS
                        ELSE
                           A(M+J)=(((FLOAT(JMIN(K)+NVALUE)*SCAL2)+REF)/
     1                               SCAL10)
                        ENDIF
C
c                     CASE DEFAULT
                    ELSE
C
C                          THE MISSING VALUE REPRESENTATION IS
C                          UNRECOGNIZED.
                        IER=18
                        GOTO 900
c                  END SELECT
                    ENDIF
                     
               ENDDO
            ENDIF
C
            M=M+NOV(K)
C
         ENDDO
C
      ELSE
C
C           A BIT-MAP IS PRESENT.
C
         DO K=1,LX
C
            IF(LBIT(K).EQ.0)THEN
               NVALUE=0
C
C                 NO VALUES ARE PACKED BECAUSE ALL OF THE VALUES
C                 IN THIS GROUP ARE THE SAME.
               DO J=1,NOV(K)
C
                  DO WHILE((IBMP(M+J).EQ.0).AND.(.NOT.CLEAN))
                     A(M+J)=XMISSP
                     M=M+1
                  ENDDO 
C
                  A(M+J)=(((FLOAT(JMIN(K)+NVALUE)*SCAL2)+REF)/SCAL10)
C
               ENDDO
C
            ELSE
C
               DO J=1,NOV(K)
C
                  DO WHILE((IBMP(M+J).EQ.0).AND.(.NOT.CLEAN))
                     A(M+J)=XMISSP
                     M=M+1
                  ENDDO 
C
                  NEWIPOS=IPOS+LBIT(K)
C
                  IF(NEWIPOS.LE.L3264B+1)THEN
                     CALL MVBITS(IPACK(LOC),L3264B+1-NEWIPOS,LBIT(K),
     1                           NVALUE,0)
 
C
                     IF(NEWIPOS.LE.L3264B)THEN
                        IPOS=NEWIPOS
                     ELSE
                        IPOS=1
                        LOC=LOC+1
                     ENDIF
C
                  ELSE
                     NBIT1=L3264B+1-IPOS
                     NBIT2=LBIT(K)-NBIT1
                     CALL MVBITS(IPACK(LOC),0,NBIT1,NVALUE,NBIT2)
                     LOC=LOC+1
                     CALL MVBITS(IPACK(LOC),L3264B-NBIT2,NBIT2,
     1                           NVALUE,0)
                     IPOS=NBIT2+1
                  ENDIF
C
                  A(M+J)=(((FLOAT(JMIN(K)+NVALUE)*SCAL2)+REF)/SCAL10)
C
               ENDDO
            ENDIF
C
            M=M+NOV(K)
C
         ENDDO
      ENDIF
C
 900  RETURN
      END

      SUBROUTINE UNPK_SMPLE(KFILDO,A,ND2X3,NX,NY,IPACK,ND5,LOCN,IPOS,
     1                      IS5,NS5,IS7,NS7,IBITMAP,IBMP,IUNPKOPT,
     2                      L3264B,REF,XMISSP,IER,*)
C
C        APRIL    1995   GLAHN   TDL   HP
C        APRIL    1995   MOELLER  RENAMED SUBROUTINE AND CHANGED 
C                                 STATEMENT TO UNPACK LBIT.
C        DECEMBER 1995   MOELLER  REMOVED KFILDO FROM CALL SEQUENCE
C        JANUARY  1996   MOELLER  CHANGED SCALE FACTORS TO REAL;
C                                 MODIFIED VARIABLE NAMES TO BE MORE
C                                 DESCRIPTIVE
C        JANUARY  1996   CALKINS  ADDED KFILDO TO CALL SEQUENCE
C        JUNE     1999   LAWRENCE UPDATED FOR UNPK_GRIB2; REORDERED
C                                 AND RENAMED MANY OF THE CALLING
C                                 ARGUMENTS TO BE MORE CONSISTENT
C                                 WITH OTHER ROUTINES; UPDATED THE
C                                 DOCUMENTATION
C        JANUARY  2001   GLAHN    COMMENTS; CHANGED IER = 17 TO 702;
C                                 CHANGED FMISS TO XMISSP; DEFINED      
C                                 ISCAL AND PUT IT INTO CALL TO 
C                                 UNPKLXBM
C        FEBRUARY 2001   GLAHN    COMMENTS
C        NOVEMBER 2001   GLAHN    CHANGED IER=702 TO IER=705
C
C        PURPOSE
C            UNPACKS DATA THAT WAS PACKED USING THE SIMPLE
C            PACKING SCHEME. THIS ROUTINE WILL UTILIZE
C            A BIT MAP IF THERE WAS ONE PROVIDED.
C
C            NOTE THAT THE FOLLOWING EQUATION IS USED IN UNPACKING THE
C            DATA:
C                 Y = [R + X * (2 ** E)] * (10 ** -D)]
C                 WHERE
C                     Y = THE VALUE WE ARE UNPACKING
C                     R = THE REFERENCE VALUE (FIRST ORDER MINIMA)
C                     X = THE PACKED VALUE
C                     E = THE BINARY SCALE FACTOR
C                     D = THE DECIMAL SCALE FACTOR
C
C        DATA SET USE
C           KFILDO - UNIT NUMBER FOR OUTPUT (PRINT) FILE. (OUTPUT)
C
C        VARIABLES
C              KFILDO = UNIT NUMBER FOR OUTPUT (PRINT) FILE.  (INPUT)
C                A(K) = UNPACKED GRID POINT DATA VALUES
C                       RETURNED (K=1,ND2X3).  (OUTPUT)
C               ND2X3 = THE DIMENSION OF A( ) AND IBMP( ).  (INPUT)
C               NX,NY = THE ACTUAL DIMENSIONS OF THE GRID WE ARE
C                       PROCESSING. (INPUT)
C            IPACK(J) = THE ARRAY HOLDING THE ACTUAL PACKED MESSAGE
C                       (J=1,ND5). (INPUT)
C                 ND5 = DIMENSION OF IPACK(). (INPUT)
C                LOCN = THE WORD POSITION FROM WHICH TO UNPACK THE
C                       NEXT VALUE. (INPUT/OUTPUT)
C                IPOS = THE BIT POSITION IN LOCN FROM WHICH TO START
C                       UNPACKING THE NEXT VALUE.  (INPUT/OUTPUT)
C              IS5(L) = THE ARRAY CORRESPONDING TO SECTION 5
C                       OF THE GRIB2 CODE. (INPUT)
C                 NS5 = DIMENSION OF IS5( ). (INPUT)
C              IS7(L) = HOLDS THE VALUES FOR GRIB2 SECTION 7 (L=1,NS7).
C                       (INPUT-OUTPUT)
C                 NS7 = DIMENSION OF IS7( ). (INPUT)
C             IBITMAP = 1 IF THERE WAS A BIT-MAP PACKED INTO
C                         THIS GRIB2 MESSAGE.
C                       0 IF THERE WAS NOT A BIT-MAP IN THIS
C                         GRIB2 MESSAGE. (LOGICAL) (INPUT)
C             IBMP(K) = WORK ARRAY (K=1,ND2X3).  HOLDS BIT MAP,
C                       IF ONE IS PRESENT. (INPUT)
C            IUNPKOPT = 0 DON'T UNPACK THIS DATA GRID. AN ERROR
C                         WAS ENCOUNTERED.
C                       1 UNPACK THIS GRID USING THE SIMPLE METHOD,
C                         LEAVE THE MISSING VALUES IN THE GRID,
C                         DO NOT RETURN A BIT-MAP.
C                       2 UNPACK THIS GRID USING THE SIMPLE METHOD,
C                         REMOVE THE MISSING VALUES FROM THE GRID,
C                         RETURN A BIT-MAP INDICATING MISSING VALUE
C                         LOCATIONS.
C                       (INPUT)
C              L3264B = INTEGER WORD LENGTH OF MACHINE BEING USED.
C                       A WORKING COPY N = L3264B FOR USE IN CALLS TO
C                       PKBG. (INPUT)
C                 REF = THE REFERENCE VALUE THAT WE WILL BE USING 
C                       TO UNPACK THE DATA. (INPUT)
C              XMISSP = VALUE TO INSERT INTO A( ) AT POINTS WHERE
C                       THE BIT MAP INDICATES VALUES ARE MISSING.
C                       (INPUT)
C                 IER = ERROR RETURN CODE.  (OUTPUT)
C                         0 = GOOD RETURN ... THE ROUTINE PROBABLY
C                             WORKED.
C                       6-8 = ERROR RETURN CODES FROM UNPKBG AND
C                             UNPKLXBM. SEE THE DOCUMENTATION IN
C                             THESE ROUTINES. 
C                       705 = THE INTERNAL ARRAYS ARE NOT DIMENSIONED
C                             LARGE ENOUGH TO CONTAIN AND PROCESS THE
C                             GRID.  INCREASE THE SIZE OF ND2X3.
C                   * = ALTERNATIVE ERROR RETURN.    
C
C             LOCAL VARIABLES
C             ISCALED = THE DECIMAL SCALING FACTOR. 
C             ISCALEB = THE BINARY SCALING FACTOR. 
C              IWIDTH = THE WIDTH OF THE PACKED VALUES. 
C              MAPBIT = 0 WHEN A BIT MAP IS NOT PRESENT.
C                       1 OTHERWISE.  
C                 NXY = THE PRODUCT OF NX*NY. USED AS THE ACTUAL 
C                       AMOUNT OF DATA IN A() AND IBMP(). MUST
C                       BE LESSER THAN OR EQUAL TO ND2X3. 
C                 REF = THE MINIMUM VALUE THAT WAS SUBTRACTED
C                       BEFORE PACKING (I.E., THE REFERENCE VALUE).
C               ISCAL = INDICATES COMBINATIONS OF SCALING.
C                       0 = NONE
C                       1 = DECIMAL ONLY
C                       2 = BINARY ONLY
C                       3 = BOTH DECIMAL AND BINARY
C              SCAL10 = DECIMAL SCALING PARAMETER = 10.**ISCALED.
C               SCAL2 = BINARY SCALING PARAMETER = 2.**ISCALEB.
C
C        NON SYSTEM SUBROUTINES CALLED
C           UNPKLXBM
C
      LOGICAL CLEAN
C
      DIMENSION A(ND2X3),IBMP(ND2X3)
      DIMENSION IPACK(ND5)
      DIMENSION IS5(NS5),IS7(NS7)
C
C        SET ERROR RETURN.
C
      IER=0
      N=L3264B
C
C        DETERMINE THE APPROPRIATE SCALE FACTORS, REFERENCE VALUES,
C        AND FIELD WIDTHS FROM THE IS5 ARRAY TEMPLATE FOR SIMPLE
C        PACKING.
      ISCALED=IS5(18)
      ISCALEB=IS5(16)
      IWIDTH=IS5(20)
C
C        NX*NY = THE NUMBER OF GRID POINTS THAT WE HAVE TO
C        PROCESS. THE ACTUAL NUMBER OF DATA VALUES PACKED
C        WILL BE EQUAL TO (IF THERE IS NO BIT-MAP) OR LESS THAN
C        THIS VALUE (IF THERE IS A BIT MAP WITH MISSING VALUES).
      NXY=NX*NY
C
C        CHECK TO MAKE SURE THAT NXY IS LE ND2X3.
C
      IF(NXY.GT.ND2X3)THEN
         IER=705
         GO TO 900
      ENDIF
C
C        DEFINE ISCAL AND COMPUTE SCAL10 AND SCAL2.
C
      IF(ISCALED.EQ.0.AND.ISCALEB.EQ.0)THEN
         ISCAL=0
         SCAL10=1.
         SCAL2=1.
      ELSEIF(ISCALED.NE.0.AND.ISCALEB.EQ.0)THEN
         ISCAL=1
         SCAL10=10.**ISCALED
         SCAL2=1.
      ELSEIF(ISCALED.EQ.0.AND.ISCALEB.NE.0)THEN
         ISCAL=2
         SCAL10=1.
         SCAL2=2.**ISCALEB
      ELSEIF(ISCALED.NE.0.AND.ISCALEB.NE.0)THEN
         ISCAL=3
         SCAL10=10.**ISCALED
         SCAL2=2.**ISCALEB
      ENDIF
C
C        SET CLEAN.
C
      IF(IUNPKOPT.EQ.1)THEN
         CLEAN=.FALSE.
      ELSE
         CLEAN=.TRUE.
      ENDIF
C
C        UNPACK THE VALUES.
C***D     WRITE(KFILDO,850)ND5,LOCN,IPOS,NXY,IWIDTH,
C***D    1           XMISSP,REF,IBITMAP,ISCAL,SCAL10,SCAL2,IUNPKOPT,N,IER
C***D850  FORMAT(/' UNPK_SMPLE--ND5,LOCN,IPOS,NXY,IWIDTH,',
C***D    1           'XMISSP,REF,IBITMAP,ISCAL,SCAL10,SCAL2,IUNPKOPT,N,IER'/
C***D    2         5I8,F8.1,F12.0,2I6,2F8.1,3I6)
C
      CALL UNPKLXBM(KFILDO,IPACK,ND5,LOCN,IPOS,A,IBMP,NXY,IWIDTH,
     1              XMISSP,REF,IBITMAP,ISCAL,SCAL10,SCAL2,CLEAN,N,IER)
C
 900  IF(IER.NE.0)RETURN 1
C
      RETURN
      END

      SUBROUTINE UNPKLXBM(KFILDO,IPACK,NDX,LOCN,IPOS,A,IBMP,NXY,NBIT,
     1                    FMISS,REF,IBITMAP,ISCAL,SCAL10,SCAL2,CLEAN,
     2                    L3264B,IER)
C
C        APRIL    1997   GLAHN    TDL   HP
C        MAY      1997   GLAHN    MODIFIED UNPACKING ALGORITHM TO USE
C                                 MVBITS RATHER THAN SHIFTING AND ORING.
C        JULY     1999   LAWRENCE UPDATED THIS ROUTINE TO CONSIDER A BITMAP
C                                 (IF ONE IS PRESENT) AND TO PERFORM THE
C                                 THE NECESSARY SCALINGS AND COMPUTATIONS
C                                 INTERNALLY. THIS HAS BEEN DONE IN ATTEMPT
C                                 TO SPEED UP THE SIMPLE UNPACKING
C                                 PROCEDURE.
C        JANUARY  2001   GLAHN    COMMENTS, CHANGED IER = 6 TO 9; ADDED
C                                 IF THEN TO HANDLE ZERO VALUE EFFICIENTLY;
C                                 ADDED ISCAL
C        FEBRUARY 2001   GLAHN    CHANGED LOC TO LOCN; INSERTED SELECT
C                                 CASE (ISCAL) IN 2 PLACES
C        MARCH    2001   LAWRENCE FIXED AN ERROR THAT WAS CAUSING THE DATA
C                                 FIELD TO BE IMPROPERLY CONSTRUCTED WHEN 
C                                 THE CLEAN ARGUMENT IS .TRUE.
C        FEBRUARY 2002   GLAHN    FIXED ERROR WHEN NBIT=0; ELIMINATED 
C                                 STATEMENT 160 
C
C        PURPOSE
C            UNPACKS NXY VALUES FROM IPACK( ), USING THE SIMPLE METHOD.
C            THE PACKED VALUES ARE RETURNED IN IC( ) WITH REFERENCE 
C            VALUE AND SCALING FACTORS CONSIDERED.  UNPKLXBM ELIMINATES
C            MULTIPLE CALLS TO UNPKBG, AND RATHER INCORPORATES IT
C            INTO THE LOOP.  SINCE THIS IS A HIGHLY USED ROUTINE, ALL
C            REASONABLE ATTEMPTS AT EFFICIENCY MUST BE PURSUED.
C
C        DATA SET USE 
C           KFILDO - UNIT NUMBER FOR OUTPUT (PRINT) FILE. (OUTPUT) 
C
C        VARIABLES 
C              KFILDO = UNIT NUMBER FOR OUTPUT (PRINT) FILE.  (INPUT) 
C            IPACK(J) = THE ARRAY HOLDING THE ACTUAL PACKED MESSAGE
C                       (J=1,MAX OF NDX).  (INPUT)
C                 NDX = DIMENSION OF IPACK( ).  (INPUT)
C                LOCN = THE WORD POSITION FROM WHICH TO UNPACK THE
C                       NEXT VALUE. (INPUT/OUTPUT)
C                IPOS = THE BIT POSITION IN LOCN FROM WHICH TO START
C                       UNPACKING THE NEXT VALUE.  (INPUT/OUTPUT)
C                A(K) = UNPACKED DATA RETURNED (K=1,NXY).  (OUTPUT)
C             IBMP(K) = CONTAINS A BITMAP CORRESPONDING TO
C                       TO THE DATA TO BE UNPACKED INTO A() (K=1,NXY).
C                       (INPUT)
C                 NXY = DIMENSION OF IC( ).  THE NUMBER
C                       OF UNPACKED VALUES RETURNED.  (INPUT)
C                NBIT = THE NUMBER OF BITS TO UNPACK FOR EACH VALUE.
C                       (INPUT)
C               FMISS = VALUE TO INSERT INTO A( ) AT POINTS WHERE
C                       THE BIT MAP INDICATES VALUES ARE MISSING.
C                       THIS IS NORMALLY XMISSP (FOR SECTON 7) OR
C                       ZERO (FOR SECTON 2).  (INPUT)
C                 REF = THE REFERENCE VALUE.  (INPUT)
C             IBITMAP = 1 IF THERE WAS A BIT-MAP PACKED INTO
C                       THIS GRIB2 MESSAGE.
C                       0 IF THERE WAS NOT A BIT-MAP IN THIS
C                       GRIB2 MESSAGE. (LOGICAL) (INPUT)
C               ISCAL = INDICATES COMBINATIONS OF SCALING.
C                       0 = NONE
C                       1 = DECIMAL ONLY
C                       2 = BINARY ONLY
C                       3 = BOTH DECIMAL AND BINARY
C              SCAL10 = DECIMAL SCALING PARAMETER. (INPUT)
C               SCAL2 = BINARY SCALING PARAMETER. (INPUT)
C               CLEAN = A LOGICAL FLAG THAT ONLY APPLIES IF THE
C                       SIMPLE PACKING METHOD IS BEING USED IN
C                       CONJUNCTION WITH A BIT-MAP.
C                       TRUE: KEEP THE DATA IN A() "CLEAN". DO NOT
C                             PUT MISSING VALUES IN A(). IT WILL
C                             BE UP TO THE USER USING THE BIT-MAP
C                             TO KEEP TRACK OF THE LOCATIONS OF THE
C                             MISSING VALUES.
C                       FALSE: PUT THE MISSING VALUES INTO THEIR
C                              PROPER PLACES IN THE A() ARRAY.
C                       (INPUT)
C              L3264B = INTEGER WORD LENGTH OF MACHINE BEING USED.
C                       (INPUT)
C                 IER = ERROR RETURN.  (OUTPUT)
C                       7 = IPOS NOT IN THE RANGE 1-L3264B.
C                       8 = IBIT NOT IN THE RANGE 0-32.
C                       9 = NDX IS NOT LARGE ENOUGH TO FURNISH THE BITS
C                           NECESSARY TO ACCOMMODATE NXY VALUES STARTING
C                           AT THE VALUES LOCN AND IPOS.
C
C        LOCAL VARIABLES
C                   K = A LOOP INDEXING VARIABLE. 
C NEWIPOS,NBIT1,NBIT2 = VARIABLES USED IN THE MANIPULATION OF 
C                       BIT POSITIONS WHILE UNPACKING VALUES FROM
C                       IPACK(). 
C              NVALUE = THE UNPACKED VALUE.
C             OSCAL10 = THE RECIPROCAL OF THE SCALING FACTOR, SCAL10.
C
C        NON SYSTEM SUBROUTINES CALLED 
C           NONE
C
      LOGICAL CLEAN
C
      DIMENSION IPACK(NDX)
      DIMENSION A(NXY)
      DIMENSION IBMP(NXY)
C
C        SET ERROR RETURN AND ZERO ARRAYS.
C
      IER=0
C
C        CHECK LEGITIMATE VALUES OF LOCN AND IPOS, AND WHETHER
C        NDX IS SUFFICIENT FOR ALL NXY VALUES.
C
      IF(IPOS.LE.0.OR.IPOS.GT.L3264B)THEN
         IER=7
         GO TO 900 
      ENDIF
C
      IF(NBIT.LT.0.OR.NBIT.GT.32)THEN
         IER=8
         GO TO 900
      ENDIF
C
      IF(NBIT*NXY.GT.(L3264B+1-IPOS)+(NDX-LOCN)*L3264B)THEN
         IER=9
         GO TO 900
      ENDIF
C
C        COMPUTE RECIPROCAL OF SCAL10 SO THAT MULTIPLICATION
C        CAN BE USED IN SCALING RATHER THAN DIVISION.
C
      OSCAL10=1./SCAL10
C
C        TEST FOR THE EXISTENCE OF A BITMAP HERE.
C    
      IF(IBITMAP.EQ.0)THEN
C
C           A BIT MAP IS NOT PRESENT.
C
         DO 300 K=1,NXY 
            NVALUE=0
C
            IF(NBIT.EQ.0)THEN
C
c               SELECT CASE (ISCAL)
c                  CASE(0)
                 IF (ISCAL.EQ.0) THEN
                     A(K)=REF
c                  CASE(1)
                 ELSEIF (ISCAL.EQ.1) THEN
                     A(K)=REF*OSCAL10
c                  CASE(2)
                 ELSEIF (ISCAL.EQ.2) THEN
                     A(K)=REF
c                  CASE(3)
                 ELSEIF (ISCAL.EQ.3) THEN
                     A(K)=REF*OSCAL10
c               END SELECT
                 ENDIF
C
            ELSE
C   
               NEWIPOS=IPOS+NBIT
C
               IF(NEWIPOS.LE.L3264B+1)THEN
                  CALL MVBITS(IPACK(LOCN),L3264B+1-NEWIPOS,NBIT,
     1                        NVALUE,0)
C
                  IF(NEWIPOS.LE.L3264B)THEN
                     IPOS=NEWIPOS
                  ELSE
                     IPOS=1
                     LOCN=LOCN+1
                  ENDIF
C
               ELSE
                  NBIT1=L3264B+1-IPOS
                  NBIT2=NBIT-NBIT1
                  CALL MVBITS(IPACK(LOCN),0,NBIT1,NVALUE,NBIT2)
                  LOCN=LOCN+1
                  CALL MVBITS(IPACK(LOCN),L3264B-NBIT2,NBIT2,NVALUE,0)
                  IPOS=NBIT2+1
               ENDIF
C
c               SELECT CASE (ISCAL)
c                  CASE(0)
                 IF (ISCAL.EQ.0) THEN
                     A(K)=NVALUE+REF
c                  CASE(1)
                 ELSEIF (ISCAL.EQ.1) THEN
                     A(K)=(NVALUE+REF)*OSCAL10
c                  CASE(2)
                 ELSEIF (ISCAL.EQ.2) THEN
                     A(K)=NVALUE*SCAL2+REF
c                  CASE(3)
                 ELSEIF (ISCAL.EQ.3) THEN
                     A(K)=(NVALUE*SCAL2+REF)*OSCAL10
c               END SELECT
                 ENDIF

C
            ENDIF
C
 300     CONTINUE
C
      ELSE
C
C        A BIT MAP IS PRESENT.
C
         K=1
         J=1
C
         DO WHILE(K.LE.NXY)
            NVALUE=0
C
            IF(IBMP(K).EQ.0)THEN
C
               IF(.NOT.CLEAN)THEN
                  A(J)=FMISS
                  J=J+1
               ENDIF
C
               K=K+1
c               CYCLE
                GOTO 1111
            ENDIF
C
            IF(NBIT.EQ.0)THEN
C
c               SELECT CASE (ISCAL)
c                  CASE(0)
                 IF (ISCAL.EQ.0) THEN
                     A(J)=REF
c                  CASE(1)
                 ELSE IF (ISCAL.EQ.1) THEN
                     A(J)=REF*OSCAL10
c                  CASE(2)
                 ELSEIF (ISCAL.EQ.2) THEN
                     A(J)=REF
c                  CASE(3)
                 ELSEIF (ISCAL.EQ.3) THEN
                     A(J)=REF*OSCAL10
c               END SELECT
                 ENDIF
C
               J=J+1
               K=K+1
            ELSE
               NEWIPOS=IPOS+NBIT
C
               IF(NEWIPOS.LE.L3264B+1)THEN
                  CALL MVBITS(IPACK(LOCN),L3264B+1-NEWIPOS,NBIT,
     1                        NVALUE,0)
C
                  IF(NEWIPOS.LE.L3264B)THEN
                     IPOS=NEWIPOS
                  ELSE
                     IPOS=1
                     LOCN=LOCN+1
                  ENDIF
C
               ELSE
                  NBIT1=L3264B+1-IPOS
                  NBIT2=NBIT-NBIT1
                  CALL MVBITS(IPACK(LOCN),0,NBIT1,NVALUE,NBIT2)
                  LOCN=LOCN+1
                  CALL MVBITS(IPACK(LOCN),L3264B-NBIT2,NBIT2,NVALUE,0)
                  IPOS=NBIT2+1
               ENDIF
C
C
c               SELECT CASE (ISCAL)
c                  CASE(0)
                 IF (ISCAL.EQ.0) THEN
                     A(J)=NVALUE+REF
c                  CASE(1)
                 ELSEIF (ISCAL.EQ.1) THEN
                     A(J)=(NVALUE+REF)*OSCAL10
c                  CASE(2)
                 ELSEIF (ISCAL.EQ.2) THEN
                     A(J)=NVALUE*SCAL2+REF
c                  CASE(3)
                 ELSEIF (ISCAL.EQ.3) THEN
                     A(J)=(NVALUE*SCAL2+REF)*OSCAL10
c               END SELECT
                 ENDIF
C
               J=J+1
               K=K+1
            ENDIF
C
 1111   END DO
C
      ENDIF
C
 900  RETURN
      END

      SUBROUTINE UNPK_CMPLX(KFILDO,A,ND2X3,NX,NY,IPACK,ND5,LOCN,IPOS,
     1                      IS5,NS5,IBITMAP,IB,IUNPKOPT,BOUST,
     2                      L3264B,REF,XMISSP,XMISSS,IER,*)
C
C        OCTOBER  1994   GLAHN    TDL   HP
C        FEBRUARY 1995   MOELLER  TDL   HP
C        APRIL    1995   GLAHN    ADDED CAPABILITY TO UNPACK DATA
C                                 VALUES WITH BINARY SCALE FACTOR,
C                                 ISCALEB
C        APRIL    1995   MOELLER  RENAMED SUBROUTINE AND CHANGED 
C                                 STATEMENT TO UNPACK LBIT
C        DECEMBER 1995   MOELLER  REMOVED KFILDO FROM CALL SEQUENCE
C        JANUARY  1996   CALKINS  ADDED KFILDO TO CALL SEQUENCE
C        JUNE     1999   LAWRENCE UPDATED FOR UNPK_GRIB2; MODIFIED 
C                                 CALLING ARGUMENTS TO BE MORE CONSISTENT
C                                 WITH OTHER ROUTINES; MODIFIED THE 
C                                 INTERNAL DOCUMENTATION
C        APRIL    2000   LAWRENCE MODIFIED TO REFLECT THE LATEST GRIB2 
C                                 STANDARDS
C        JANUARY  2001   GLAHN    COMMENTS; CHANGED IER = 17 TO 705;
C                                 ELIMINATED IA( ), NUMOCTET, IS7( ),
C                                 NS7; ADDED ALTERNATE RETURN IN CALLS
C                                 TO UNPKLX
C        FEBRUARY 2001   GLAHN    REMOVED XMISSX FROM CALL TO UNPKSECDIF
C        FEBRUARY 2001   GLAHN    DEFINED ISCAL AND PUT IT INTO CALL TO 
C                                 UNPKSECDIF AND UNPKCMBM; COMMENTS;
C                                 INSERTED CALL TO BOUNDARY; CHANGED
C                                 (-1)* TO - IN 3 PLACES
C        NOVEMBER 2001   GLAHN    ADDED MAXGPREF TO CALL TO UNPKCMBM
C                                 AND UNPKSECDIF; DIMENSIONS OF JMIN( ),
C                                 LBIT( ), AND NOV( ) CHANGED FROM ND2X3
C                                 TO IS5(32)
C        MARCH    2002   GLAHN    ADDED IF(IER.NE.0)GO TO 900 AFTER CALL
C                                 TO UNPKCMBM
C
C        PURPOSE
C            UNPACKS DATA THAT WAS PACKED USING THE COMPLEX PACKING
c            SCHEME IN GRIB2.  ND2X3 UNPACKED VALUES ARE RETURNED
C            IN A( ).  THE ROUTINE GIVES THE USER THE OPTION TO PASS IN
C            A BIT MAP WHICH WILL SHOW WHERE MISSING VALUES ARE, OR
C            THE ROUTINE WILL GENERATE A BIT MAP AUTOMATICALLY
C            AS LONG AS THE USER SUPPLIES THE VALUE THAT WILL
C            REPRESENT MISSING IN THE GRIDDED FIELD.
C
C            NOTE THAT THIS SUBROUTINE USES THE FOLLOWING EQUATION
C            TO RECOVER THE PACKED VALUE:
C               Y = R + [(X1 + X2) * (2 ** E) * (10 ** D)]
C               WHERE:
C                     Y = THE VALUE WE ARE UNPACKING
C                     R = THE REFERENCE VALUE (FIRST ORDER MINIMA)
C                    X1 = THE PACKED VALUE
C                    X2 = THE SECOND ORDER MINIMA
C                     E = THE BINARY SCALE FACTOR
C                     D = THE DECIMAL SCALE FACTOR
C
C        DATA SET USE
C           KFILDO - UNIT NUMBER FOR OUTPUT (PRINT) FILE. (OUTPUT)
C
C        VARIABLES 
C              KFILDO = UNIT NUMBER FOR OUTPUT (PRINT) FILE.  (INPUT)
C                A(K) = UNPACKED DATA RETURNED (K=1,ND2X3). THE DATA
C                       ARE IN THIS LINEAR ARRAY IN THE ORDER OF A
C                       FORTRAN 2-DIMENSIONAL ARRAY LIKE A(IX,JY)
C                       (IX=1,NX) (JY=1,NY).(OUTPUT)
C               ND2X3 = THE MAXIMUM SIZE OF ARRAYS A( ) AND IB( ).
C                       (INPUT)
C                  NX = THE ACTUAL NUMBER OF COLUMNS IN THIS 
C                       GRIDDED PRODUCT. (INPUT)
C                  NY = THE ACTUAL NUMBER OF ROWS IN THIS GRIDDED
C                       PRODUCT. (INPUT)
C            IPACK(J) = THE ARRAY HOLDING THE ACTUAL PACKED MESSAGE
C                       (J=1,ND5).  (INPUT)
C                 ND5 = DIMENSION OF IPACK( ).  (INPUT)
C                LOCN = THE WORD POSITION FROM WHICH TO UNPACK THE
C                       NEXT VALUE. (INPUT/OUTPUT)
C                IPOS = THE BIT POSITION IN LOCN FROM WHICH TO START
C                       UNPACKING THE NEXT VALUE.  (INPUT/OUTPUT)
C              IS5(L) = THE ARRAY CORRESPONDING TO SECTION 5
C                       OF THE GRIB2 CODE. (INPUT)
C                 NS5 = DIMENSION OF IS5( ). (INPUT)
C             IBITMAP = 1 IF THERE WAS A BIT-MAP PACKED INTO
C                       THIS GRIB2 MESSAGE.
C                       0 IF THERE WAS NOT A BIT-MAP IN THIS
C                       GRIB2 MESSAGE.  (INPUT)
C               IB(K) = HOLDS PRIMARY BIT MAP, IF ONE IS PRESENT
C                       (K=1,ND2X3).  (INPUT)
C            IUNPKOPT = 0 DON'T UNPACK THIS DATA GRID. AN ERROR
C                         WAS ENCOUNTERED.
C                       3 UNPACK THIS GRID USING THE COMPLEX METHOD,
C                         LEAVE THE MISSING VALUES IN THE GRID,
C                         DO NOT RETURN A BIT-MAP.
C                       4 UNPACK THIS GRID USING THE COMPLEX METHOD,
C                         REMOVE THE MISSING VALUES FROM THE GRID,
C                         RETURN A BIT-MAP INDICATING MISSING VALUE
C                         LOCATIONS.  (INPUT)
C               BOUST = .TRUE. IF THE DATA FIELD WAS SCANNED
C                       BOUSTROPHEDONICALLY. .FALSE. OTHERWISE.
C                       (LOGICAL) (INPUT)
C              L3264B = THE NUMBER OF BITS IN A WORD ON THIS MACHINE.
C                       THIS IS A PLATFORM DEPENDENT VALUE AND CAN
C                       EITHER BE 32 FOR A FOUR BYTE MACHINE, OR 64
C                       FOR AN EIGHT BYTE MACHINE. (INPUT)
C                 REF = THE REFERENCE VALUE THAT WE WILL BE USING TO
C                       UNPACK THE DATA VALUES. (INPUT)
C              XMISSP = THE PRIMARY MISSING VALUE. (INPUT)
C              XMISSS = THE SECONDARY MISSING VALUE. (INPUT) 
C                 IER = ERROR RETURN CODE. (OUTPUT)
C                         0 = GOOD RETURN ... THE ROUTINE PROBABLY
C                             WORKED.
C                       6-8 = ERROR RETURN CODES FROM UNPKBG, UNPKLX,
C                             UNPKCMBM, AND UNPKSECDIF. SEE INTERNAL
C                             DOCUMENTATION IN THESE ROUTINES.
C                       705 = ND2X3 IS TOO SMALL OF A DIMENSION
C                             TO ALLOW FOR PROPER PROCESSING OF
C                             THE GRID.
C                   * = ALTERNATE ERROR RETURN. 
C
C        LOCAL VARIABLES
C             JMIN(M) = THE MINIMUM VALUE SUBTRACTED FOR EACH GROUP
C                       M BEFORE PACKING (M=1,LX).  (AUTOMATIC)
C             LBIT(M) = THE NUMBER OF BITS NECESSARY TO HOLD THE
C                       PACKED VALUES FOR EACH GROUP M (M=1,LX). 
C                       (AUTOMATIC)
C              NOV(M) = THE NUMBER OF VALUES IN EACH GROUP M (M=1,LX).
C                       (AUTOMATIC)
C                  LX = THE NUMBER OF VALUES IN LBIT( ), JMIN( ), AND
C                       NOV( ) = IS5(32).  (INPUT)
C            IMISSING = REPRESENTS OCTET 23 OF SECTION 5. DETERMINES
C                       IF THERE ARE NO MISSING VALUES, PRIMARY MISSING
C                       VALUES, OR PRIMARY AND SECONDARY MISSING VALUES.
C             ISCALED = IS5(18) IN CALLING PROGRAM.  THE DECIMAL SCALING
C                       FACTOR.
C             ISCALEB = IS5(16) IN CALLING PROGRAM.  THE BINARY SCALING
C                       FACTOR.
C               ISIGN = A FLAG INDICATING WHETHER AN UNPACKED VALUE
C                       IS POSITIVE OR NEGATIVE.
C                IREF = REFERENCE FOR FIELD WIDTH = IS5(36).
C             IREFBIT = NUMBER OF BITS REQUIRED TO STORE THE FIELD
C                       WIDTHS AFTER THE REMOVAL OF IREF = IS5(37). 
C             ILENREF = REFERENCE FOR THE GROUP LENGTHS = IS5(38).
C             ILENINC = LENGTH INCREMENT FOR THE GROUP LENGTHS = IS5(42).
C            ITRUELEN = TRUE LENGTH OF THE LAST GROUP = IS5(43).
C             ILENBIT = FIELD WIDTH NEEDED TO STORE THE GROUP LENGTHS
C                       ONCE THE REFERENCE HAS BEEN REMOVED = IS5(47).
C             NUMBITS = NUMBER OF BITS TO UNPACK INFORMATION SPECIFIC
C                       TO SECOND ORDER DIFFERENCES SANS THE SIGN BIT
C                       = IS5(49)*8-1.
C               ISCAL = INDICATES COMBINATIONS OF SCALING.
C                       0 = NONE
C                       1 = DECIMAL ONLY
C                       2 = BINARY ONLY
C                       3 = BOTH DECIMAL AND BINARY
C              SCAL10 = THE DECIMAL SCALING FACTOR.
C               SCAL2 = THE BINARY SCALING FACTOR.
C               CLEAN = TRUE WHEN THE USER DOESN'T WANT MISSING VALUES
C                       IN THE UNPACKED DATA FIELD.  FALSE OTHERWISE.
C                       (LOGICAL)
C            MAXGPREF = THE MAXIMUM VALUE OF THE GROUP REFERENCES.
C
C        NON SYSTEM SUBROUTINES CALLED
C           UNBOUSTRO, UNPKBG, UNPKLX, UNPKCMBM, UNPKSECDIF, BOUNDARY
C
      LOGICAL BOUST, CLEAN
C
      PARAMETER (LXSIZE = 50000)
      DIMENSION A(ND2X3),IB(ND2X3)
      DIMENSION IPACK(ND5)
      DIMENSION IS5(NS5)
c      DIMENSION JMIN(IS5(32)),LBIT(IS5(32)),NOV(IS5(32))
      DIMENSION JMIN(LXSIZE),LBIT(LXSIZE),NOV(LXSIZE)
C        JMIN( ), LBIT( ), AND NOV( ) ARE AUTOMATIC ARRAYS.
C        FOR THIS TO WORK ON HP 755, IS5( ) MUST BE DECLARED FIRST.
C        IS5(32) = LX.
C
      IER=0
C
      N=L3264B
C
C        SET NXY EQUAL TO THE NUMBER OF GRID POINTS IN THE
C        GRID THAT WE ARE PROCESSING.
C
      NXY=NX*NY
C
C        CHECK TO MAKE SURE THAT THIS VALUE IS .LE. ND2X3.
C
      IF(NXY.GT.ND2X3)THEN
         IER=705
         GO TO 900
      ENDIF
c
c        check to make sure that LXSIZE is GE, IS5(32)
c
      IF(LXSIZE.LT.IS5(32))THEN
         IER=706
         GO TO 900
      ENDIF
C
C        RETRIEVE THE INFORMATION THAT IS PERTINENT
C        TO UNPACKING DATA THAT WAS PACKED USING THE
C        COMPLEX METHOD.
C
C        INTIALIZE THE SCALE FACTORS.
      ISCALED=IS5(18)
      ISCALEB=IS5(16)
C
C        INITIALIZE THE FIELD WIDTH THAT WAS USED TO PACK
C        THE GROUP REFERENCES.
      IWIDTH=IS5(20)
C
C        INITIALIZE THE USE OF EXPLICIT MISSING VALUES.
      IMISSING=IS5(23)
C
C        DETERMINE THE NUMBER OF GROUPS INTO WHICH
C        THE DATA WAS SPLIT.
      LX=IS5(32)
C
C        DETERMINE THE REFERENCE FOR THE FIELD WIDTHS (IN BITS)
C        USED TO STORE THE VALUES IN THE GROUPS. 
      IREF=IS5(36)
C
C        DETERMINE THE NUMBER OF BITS REQUIRED
C        TO STORE THE FIELD WIDTHS AFTER THE REMOVAL
C        OF THE ABOVE REFERENCE VALUE. 
      IREFBIT=IS5(37)
      MAXGPREF=2**IWIDTH-1
C        MAXBIT IS THE MAXIMUM NUMBER THAT CAN BE STORED
C        IN LBIT( ).
C
C        DETERMINE THE REFERENCE FOR THE GROUP LENGTHS.
      ILENREF=IS5(38)
C
C        DETERMINE THE LENGTH INCREMENT FOR THE GROUP 
C        LENGTHS.
      ILENINC=IS5(42)
C
C        DETERMINING THE TRUE LENGTH OF THE LAST GROUP.
      ITRUELEN=IS5(43)
C
C        DETERMINE THE FIELD WIDTH NEEDED TO STORE THE
C        GROUP LENGTHS ONCE THE ABOVE REFERENCE HAS BEEN
C        REMOVED.
      ILENBIT=IS5(47)
C
C        IF SECOND ORDER DIFFERENCES WERE DONE, THEN
C        UNPACK THE INFORMATION SPECIFIC TO SECOND
C        ORDER DIFFERENCES.
C
      IF(IS5(10).EQ.3)THEN
         NUMBITS=(IS5(49)*8)-1
         CALL UNPKBG(KFILDO,IPACK,ND5,LOCN,IPOS,ISIGN,1,N,IER,*900)
         CALL UNPKBG(KFILDO,IPACK,ND5,LOCN,IPOS,IFIRST,NUMBITS,N,
     1               IER,*900)
         IF(ISIGN.EQ.1)IFIRST=(-1)*IFIRST
         CALL UNPKBG(KFILDO,IPACK,ND5,LOCN,IPOS,ISIGN,1,N,IER,*900)
         CALL UNPKBG(KFILDO,IPACK,ND5,LOCN,IPOS,ISECOND,NUMBITS,N,
     1               IER,*900)
         IF(ISIGN.EQ.1)ISECOND=(-1)*ISECOND
         CALL UNPKBG(KFILDO,IPACK,ND5,LOCN,IPOS,ISIGN,1,N,IER,*900)
         CALL UNPKBG(KFILDO,IPACK,ND5,LOCN,IPOS,ISECMIN,NUMBITS,N,
     1               IER,*900)
         IF(ISIGN.EQ.1)ISECMIN=(-1)*ISECMIN
      ENDIF 
C
C***      WRITE(KFILDO,994)ILENREF,ILENINC,ITRUELEN,ILENBIT,
C***     1      NUMBITS,IFIRST,ISECOND,ISECMIN,LOCN,IPOS
C*** 994  FORMAT(/' UNPK_CMPLX AT 994--ILENREF,ILENINC,ITRUELEN,ILENBIT,
C***     1      NUMBITS,IFIRST,ISECOND,ISECMIN,LOCN,IPOS'/10I10)
C***      WRITE(KFILDO,990)(IS5(J),J=32,49)
C*** 990  FORMAT(/' AT 990 IN UNPK_CMPLX--(IS5(J),J=32,49)',
C***     1         (/20I6))
C
C        UNPACK THE REFERENCE VALUES OF THE GROUPS.
      CALL UNPKLX(KFILDO,IPACK,ND5,LOCN,IPOS,JMIN,LX,IWIDTH,N,IER,*900)
      CALL BOUNDARY(IPOS,LOCN)
C
C***      WRITE(KFILDO,995)(JMIN(J),J=1,200)
C*** 995  FORMAT(/' UNPK_CMPLX AT 995--(JMIN(J),J=1,200)'/(20I6))
C
C        UNPACK THE WIDTH INCREMENTS OF THE DATA FIELD.
      CALL UNPKLX(KFILDO,IPACK,ND5,LOCN,IPOS,LBIT,LX,IREFBIT,N,IER,*900)
      CALL BOUNDARY(IPOS,LOCN)
C
C***      WRITE(KFILDO,996)(LBIT(J),J=1,200)
C*** 996  FORMAT(/' UNPK_CMPLX AT 996--(LBIT(J),J=1,200)'/(20I6))
C
C        ADD THE REFERENCE TO ALL OF THE GROUP WIDTHS
C
      IF(IREF.NE.0)THEN
         DO K=1,LX
            LBIT(K)=LBIT(K)+IREF
         ENDDO
      ENDIF
C
C***      WRITE(KFILDO,997)IREF,(LBIT(J),J=1,200)
C*** 997  FORMAT(/' UNPK_CMPLX AT 997--IREF,(LBIT(J),J=1,200)',I4/(20I6))
C
C        UNPACK THE LENGTHS OF THE GROUPS
      CALL UNPKLX(KFILDO,IPACK,ND5,LOCN,IPOS,NOV,LX,ILENBIT,N,IER,*900)
      CALL BOUNDARY(IPOS,LOCN)
C
C***      WRITE(KFILDO,998)(NOV(J),J=1,1200)
C*** 998  FORMAT(/' UNPK_CMPLX AT 998--(NOV(J),J=1,1200)'/(20I6))
C
C        ADD THE REFERENCE GROUP LENGTH TO ALL OF THE GROUP LENGTHS
C        EXCEPT FOR THE LAST GROUP.  THE ACTUAL LENGTH OF THE LAST
C        GROUP IS KNOWN.
C
      IF((ILENREF.NE.0).OR.(ILENINC.GT.1))THEN
         DO K=1,(LX-1)
            NOV(K)=(NOV(K)*ILENINC)+ILENREF
         ENDDO
      ENDIF
C
C***      WRITE(KFILDO,999)(NOV(J),J=1,200)
C*** 999  FORMAT(/' UNPK_CMPLX AT 999--(NOV(J),J=1,200)'/(20I6))
C
      NOV(LX)=ITRUELEN
C
C        DEFINE ISCAL AND COMPUTE SCAL10 AND SCAL2.
C
      IF(ISCALED.EQ.0.AND.ISCALEB.EQ.0)THEN
         ISCAL=0
         SCAL10=1.
         SCAL2=1.
      ELSEIF(ISCALED.NE.0.AND.ISCALEB.EQ.0)THEN
         ISCAL=1
         SCAL10=10.**ISCALED
         SCAL2=1.
      ELSEIF(ISCALED.EQ.0.AND.ISCALEB.NE.0)THEN
         ISCAL=2
         SCAL10=1.
         SCAL2=2.**ISCALEB
      ELSEIF(ISCALED.NE.0.AND.ISCALEB.NE.0)THEN
         ISCAL=3
         SCAL10=10.**ISCALED
         SCAL2=2.**ISCALEB
      ENDIF
C
C        SET CLEAN.
C
      IF(IUNPKOPT.EQ.3)THEN
         CLEAN=.FALSE.
      ELSE
         CLEAN=.TRUE.
      ENDIF
C
C        UNPACK THE SECOND ORDER PACKED VALUES.
C        DEPENDING ON THE METHOD USED TO PACK THE DATA
C        CALL THE APPROPRIATE ROUTINE.
C
      IF(IS5(10).EQ.3)THEN
C
C           COMPLEX PACKING WITH SPATIAL DIFFERENCING
C           WAS USED.
         CALL UNPKSECDIF(KFILDO,A,ND2X3,JMIN,LBIT,NOV,LX,NX,NY,
     1                   IPACK,ND5,IFIRST,ISECOND,ISECMIN,REF,
     2                   LOCN,IPOS,MAXGPREF,IMISSING,XMISSP,XMISSS,
     3                   ISCAL,SCAL10,SCAL2,L3264B,IER)
      ELSE
C
C           COMPLEX PACKING WITHOUT SPATIAL DIFFERENCING
C           WAS USED.
         CALL UNPKCMBM(KFILDO,IPACK,ND5,LOCN,IPOS,A,IB,NXY,LBIT,
     1                 JMIN,NOV,LX,MAXGPREF,IMISSING,XMISSP,XMISSS,
     2                 REF,IBITMAP,SCAL10,SCAL2,CLEAN,L3264B,IER)
      ENDIF
C
      IF(IER.NE.0)GO TO 900
C
C        MAKE SURE THAT WE ARE POINTING TO A BYTE BOUNDARY.
C
      IFILL=MOD(33-IPOS,8)
C
      IF (IFILL.NE.0) THEN
         IPOS=IPOS+IFILL
C
         IF(IPOS.GT.32) THEN
           IPOS=1
           LOCN=LOCN+1
         END IF
C
      END IF
C
C        CHECK TO SEE IF THE DATA WAS SCANNED BOUSTROPHEDONICALLY
C        BEFORE IT WAS PACKED. IF IT WAS, THEN REARRANGE THE ROWS 
C        IN THE CORRECT ORDER TO RETURN THE DATA FIELD TO
C        ITS ORIGINAL STATE.
C
      IF(BOUST)THEN
         CALL UNBOUSTRO(A,NX,NY)
      ENDIF
C
 900  IF(IER.NE.0)RETURN 1
      RETURN
      END

      SUBROUTINE UNPK_SECT5(KFILDO,IPACK,ND5,IS5,NS5,L3264B,
     1                      LOCN,IPOS,REF,XMISSP,XMISSS,
     2                      IER,ISEVERE,*)
C
C        MARCH    2000   LAWRENCE  GSC/TDL    ORIGINAL CODING
C        JANUARY  2001   GLAHN     COMMENTS; CHANGED IER = 18 TO 508;
C                                  OMITTED EXISTS FROM CALL SEQUENCE;
C                                  ADDED IER = 501; ADDED TEST FOR
C                                  SECTION LENGTH
C        FEBRUARY 2001   GLAHN     CHECKED SIZE OF NS5; COMMENTS;
C                                  OMITTED UNPAKCING NONSTANDARD
C                                  INTEGER REFERENCE VALUE
C        NOVEMBER 2001   GLAHN     MOVED ISEVERE=2 TO TOP; INSERTED
C                                  IER=509
C
C        PURPOSE
C            UNPACKS SECTION 5, THE DATA REPRESENTATION SECTION, OF
C            A GRIB2 MESSAGE.
C
C        DATA SET USE
C           KFILDO - UNIT NUMBER FOR OUTPUT (PRINT) FILE. (OUTPUT
C                    FILE)
C
C        VARIABLES
C              KFILDO = UNIT NUMBER FOR OUTPUT (PRINT) FILE. (INPUT)
C            IPACK(J) = THE ARRAY THAT HOLDS THE ACTUAL PACKED MESSAGE
C                       (J=1,ND5). (INPUT/OUTPUT)
C                 ND5 = THE SIZE OF THE ARRAY IPACK( ). (INPUT)
C              IS5(J) = THE DATA REPRESENTATION DATA THAT ARE UNPACKED FROM
C                       IPACK( ) ARE PLACED INTO THIS ARRAY (J=1,NS5).
C                       (OUTPUT)
C                 NS5 = SIZE OF IS5( ). (INPUT)
C              L3264B = THE INTEGER WORD LENGTH IN BITS OF THE MACHINE
C                       BEING USED. VALUES OF 32 AND 64 ARE
C                       ACCOMMODATED. (INPUT)
C                LOCN = THE WORD POSITION FROM WHICH TO UNPACK THE
C                       NEXT VALUE. (INPUT/OUTPUT)
C                IPOS = THE BIT POSITION IN LOCN FROM WHICH TO START
C                       UNPACKING THE NEXT VALUE.  (INPUT/OUTPUT)
C                 REF = THE REFERENCE VALUE OF THE FIELD WHEN
C                       THE DATA FIELD IS FLOATING POINT. (OUTPUT)
C              XMISSP = THE PRIMARY MISSING VALUE REPRESENTATION. 
C                       (INPUT/OUTPUT)
C              XMISSS = THE SECONDARY MISSING VALUE REPRESENTATION.
C                       (INPUT/OUTPUT)
C                 IER = RETURN STATUS CODE. (OUTPUT)
C                         0 = GOOD RETURN.
C                       6-8 = ERROR CODES GENERATED BY UNPKBG. SEE THE
C                             DOCUMENTATION IN THE PKBG ROUTINE.
C                       501 = IS5(5) DOES NOT INDICATE SECTION 5.
C                       502 = IS5( ) HAS NOT BEEN DIMENSIONED LARGE
C                             ENOUGH TO CONTAIN THE TEMPLATE.
C                       508 = UNRECOGNIZED TYPE OF PACKING IN IS5(10).
C                       509 = UNRECOGNIZED TYPE OF DATA IN IS5(21). 
C                       599 = UNEXPECTED END OF MESSAGE.
C             ISEVERE = THE SEVERITY LEVEL OF THE ERROR.  THE ONLY
C                       VALUE RETUNED IS:
C                       2 = A FATAL ERROR  (OUTPUT)
C                   * = ALTERNATE RETURN WHEN IER NE 0.
C
C             LOCAL VARIABLES
C             LOCN5_1 = SAVES THE WORD POSITION LOCN IN IPACK
C                       UPON ENTRY TO STORE BACK TO LOCN IN CASE
C                       THERE IS A FATAL ERROR.
C             IPOS5_1 = SAVES THE BIT POSITION IPOS IN LOCN
C                       UPON ENTRY TO STORE BACK TO IPOS IN CASE
C                       THERE IS A FATAL ERROR.
C               LSECT = CONTAINS THE LENGTH OF SECTION 5
C                       AS UNPACKED FROM THE FIRST FOUR
C                       BYTES IN THE SECTION.
C               NSECT = SECTION NUMBER.
C             IEEEREF = THE INTEGER EQUIVALENCE OF THE 'IEEE'
C                       REAL NUMBER CONTAINED IN RVALUE.
C                IREF = THE REFERENCE VALUE OF THE FIELD WHEN
C                       THE DATA FIELD IS INTEGER.
C                   K = A LOOPING INDEX VARIABLE.
C                   N = L3264B = THE INTEGER WORD LENGTH IN BITS OF
C                       THE MACHINE BEING USED. VALUES OF 32 AND
C                       64 ARE ACCOMMODATED.
C              RVALUE = CONTAINS AN 'IEEE' REAL NUMBER.
C               ISIGN = SIGN OF VALUE BEING UNPACKED, 0 = POSITIVE,
C                       1 = NEGATIVE.  THE SIGN ALWAYS GOES IN THE
C                       LEFTMOST BIT OF THE AREA ASSIGNED TO THAT VALUE.
C
C        NON SYSTEM SUBROUTINES CALLED
C           ENDOMESS, RDIEEE, UNPKBG
C
      LOGICAL ENDOMESS
C
      DIMENSION IPACK(ND5),IS5(NS5)
C
      EQUIVALENCE (RVALUE,IEEEREF)
C
      N=L3264B
      IER=0
C
C        ALL ERRORS GENERATED BY THIS ROUTINE ARE FATAL.
      ISEVERE=2
C
C        CHECK SIZE OF IS5( ).
C
      IF(NS5.LT.21)THEN
C           NS5 IS THE SIZE FOR TEMPLATE 5.0 (SIMPLE PACKING)
C           WHICH IS CONTAINED IN ALL OTHER DEFINED TEMPLATES.
         IER=502
         GO TO 900
      ENDIF
C
      LOCN5_1=LOCN
      IPOS5_1=IPOS
c
C        UNPACK THE LENGTH OF THE SECTION, LSECT.
      CALL UNPKBG(KFILDO,IPACK,ND5,LOCN,IPOS,LSECT,32,N,IER,*900)
C
C        CHECK FOR AN UNEXPECTED END OF MESSAGE,
C        ACCOMMODATING FOR A 64-BIT WORD.
      IF(ENDOMESS(LSECT,N))THEN
         IER=599
         GO TO 900
      ENDIF
C
C        UNPACK THE NUMBER OF THE SECTION, NSECT. CHECK
C        TO MAKE SURE THAT THIS IS SECTION 5.
      CALL UNPKBG(KFILDO,IPACK,ND5,LOCN,IPOS,NSECT,8,N,IER,*900)
C
      IF(NSECT.NE.5)THEN
         IER=501
         LOCN=LOCN5_1
         IPOS=IPOS5_1
         GO TO 900
      ENDIF
C
      DO K=1,NS5
         IS5(K)=0
      ENDDO
C
      IS5(1)=LSECT
      IS5(5)=NSECT
C
C        UNPACK THE NUMBER OF ACTUAL DATA POINTS WHERE
C        ONE OR MORE VALUES ARE SPECIFIED IN SECTION 7.
      CALL UNPKBG(KFILDO,IPACK,ND5,LOCN,IPOS,IS5(6),32,N,IER,*900)
C
C        UNPACK THE DATA REPRESENTATION TEMPLATE NUMBER.
C
      CALL UNPKBG(KFILDO,IPACK,ND5,LOCN,IPOS,IS5(10),16,N,IER,*900)
C
      CALL UNPKBG(KFILDO,IPACK,ND5,LOCN,IPOS,IEEEREF,32,N,IER,*900)
C        THE REFERENCE VALUE IS ALWAYS PACKED AS FLOATING POINT.
C        RVALUE AND IEEEREF ARE EQIVALENCED.

      REF=RDIEEE(RVALUE)
      IS5(12)=INT(REF)
C
C        UNPACK THE BINARY AND DECIMAL SCALE FACTORS,
C        TAKING INTO ACCOUNT THAT THEY MAY BE NEGATIVE.
      CALL UNPKBG(KFILDO,IPACK,ND5,LOCN,IPOS,ISIGN,1,N,IER,*900)
      CALL UNPKBG(KFILDO,IPACK,ND5,LOCN,IPOS,IS5(16),15,N,IER,*900)
      IF(ISIGN.EQ.1)IS5(16)=-IS5(16)
      CALL UNPKBG(KFILDO,IPACK,ND5,LOCN,IPOS,ISIGN,1,N,IER,*900)
      CALL UNPKBG(KFILDO,IPACK,ND5,LOCN,IPOS,IS5(18),15,N,IER,*900)
      IF(ISIGN.EQ.1)IS5(18)=-IS5(18)
C
C        UNPACK THE FIELD WIDTH OF THE PACKED VALUES.
      CALL UNPKBG(KFILDO,IPACK,ND5,LOCN,IPOS,IS5(20),8,N,IER,*900)
C
C        UNPACK THE TYPE OF ORIGINAL FIELD VALUES
      CALL UNPKBG(KFILDO,IPACK,ND5,LOCN,IPOS,IS5(21),8,N,IER,*900)
C
C        UNPACK THE REMAINDER OF SECTION 5 DEPENDING ON
C        WHICH PACKING METHOD WAS USED TO ORIGINALLY
C        PACK THE DATA.
C
      IF(IS5(10).EQ.1)THEN
C
C           CHECK SIZE OF IS5( ) FOR MATRIX OF VALUES.
C
         IF(NS5.LT.36)THEN
            IER=502
            GO TO 900
         ENDIF
C
C           SIMPLE PACKING - MATRIX VALUES AT A GRID POINT
C
         CALL UNPKBG(KFILDO,IPACK,ND5,LOCN,IPOS,IS5(22),8,N,IER,*900)
         CALL UNPKBG(KFILDO,IPACK,ND5,LOCN,IPOS,IS5(23),32,N,IER,*900)
         CALL UNPKBG(KFILDO,IPACK,ND5,LOCN,IPOS,IS5(27),16,N,IER,*900)
         CALL UNPKBG(KFILDO,IPACK,ND5,LOCN,IPOS,IS5(29),16,N,IER,*900)
         CALL UNPKBG(KFILDO,IPACK,ND5,LOCN,IPOS,IS5(31),8,N,IER,*900)
         CALL UNPKBG(KFILDO,IPACK,ND5,LOCN,IPOS,IS5(32),8,N,IER,*900)
         CALL UNPKBG(KFILDO,IPACK,ND5,LOCN,IPOS,IS5(33),8,N,IER,*900)
         CALL UNPKBG(KFILDO,IPACK,ND5,LOCN,IPOS,IS5(34),8,N,IER,*900)
         CALL UNPKBG(KFILDO,IPACK,ND5,LOCN,IPOS,IS5(35),8,N,IER,*900)
         CALL UNPKBG(KFILDO,IPACK,ND5,LOCN,IPOS,IS5(36),8,N,IER,*900)
C
C           CHECK SIZE OF IS5( ) FOR MATRIX OF VALUES.
C
         IF(NS5.LT.37+IS5(32)*4+(4*(IS5(32)+IS5(34))))THEN
            IER=502
            GO TO 900
         ENDIF
C
         DO L=37,36+(IS5(32)*4),4
            CALL UNPKBG(KFILDO,IPACK,ND5,LOCN,IPOS,IS5(L),32,N,IER,*900)
         ENDDO
C
         DO L=37+IS5(32)*4,37+IS5(32)*4+(4*(IS5(32)+IS5(34))),4
            CALL UNPKBG(KFILDO,IPACK,ND5,LOCN,IPOS,IS5(L),32,N,IER,*900)
         ENDDO
C
C        CHECK FOR GRIDPOINT DATA.
C
      ELSE IF((IS5(10).EQ.2).OR.(IS5(10).EQ.3))THEN
C     
C           CHECK FOR SIZE OF IS5( ).
C   
         IF(IS5(10).EQ.2)THEN
C          
            IF(NS5.LT.47)THEN
               IER=502
               GO TO 900
            ENDIF
C
         ELSE
            IF(ND5.LT.49)THEN
               IER=502
               GO TO 900
            ENDIF
C
         ENDIF  
C
C           COMPLEX PACKING WITH OR WITHOUT SPATIAL DIFFERENCING
C           IS TO BE USED
C
         CALL UNPKBG(KFILDO,IPACK,ND5,LOCN,IPOS,IS5(22),8,N,IER,*900)
         CALL UNPKBG(KFILDO,IPACK,ND5,LOCN,IPOS,IS5(23),8,N,IER,*900)
C
C           UNPACK THE PRIMARY AND SECONDARY MISSING VALUE SUBSTITUTES.
C           HOW THESE VALUES WERE PACKED DEPENDS ON THE TYPE OF
C           THE DATA FIELD.
C
         IF(IS5(21).EQ.0)THEN
C
C              THE DATA FIELD WAS PACKED AS FLOATING POINT.
            CALL UNPKBG(KFILDO,IPACK,ND5,LOCN,IPOS,IEEEREF,32,N,
     1                  IER,*900)
            XMISSP=RDIEEE(RVALUE)
C
            CALL UNPKBG(KFILDO,IPACK,ND5,LOCN,IPOS,IEEEREF,32,N,
     1                  IER,*900)
            XMISSS=RDIEEE(RVALUE)
C
            IS5(24)=INT(XMISSP)
            IS5(28)=INT(XMISSS)
         ELSEIF(IS5(21).EQ.1)THEN
C              
C              THE DATA FIELD WAS PACKED AS INTEGER.
            CALL UNPKBG(KFILDO,IPACK,ND5,LOCN,IPOS,JSIGN,1,N,IER,*900)
            CALL UNPKBG(KFILDO,IPACK,ND5,LOCN,IPOS,MISSP,31,N,IER,*900)
            IF(JSIGN.EQ.1)MISSP=-MISSP
            CALL UNPKBG(KFILDO,IPACK,ND5,LOCN,IPOS,JSIGN,1,N,IER,*900)
            CALL UNPKBG(KFILDO,IPACK,ND5,LOCN,IPOS,MISSS,31,N,IER,*900)
            IF(JSIGN.EQ.1)MISSS=-MISSS
            IS5(24)=MISSP
            IS5(28)=MISSS
            XMISSP=FLOAT(MISSP)
            XMISSS=FLOAT(MISSS)
         ELSE
            IER=509
C              UNRECOGNIZED TYPE OF DATA.
            GO TO 900
         ENDIF
C
         CALL UNPKBG(KFILDO,IPACK,ND5,LOCN,IPOS,IS5(32),32,N,IER,*900)
         CALL UNPKBG(KFILDO,IPACK,ND5,LOCN,IPOS,IS5(36),8,N,IER,*900)
         CALL UNPKBG(KFILDO,IPACK,ND5,LOCN,IPOS,IS5(37),8,N,IER,*900)
         CALL UNPKBG(KFILDO,IPACK,ND5,LOCN,IPOS,IS5(38),32,N,IER,*900)
         CALL UNPKBG(KFILDO,IPACK,ND5,LOCN,IPOS,IS5(42),8,N,IER,*900)
         CALL UNPKBG(KFILDO,IPACK,ND5,LOCN,IPOS,IS5(43),32,N,IER,*900)
         CALL UNPKBG(KFILDO,IPACK,ND5,LOCN,IPOS,IS5(47),8,N,IER,*900)
C
         IF(IS5(10).EQ.3)THEN
C
C              SECOND ORDER SPATIAL DIFFERENCES
C              WE NEED TO UNPACK THE ORDER OF THE SPATIAL DIFFERENCES
C              AND THE NUMBER OF OCTETS THAT THE FIRST AND SECOND
C              ORIGINAL VALUES AND THE MINIMUM OF THE FIELD OF SECOND
C              ORDER DIFFERENCES ARE PACKED IN.
            CALL UNPKBG(KFILDO,IPACK,ND5,LOCN,IPOS,IS5(48),8,N,
     1                  IER,*900)
            CALL UNPKBG(KFILDO,IPACK,ND5,LOCN,IPOS,IS5(49),8,N,
     1                  IER,*900)
         ENDIF
C
      ELSE IF(IS5(10).NE.0) THEN
         IER = 508
C           THE METHOD OF UNPACKING IS NOT SUPPORTED.  NOTE THAT
C           IS5(10) = 0 FOR SIMPLE PACKING DOES NOT REQUIRE ANY MORE
C           UNPACKING HERE.
      ENDIF
C
C        ERROR RETURN SECTION
C
 900  IF(IER.NE.0)RETURN 1
C
      RETURN
      END

      SUBROUTINE IERX(KFILDO,IP1,IOS,RUTINE,STATMT) 
C 
C        JANUARY 1994   GLAHN   TDL  MOS-2000
C        APRIL   2000   DALLAVALLE   MODIFIED FORMAT STATEMENTS TO
C                                    CONFORM TO FORTRAN 90 STANDARDS
C                                    ON THE IBM SP
C 
C        PURPOSE 
C            TO HANDLE AN ERROR INDICATED BY A SYSTEM SUBROUTINE, USUALLY 
C            AN I/O OPERATION.  DIAGNOSTIC IS WRITTEN TO UNIT NUMBER KFILDO.
C            WHEN IP1 NE KFILDO, THE DIAGNOSTIS IS ALSO WRITTEN TO UNIT
C            NUMBER IP1.
C 
C        DATA SET USE 
C            KFILDO - DEFAULT UNIT NUMBER FOR OUTPUT (PRINT) FILE.  (OUTPUT)
C            IP1    - UNIT NUMBER FOR OUTPUT (PRINT) FILE.  (OUTPUT)   
C 
C        VARIABLES 
C 
C          INPUT 
C              KFILDO = DEFAULT UNIT NUMBER FOR OUTPUT (PRINT) FILE.
C                 IP1 = UNIT NUMBER FOR OUTPUT (PRINT) FILE. 
C                 IOS = INPUT/OUTPUT STATUS.
C              RUTINE = NAME OF CALLING SUBROUTINE. 
C                       MAXIMUM OF 6 CHARACTERS PRINTED.
C                       (CHARACTER*(*))
C              STATMT = STATEMENT NUMBER IN CALLING PROGRAM NEAR CALL 
C                       TO IERX.  MAXIMUM OF 4 CHARACTERS PRINTED.
C                       (CHARACTER*(*))
C 
C        NONSYSTEM SUBROUINES USED 
C            NONE. 
C 
      CHARACTER*(*) RUTINE,STATMT
C 
      WRITE(KFILDO,100)IOS,RUTINE,STATMT 
      IF(IP1.NE.KFILDO)WRITE(IP1,100)IOS,RUTINE,STATMT 
 100  FORMAT(/,' ****SYSTEM STATUS CODE ERROR =',I5, 
     1         ' IN ROUTINE ',A6,' NEAR ',A4) 
      RETURN
      END 
